/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.frm;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Properties;

/**
 * @author Yehuda
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MessageHandler {

	private static Hashtable frmFileHash = new Hashtable(3);
	private static String m_frmPath = new String();
	
	public static void setFrmPath(String frmPath){
		m_frmPath = frmPath;
	}
	
	public static String getMessage(String frmFileName,String messageID){
		
		String message = new String();
		
		Properties frmProp = (Properties)frmFileHash.get(frmFileName);
	
		if (frmProp == null) {
			frmProp = new Properties();
			FileInputStream fileInputStream;
			try {
				fileInputStream = new FileInputStream(m_frmPath + frmFileName);
				frmProp.load(fileInputStream);
			} 
			catch (FileNotFoundException e) {
				return frmFileName + " not found";
			}
			catch (IOException e) {
				return "IO Error getting message file name = " + frmFileName + " id = " + messageID;
			} 
			
			frmFileHash.put(frmFileName, frmProp);
		}
		
		message = frmProp.getProperty(messageID);
		
		if(message == null){
			message = "Message not found, file name = " + frmFileName + " id = " + messageID;
		}
		
		return message;		
	}

/*
	public static String getMessage(String frmFileName,String messageID)
													throws FileNotFoundException, IOException {
			
		Properties frmFileProp = (Properties)frmFileHash.get(frmFileName);
	
		if (frmFileProp == null) {	
			frmFileProp = new Properties();
			frmFileProp.load(new FileInputStream(m_frmPath + frmFileName));
			frmFileHash.put(frmFileName, frmFileProp);
		}
		
		return frmFileProp.getProperty(messageID);		
	}
*/

	public static void main(String[] args) {
		MessageHandler.setFrmPath("v:\\frm\\");
		System.out.println(MessageHandler.getMessage("webwatch.frm","10"));
		System.out.println(MessageHandler.getMessage("webwatch.frm","20"));
	}
}
