/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.testtalk;

// class which include the structure of message and a few method to
// convert from that class to class which is used for writing/reading
// from the socket in the low level (PackedBuf).
class MessageC {

    protected String FromHost;   // include <host>:<port>
    protected String FromClient;
    protected String ToHost;     // include <host>:<port>
    protected String ToClient;
    protected byte   QueueType;
    protected short  Type;
    protected short  SubType;
    protected String Data;

    // conversion to PackedBuf
    protected PackedBufC ToPackedBuf() {

        PackedBufC PackedBuf = new PackedBufC();

        // copy Type & SubType
        PackedBuf.Type = Type;
        PackedBuf.SubType = SubType;

        String QueueTypeCh = "" + QueueType;

        PackedBuf.Data = "" + 6 + " " +
                         (ToHost.length() + 1)      + " " +
                         (ToClient.length() + 1)    + " " +
                         (FromHost.length() + 1)    + " " +
                         (FromClient.length() + 1)  + " " +
                         (QueueTypeCh.length() + 1) + " " +
                         (Data.length() + 1)        + " " +
                         ToHost + TestTalkConstants.C_NULL_TERMINATOR +
                         ToClient + TestTalkConstants.C_NULL_TERMINATOR +
                         FromHost + TestTalkConstants.C_NULL_TERMINATOR +
                         FromClient + TestTalkConstants.C_NULL_TERMINATOR +
                         QueueTypeCh + TestTalkConstants.C_NULL_TERMINATOR +
                         Data + TestTalkConstants.C_NULL_TERMINATOR;

        return PackedBuf;
    }

    // conversion from PackedBuf
    protected void FromPackedBuf(PackedBufC PackedBuf) {
        // copy Type & SubType
        Type = PackedBuf.Type;
        SubType = PackedBuf.SubType;

        // copy the rest fields

        // get no of fields packed in data
        int IndexOfBlank = (PackedBuf.Data).indexOf(" ");
        String FieldsNoChar = (PackedBuf.Data).
                                    substring(0,IndexOfBlank);
        int FieldsNo = Integer.parseInt(FieldsNoChar);

        // fetch fields length from data
        int FromIndex = IndexOfBlank + 1;
        int FieldsLength[] = new int[FieldsNo];
        String FieldLengthChar;
        for (int i = 0; i < FieldsNo; i++) {
            IndexOfBlank = (PackedBuf.Data).indexOf(" ",FromIndex);
            FieldLengthChar = (PackedBuf.Data).
                                    substring(FromIndex,IndexOfBlank);
            FieldsLength[i] = Integer.parseInt(FieldLengthChar);
            FromIndex = IndexOfBlank + 1;
        }

        // fetch fields values from data
        ToHost = (PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[0]-1);
        FromIndex = FromIndex + FieldsLength[0];
        ToClient = (PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[1]-1);
        FromIndex = FromIndex + FieldsLength[1];
        FromHost = (PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[2]-1);
        FromIndex = FromIndex + FieldsLength[2];
        FromClient = (PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[3]-1);
        FromIndex = FromIndex + FieldsLength[3];
        QueueType = (byte)Integer.parseInt((PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[4]-1));
        FromIndex = FromIndex + FieldsLength[4];
        if (FieldsLength[5] == 1)   // it means empty field just C_NULL
            Data = "";
        else
            Data = (PackedBuf.Data).
                    substring(FromIndex,FromIndex+FieldsLength[5]-1);
    }

}
