/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.testtalk;

import com.radview.util.datastructures.*;


/**
 * Class SyncNetKernelMessageHandler extends NetKernelMessageHandler
 * This class doesn't have threads for sending and geting messages
 * it supplies a way to create a testtalk client and to send and get
 * messages in a synchronized way.
 **/
public class SyncNetKernelMessageHandler extends NetKernelMessageHandler
{
	public SyncNetKernelMessageHandler()
	{
		super("test");
	}

	public SyncNetKernelMessageHandler(String baseName)
	{
		super(baseName);
	}

	public void init() throws ErrorLocatingLocalHostAddressException,
                           	  CouldNotListenOnPortException
	{
		init(0, true);
	}

	public void init(int port) throws ErrorLocatingLocalHostAddressException,
                           			  CouldNotListenOnPortException
	{
		init(port, true);
	}

	public AssociativeArrayC getMessage() throws IllegalAssoSyntaxException
	{
		String buffer = testtalkClient.NetWaitMessage();

		if(buffer != null) {
			AssociativeArrayC message = new AssociativeArrayC();

			message.FromString(buffer);
			return message;
		}

		return null;
	}

	public void messageHandler(AssociativeArrayC message)
	{
		// Default implementation, does nothing
	}
}
