/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// wljavautils.cpp : Defines the entry point for the DLL application.
//

#include "com_radview_wlutil_java2trace.h"
#include "com_radview_wlutil_tvenv.h"
#include "tracedll.h"
#include "wljavautils.h"

#ifdef __TV_WINDOWS__

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

#endif // __TV_WINDOWS__

/* Manually load the required native methods. */
bool DllExport InitJavautilsJNI(JNIEnv* env)
{
  jclass jcJava2Trace = env->FindClass("com/radview/wlutil/Java2Trace");

  static JNINativeMethod nativeMethods[] = {
    {"Message", "(Ljava/lang/String;)V", (void*)&Java_com_radview_wlutil_Java2Trace_Message},
  };

  env->RegisterNatives(jcJava2Trace, nativeMethods, sizeof(nativeMethods) / sizeof(JNINativeMethod));
  if (env->ExceptionOccurred()) {
    //
    // report the error @@Yahali
    env->ExceptionDescribe();
    env->ExceptionClear();
    WlAssert(0);
    //return false;
  }

  jclass jcTVEnv = env->FindClass("com/radview/wlutil/TVEnv");

  static JNINativeMethod nativeMethods2[] = {
    {"getTVEnvVar", "(Ljava/lang/String;)Ljava/lang/String;", (void*)&Java_com_radview_wlutil_TVEnv_getTVEnvVar},
  };

  env->RegisterNatives(jcTVEnv, nativeMethods2, sizeof(nativeMethods2) / sizeof(JNINativeMethod));
  if (env->ExceptionOccurred()) {
    //
    // report the error @@Yahali
    env->ExceptionDescribe();
    env->ExceptionClear();
    WlAssert(0);
    //return false;
  }

  return true;
}

