/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_ARRAY__
#define __WL_ARRAY__
#include <stdlib.h>
#include <collstr.h>
#include <colclass.h>
#include <ordered.h>
#include <collectable.h>
#include <ordered.h>
#include <RVCString.h>
#include "platform.h"
#include "wllightstring.h"
	  	



// ===============================CKVP=============================
class DllExport CKVP : public CWLCollectableString {
private:
  CWLLightString m_Value;

public:
  CKVP() {}
  CKVP(const char* aKey, const char* aValue);
  virtual ~CKVP(){}
	CKVP& operator=( CKVP&) ;
  const char* Key();
  const char* Value();
  void setKey     (const char* key_);
  void setValue   (const char* value_);
  
};


//==============================CWLARRAY============================
//! this class is meant to implement an associative array
class DllExport CWLArray : public RVOrdered
{
public:
  CWLArray() : RVOrdered(10) {}
  virtual ~CWLArray(); 
	CWLArray&				operator=(const CWLArray&);
  RVCollectable*  insertKeyAndValue(const char* aKey, const char* aValue);
  RVCollectable*  addKVP(CKVP* aKVP);
  void            removeAllKeysAndValues(const char* aKey);
  const char*     getAllValues(const char* aKey);
  const char*     Key(int i);
  const char*     Value(int i);
  const char*     Value(const char* aKey);
  void            print();
};


//==============================CWLSEARCHARRAY============================
class DllExport CWLSearchArray: public CWLArray {
private:
  RVCString m_URLEncoded;
	static bool m_ParseCharInitialize ;
	static char m_ParseChar[256][4];
private:
	void	ParseCharForHttp();
	RVCString& ParseCharFunc(const char*, RVCString&);
public:
  CWLSearchArray(); 
  virtual ~CWLSearchArray() {}
	CWLSearchArray& operator=(const CWLSearchArray&);
  void PrintAllPairs();
  bool LoadURLEncodedString(const char* urlString);
  const char* GetURLEncodedString();	
	const char* retURLEncodedString() const{return m_URLEncoded.data();}	

// virtual void printAll();
};

#endif
