/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_FORM_LIST__
#define __WL_FORM_LIST__

#include <RVCString.h>
#include <ordered.h>
#include <hashdict.h>
#include <regexp.h>
#include "wlobjectcollection.h"
#include "platform.h"
#include "wlurlbase.h"
//#include "wlform.h"
#include "wlhtmlfuncs.h"
#include "wllocation.h"

class CWLDocument;
class CWLForm;

//==============================FORMLIST=========================
class DllExport formList:public CWLObjectCollection
{
private:
  CWLForm*			formPtr ;
  RVCString			buff;
  size_t				buffPtr;
  int						stateFlag;
  int						typeHref;
	bool					createNewForm;
private:
	CWLDocument*			m_DocPtr;

private:
  virtual RVCollectable *comparedObject(int index);
  /*virtual RVCollectable *comparedObject(int index)
  {
	  return ((CWLForm *)at(index))->Action_();
  }*/


public:
	formList() {}
	formList(CWLDocument* docPtr);

  virtual ~formList() { clearAndDestroy(); }
	formList& operator=(const formList&);
  elementReadState			parse(RVCString& buff, urlBase* urlBasePtr);
  void			printAll();
	CWLForm*	Form(const char* formName);
  int				findActionByIndex(size_t formIndex, CWLLocation** action_);
  int				findEntryByName(const char* ,const char**);
  int				findEntryByIndexAndName( size_t, const char*, const char**);
};
#endif

