/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_FRAME_LIST__
#define __WL_FRAME_LIST__

#include <RVCString.h>
#include <hashdict.h>
#include <regexp.h>
#include <ordered.h>
#include <slistcolque.h>
#include "platform.h"
#include "wllocation.h"
#include "wldocument.h"
#include "wlformlist.h"
#include "wlparseflags.h"
#include "wlidentlocation.h"
#include "wlobjectcollection.h"

class frameContainer;
class CWLDocument;
class CWLHtmlVirtualQueue;
class urlBase;

enum findFrameStatus {
  findFrameStatus_OK,
  findFrameStatus_ERROR,
  findFrameStatus_NAME_MATCH_NUMBER_MISMATCH_WARNING,
  findFrameStatus_NUMBER_MATCH_NAME_MISMATCH_WARNING
};
enum attStateFrame{
	ATT_NONE,
	ATT_SRC,
	ATT_NAME
};
//=========================PARSEFRAME==============================
class DllExport parseFrame:public  CWLObjectCollection
{
private:
  size_t						buffPtr;
  int							stateFlag;
  int							typeFrame;
  RVCString                     name;
  RVCString					buff;
	CWLUserParseFlags m_ParseFlags;
  bool							entityCount;
	attStateFrame			attFound;  
	frameContainer*		frameCont;
	CWLDocument*        m_DocPtr;
  
private:
  void  		extractUrl(RVCString& buff, RVCString& frameUrl, RVCString& frameName);
  int			findFrame(RVCString& buff);      //find a HREF
  RVCString&	getString(RVCString& str, RVCString& buff, size_t& strPtr)  ;
  int			findSpace(char& c);
  size_t		findSpaceIndex(RVCString& buff, int startUrlIndex);
  virtual RVCollectable *comparedObject(int index);

public:
	parseFrame(CWLDocument *docPtr) : m_DocPtr(docPtr) {}
	parseFrame(RVCString&, CWLUserParseFlags&, frameContainer*, CWLDocument *docPtr);
  virtual ~parseFrame();  
	parseFrame& operator=(parseFrame&);

  void printAll();    //! print the m_Links
	elementReadState parse(RVCString& buff, urlBase* urlBasePtr);
  int findEntryByUrlMatch(const char*, CWLDocument**);
  findFrameStatus	findEntryByLocationMatch(CWLIdentLocation& identLocation, CWLDocument*& retFrame);

	int  findEntryByFrameNameMatch(const char*, CWLDocument**);
  int  getNameByIndex(RVCString&, int, CWLDocument**);
	CWLDocument* frame(const char* frameName);
};

#endif
