/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_IDENT_LOCATION__
#define __WL_IDENT_LOCATION__

#include <RVCString.h>	
#include <ordered.h>
#include "platform.h"

#define NULL_IDENT_LOCATION_NUMBER -1

class DllExport CWLIdentLocation 
{
private:
  RVOrdered  m_Elements;
  RVCString  m_fullIdentLocation;
  int        m_ObjectIndex;
public:
  CWLIdentLocation ();
  CWLIdentLocation (const RVCString& strLocation);
  CWLIdentLocation (const CWLIdentLocation& IdentLocation);
  ~CWLIdentLocation();
  int appendLevel  (const int& Number, const RVCString& Name);
  int appendLevel  (const RVCString& Value);
  int prependLevel (const int& Number, const RVCString& Name);
  int prependLevel (const RVCString& Value);
  int Depth ();
  int getLevel (const int& Level, int& Number, RVCString& Name);
  RVCString getStr ();
  int getObjectIndex ();
  int setObjectIndex (const int& objectIndex);
  int setObjectIndex (const RVCString& objectIndex);
  int removeLevel (const int& Level);
  bool isEmpty ();
  CWLIdentLocation& operator+= (const CWLIdentLocation& IdentLocation);
  CWLIdentLocation& operator+= (const RVCString& strLocation);
  CWLIdentLocation& operator+  (const CWLIdentLocation& IdentLocation);
  CWLIdentLocation& operator+  (const RVCString& strLocation);
  CWLIdentLocation& operator=  (const CWLIdentLocation& IdentLocation);
  CWLIdentLocation& operator=  (const RVCString& strLocation);
  bool operator== (const CWLIdentLocation& IdentLocation);
  bool operator== (const RVCString& strLocation);
private:
  int constructFromStr (const RVCString& FromStr, bool Append);
  int constructFromElements();
  int findValues (const RVCString& FromStr, int& Number, RVCString& Name);
  int insertAt   (const int& Level, int& Number, RVCString& Name);
};

#endif
