/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_OBJECT_COLLECTION_H
#define __WL_OBJECT_COLLECTION_H

#include <collectable.h>
#include <ordered.h>
#include "platform.h"



//! This is a base class for object collections like links and forms
//! It support a generic ASM search
class DllExport CWLObjectCollection: public RVOrdered {
private:
	virtual RVCollectable *comparedObject(int index) = 0;

public:
	CWLObjectCollection() {}
	virtual ~CWLObjectCollection() {}

	virtual RVCollectable *unifyObject(RVCollectable *comp, int expectedIndex);
};



#endif

