/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_STYLE__
#define __WL_STYLE__
#include <collectable.h>
#include <ordered.h>
//#include "platform.h"
#include "wltransactiondata.h"
#include "wlurlbase.h"

class RWSCtring;
class CWLDocument;

class  DllExport CWLStyle:public RVCollectable{
public:
	RVOrdered m_Imports;
	
	CWLStyle(CWLDocument* docPtr); //! called from the html parser
	CWLStyle(CWLDocument* docPtr, CWLStyle* parentSS, RVCString& href); //! called from the css parser
	virtual ~CWLStyle(){ m_Imports.clearAndDestroy(); }

private:
	RVCString m_Id;
	RVCString m_Href;
	
	long m_Index;
	CWLDocument* m_DocPtr;
	urlBase		m_UrlBase;
    CWLTransactionsObject m_TransObj;
	CWLStyle* m_ParentStyleSheet;
	RVCString m_Buff;
	size_t m_BuffIndex;
	RVCString m_OriginalUrl;
	RVCString m_Referrer;

public:
//	void	    SetCssText(const char* cssText) { m_CssText = cssText; }
	void	    SetId(const char* id) { m_Id = id; }
	const char* GetCssText()    { return m_Buff.isNull() ? NULL : m_Buff.data(); }
	const char* GetInnerHTML()  { return m_Buff.isNull() ? NULL : m_Buff.data(); }
	size_t      GetTextLength() { return m_Buff.length(); }
	const char* GetId()         { return m_Id.isNull() ? NULL : m_Id.data(); }
	const char* GetHref()       { return m_Href.isNull() ? NULL : m_Href.data(); }
	void	    printAll();
	CWLTransactionsObject* GetTransactionObj(){return &m_TransObj;}

	RVCString& GetReferrer()    { return m_Referrer; }
	RVCString& GetOriginalUrl() { return m_OriginalUrl;  }
	long       GetIndex()       { return m_Index; }
	void parse(RVCString& newData, size_t dataSize, urlBase* urlBasePtr, size_t offset);

protected:
  int m_iUrlOffset;
public:
  void setUrlOffset(int uo) { m_iUrlOffset = uo; }
  int  getUrlOffset() { return m_iUrlOffset; }
};
#endif
