/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_URL_ARRAY__
#define __WL_URL_ARRAY__

#include <ordered.h>
#include <RVCString.h>
#include <hashdict.h>
#include <regexp.h>
#include "wlobjectcollection.h"
#include "wllocation.h"
#include "wlurl.h"
#include "platform.h"
#include "wlhtmlfuncs.h"

class urlBase;
class CWLDocument;
//=========================CWLURLARRAY=================================
class DllExport CWLLinkArray:public CWLObjectCollection
{
private:

  CWLDocument *m_DocPtr;
  RVCString url, name, target, id, innerHTML, origUrl;

  virtual RVCollectable *comparedObject(int index)
  {
	  return at(index);
  }

private:
  bool m_hrefAttFound;//! <indicates that it's not <a name...
	enum{
			FIND_ATT_VALUE,
			FIND_NAME_VALUE
  } stateFlag;


public:
  CWLLinkArray(CWLDocument *docPtr);
  virtual ~CWLLinkArray() {clearAndDestroy();}
  CWLLinkArray& operator=(const CWLLinkArray&);
  void		printAll();    //! print the hrefList
	elementReadState parse(RVCString& buff, anchorType type, urlBase* urlBasePtr);   //! all the work is here
  int			findEntryByName(const char* );
  int			findEntryByUrl(const char* );
  int			findEntryByInnerHTMLMatch(const char*,CWLLink**);
  int			findEntryByUrlMatch(const char*,CWLLink**);
  int			getUrlByIndex(int, CWLLink**);
  int			getNameByIndex(int, RVCString&);
};


//=========================CWLLINKARRAY=================================
class DllExport CWLCSSArray:public CWLObjectCollection
{
private:
  CWLDocument *m_DocPtr;

  virtual RVCollectable *comparedObject(int index)
  {
	  return at(index);
  }

public:
  CWLCSSArray(CWLDocument *docPtr): m_DocPtr(docPtr) {}
  virtual ~CWLCSSArray() {clearAndDestroy();}
  CWLCSSArray& operator=(const CWLCSSArray&);
  void		printAll();    //! print the hrefList
	elementReadState parse(RVCString& buff, urlBase* urlBasePtr);   //! all the work is here
};
#endif

