/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlmeta.h"
#include "wldocument.h"


void CWLMeta::parseUrl(urlBase *urlBasePtr)
{
	RVCString contentRWStr(m_Content);
	int pos,endPos;
	if ((pos = contentRWStr.index("url",0,RVCString::ignoreCase)) == RV_NPOS)
        return;
	if ((pos = contentRWStr.index("=",pos+3,RVCString::ignoreCase)) == RV_NPOS)
        return;
	if ((endPos = contentRWStr.index(";",pos,RVCString::ignoreCase)) == RV_NPOS)
		contentRWStr.remove(0,pos+1);
	else
	{
		contentRWStr.remove(0,pos+1);
		contentRWStr.remove(endPos);
	}
	contentRWStr = contentRWStr.strip(RVCString::both);
	contentRWStr = contentRWStr.strip(RVCString::both,'\"');
	contentRWStr = contentRWStr.strip(RVCString::both,'\'');
	
	RVCString metaUrl = urlBasePtr->calcUrl(contentRWStr);
	m_Url = new CWLUrl(m_DocPtr, metaUrl,contentRWStr,m_DocPtr->GetDocUrl(),"","","");
	
	return;
}


void CWLMeta::parse(RVCString &buff, urlBase *urlBasePtr)
{
	size_t buffPtr = 0, attValueStart = RV_NPOS;
	RVCString attName, attValue;
	while(1)
	{
		attState metaState = htmlFindNextAttribute(buff, attName, attValue, buffPtr, attValueStart);
		if(metaState == HTML_CURRENT_ATT_COMPLETE)
		{
			switch(kindOfAttribute(attName)) {
			case CONTENT:
				m_Content = attValue.data();
				break;
			case HTTP_EQUIV:
				m_HttpEquiv = attValue.data();
				break;
			case NAME:
				m_Name = attValue.data();
				break;
			}
		}
		else if (metaState == HTML_FOUND_DELIMITER)
		{
			if( m_HttpEquiv.compareTo("refresh", RVCString::ignoreCase ) == 0 )
				parseUrl(urlBasePtr);

			break;
		}
		else
			break;
	}

	return;
}

void CWLMeta::printAll()
{
	cout << "Name:       " << m_Name << endl;
	cout << "Http-Equiv: " << m_HttpEquiv << endl;
	cout << "Content:    " << m_Content << endl;
	if( m_Url )
		cout << "Url: " << m_Url->Href() << endl;
}




elementReadState CWLMetaCollection::parse(RVCString& buff, urlBase* urlBasePtr)
{
	if( buff.index(">" ) == RV_NPOS )
		return READ_MORE;
	else
	{
		CWLMeta *mt = new CWLMeta(m_DocPtr);
		mt->parse(buff,urlBasePtr);
		insert(mt);

		return END_OF_ELEMENT;
	}
}



void CWLMetaCollection::printAll()
{
  for ( unsigned int i = 0; i < entries(); i++)  {
    CWLMeta* pfrm = (CWLMeta*)at(i);
    cout << "Meta Tag No. " << i + 1 << endl;
    cout << "=========================" << endl;
	pfrm->printAll();
    cout << endl;
  }      
}


			





