/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include <windows.h>
#include <winsock.h>

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <tchar.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "chaphttpauth.h"

// globals

#define MAX_TRY			2
/*
#define HD_AUTHENTICATE         "WWW-Authenticate:"
#define HD_LENGTH               "Content-Length:"
#define HD_CONNECTION           "Connection:"
*/

//BYTE      Request[1024];

BOOL function_that_creates_sockets()
{
    BOOL fNeedAuthenticate = FALSE;
	BOOL fServerKeepAlive = FALSE; //server side
	int	 nCount = 0;			//counts the number of tries
    PSTR pchAuthData = NULL;	//will use to hold the random number data
	BOOL fNeedMoreData;
	PSTR pchUserName = NULL;
	PSTR pchPassword = NULL;
	.
	.
	.
	/*
	send the request and parse the response headers.
	if the status code returned is 401 then:->
	*/
		fNeedAuthenticate = TRUE;
	/*
	if the response header - "WWW-Authenticate" is equal to NTLM
	then this indicates an NTLM handshake is to occur.
	else treate this response in the usual manner
	*/

	//Code for Starting Handshake...

	//close the socket

	//start a new socket similar to the last one (connecting to the same server as before)

	//perform only one loop when UserName and Password are NULL
	if ( ((*pchUserName == '\0') &&(*pchPassword == '\0')) )
		nCount++;

	while (fNeedAuthenticate)
	{
		pchAuthData = NULL;
		nCount++;
		/*
		call the following function in order to load the security dll which 
		belongs to the current's machine Windows system
		*/
		if ( !InitAuthorizationHeader() )
			{
				fprintf(stderr, "Cannot initialize security module\n" );
				return FALSE;
			}

		if (nCount <= MAX_TRY)
			for (int i=0 ; i<2 ; i++)
			{
				if (nCount == 2)
				{
					*pchUserName = '\0';
					*pchPassword = '\0';
				}
				// The User Name and Password should be taken from the Java Script

				/*
				Make the request headers similar to the previous request and then:->
				add the "Connection: Keep-Alive\r\n" header, then call the following
				function.
				
				The parameters:

				1. Pointer to the end of the last request header
				2. Pointer to the Authtentication method to use
				3. Pointer to the server sent authentication data (Random Number)
				4. Pointer to the User Name under whose behalf the NTLM method would work,
				if set to NULL the name of the user under whose security context the process
				is executing would be taken.
				5. Pointer to the User's Password.
				** If either the User Name nor the User's Password is set to NULL both would be
				taken from the user under whose security context the process is executing.
				*/
				if ( !AddAuthorizationHeader( Request + strlen(Request), "NTLM", pchAuthData,
					pchUserName, pchPassword, &fNeedMoreData ) )
				{
					printf( "Authentication failed\n" );
				}


				fServerKeepAlive = FALSE;	//server side (for current response)
				fNeedAuthenticate = FALSE;

				/*
				Send the request and parse the response headers
				Add the following 3 checks for headers:
				1). If the status code returned is 401 then:->
				*/
					fNeedAuthenticate = TRUE;
				//else:->
					fNeedAuthenticate = FALSE;
					break;

				
				/*
				2). Search if there exists an header - "WWW-Authenticate" take the right-most
				data token (= dataToken) then :->
				*/
				if (i == 0) // First iteration
					pchAuthData = dataToken;
				else if (dataToken != "NTLM")
				{
					fNeedAuthenticate = FALSE;
					break;
				}
					

				/*
				3). Search if there exist an header  - "Connection: Keep-Alive" (must 
				appear on the first iteration) then:->
				*/
					fServerKeepAlive = TRUE;

				//handle "Content-Length" header , if exists (as usual)

				if (!fServerKeepAlive)
					/*
					then:->
					1) close the current socket
					2) start a new socket similar to the last one (connecting to the
					same server as before)
					*/

			} //End of for loop
		else
			fNeedAuthenticate = FALSE;

		TerminateAuthorizationHeader();
	} //End of While loop


	// Treate the response the usual way and if the status = 401 then:->
		fprintf( stderr, "Authentication rejected by server\n" );

	//close the socket if it still exists
}
