/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _ParseFuncs_h_
#define _ParseFuncs_h_

#include "platform.h"
#include "wlurlarray.h"
#include "wlarray.h"
#include "wlurl.h"
#include "wllocation.h"

#define CWLFrame CWLDocument

class CWLCommandManager;
class CWLDocument;
class CWLUrl;
class CWLLink;
// This is a misc function that get a frame from the private part of a 
// java script objects 
CWLFrame*    GetFrame(CWLCommandManager* thread, JSContext* cx, uintN n, uintN argc, jsval v);
CWLDocument* GetWindowOrFrame(CWLCommandManager* thread, JSContext* cx, uintN n, uintN argc, jsval v);

CWLFrame*    WLParse_GetFrameByIndex(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLFrame*    WLParse_GetFrameByUrl(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLFrame*    WLParse_GetFrameByLocation(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLUrl*      WLParse_GetFrameUrl(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLUrl*      WLParse_GetLinkByIndex(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLUrl*      WLParse_GetLinkByUrl(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLUrl*      WLParse_GetLinkByName(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
CWLLocation* WLParse_GetFormAction(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetFieldValue(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetFieldValueInForm(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
char*        WLParse_GetQSFieldValue(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetHeaderValue(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
unsigned     WLParse_GetStatusNumber(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetStatusLine(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetHost(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetHostName(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
unsigned     WLParse_GetPortNum(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
const char*  WLParse_GetUri(CWLCommandManager* thread, JSContext* cx, uintN argc, jsval* argv);
	
#endif
