/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
 * File name : propertieshandler.h
 * Author    : Yossi Nakash
 * Created   : 3/7/01
 * ==========:
 * Abstract  : PropertiesHandler class declaration
 *
 * Version control stuff:
 * $Revision:: 1        $
 * $Author::            $
 */

#ifndef PROPERTIESHANDLER_H
#define PROPERTIESHANDLER_H


class PropertiesHandler
{
public:
  PropertiesHandler();
  virtual ~PropertiesHandler();

#ifndef __GNUC__
  // ATTENTION GNU compiler does not knwo how to handle static enum definitions
  // so we omit the static ONLT from GNU 
  static 
#endif //__GNUC__
    enum ClassNameId{
    EN_CLASS_NONE,
    EN_CLASS_ACTION,
    EN_CLASS_APPLET,
    EN_CLASS_ARRAY,
    EN_CLASS_BROWSER_LOCATION,
    EN_CLASS_CELL,
    EN_CLASS_CSS,
    EN_CLASS_DOCUMENT,
    EN_CLASS_ELEMENT,
    EN_CLASS_EMBED,
    EN_CLASS_FORM,
    EN_CLASS_FRAME,
    EN_CLASS_FRAMES,
    EN_CLASS_HEADER,
    EN_CLASS_IMG,
    EN_CLASS_KVP,
    EN_CLASS_LINK,
    EN_CLASS_LOCATION,
    EN_CLASS_META,
    EN_CLASS_OPTION,
    EN_CLASS_REPLY,
    EN_CLASS_ROW,
    EN_CLASS_ROW_CELL,
    EN_CLASS_SCRIPT,
    EN_CLASS_STRING,
    EN_CLASS_TABLE,
    EN_CLASS_TABLE_CELL,
    EN_CLASS_WINDOW,
    EN_CLASS_XML
  };


#ifndef __GNUC__
  // ATTENTION GNU compiler does not knwo how to handle static enum definitions
  // so we omit the static ONLT from GNU 
  static 
#endif //__GNUC__
    enum PropertyNameId{
    EN_NONE,
    EN_ACTION,
    EN_ALT,
    EN_APPLETS,
    EN_CELL_INDEX,
    EN_CELLS,
    EN_CHECKED,
    EN_CHECKSUM,
    EN_COLS,
    EN_COMMANDS,
    EN_CONTENT,
    EN_DEFAULT_CHECKED,
    EN_DEFAULT_SELECTED,
    EN_DEFAULT_VALUE,
    EN_DOCUMENT,
    EN_ELEMENTS,
    EN_EMBEDS,
    EN_ENCODING,
    EN_EVENT,
    EN_FILE_SIZE,
    EN_FORMS,
    EN_FRAMES,
    EN_HASH,
    EN_HEADERS,
    EN_HEIGHT,
    EN_HOST,
    EN_HOSTNAME,
    EN_HREF,
    EN_HTTPEQUIV,
    EN_ID,
    EN_IMAGES,
    EN_INNERHTML,
    EN_INNERIMG,
    EN_INNERTEXT,
    EN_KEY,
    EN_KVP,
    EN_LANGUAGE,
    EN_LENGTH,
    EN_LINKS,
    EN_LOCATION,
    EN_LOWSRC,
    EN_METHOD,
    EN_NAME,
    EN_OPEN_TIME,
    EN_OPTIONS,
    EN_OUTERHTML,
    EN_PATHNAME,
    EN_PORT,
    EN_PROTOCOL,
    EN_RECEIVE_TIME,
    EN_REFERRER,
    EN_REPLY,
    EN_ROWINDEX,
    EN_ROWS,
    EN_SCRIPTS,
    EN_SEARCH,
    EN_SELECTED,
    EN_SELECTED_INDEX,
    EN_SEND_TIME,
    EN_SOURCE,
    EN_SPIDERSESSION,
    EN_SRC,
    EN_STATUS_LINE,
    EN_STATUS_NUMBER,
    EN_STYLESHEETS,
    EN_TAGNAME,
    EN_TARGET,
    EN_TEXT,
    EN_TITLE,
    EN_TYPE,
    EN_URI,
    EN_URL,
    EN_USEMAP,
    EN_VALUE,
    EN_VERSION,
    EN_WAIT_TIME,
    EN_WIDTH,
    EN_WLHASH,
    EN_WLHEADERS,
    EN_WLHIDDEN_PROPERTY_CLASS_NAME,
    EN_WLHIDDEN_PROPERTY_DOM_SCOPE,
    EN_WLHOST,
    EN_WLHOSTNAME,
    EN_WLHREF,
    EN_WLMETAS,
    EN_WLORIGURL,
    EN_WLPATH_NAME,
    EN_WLPOST,
    EN_WLPROTOCOL,
    EN_WLSEARCH,
    EN_WLSEARCHPAIRS,
    EN_WLSOURCE,
    EN_WLSOURCE_INDEX,
    EN_WLSTATUS_LINE,
    EN_WLSTATUS_NUMBER,
    EN_WLTABLES,
    EN_WLVERSION,
    EN_WLXMLS
  };

public:
  static PropertiesHandler::ClassNameId GetClassId(const char* p_pcClassName);
  static PropertiesHandler::PropertyNameId GetPropertyId(const char* p_pcPropertyName);

private:
  // avoid copy ctor & asignment operator
  PropertiesHandler( const PropertiesHandler& src );
  PropertiesHandler& operator=( const PropertiesHandler& src );

};

#endif // PROPERTIESHANDLER_H
