/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_QUEUE__
#define __WL_QUEUE__
#include <slistcol.h>                              // 1
#include <thr.h>
#include <thr.h>
#include <hashdict.h>
#include <collstr.h>
#include <slistcolque.h>
#include "wlhtmlvirtualqueue.h"
#include "platform.h"

class CWLTransactionsObject;
class CWLCommandManager;

class CWLQueue : public CWLHtmlVirtualQueue {
private:
	bool                      m_Terminated;
	bool											m_MasterWaiting;
	bool											m_EndOfSession;
  bool                      m_OnlyMasterRead;
	RVMutexLock								m_NotEmptyMutex;                                
	RVMutexLock								m_ParseOnceMutex;                                
	RVCondition								m_MasterSignal;								
  RVCondition								m_SlaveSignal;                             
	RVSlistCollectablesQueue  m_TransactionsQueue;
	unsigned int							m_MaxNumberThreads;
	unsigned int							m_NumThreadsWaiting;
  RVHashDictionary          m_CacheTable;
  CWLCommandManager*        m_pCm ;

  // Chaim
  RVHashDictionary          m_SavedTransactions;
  bool                      m_UseBackup;
  RVCollectableString       m_BackupKey;                      

public:
	CWLQueue(unsigned int numThreads, CWLCommandManager* p_pCm);	
	virtual ~CWLQueue();
	void setNumMaxThreads(unsigned int maxThreads );
	HtmlQueueItemType slaveRead(RVCollectable** result);
	HtmlQueueItemType masterRead(RVCollectable** result);	
	void waitForMaxThreads();
	void releaseAllThreads();
	void terminateAllThreads();
	virtual bool insert(CWLTransactionsObject* pTransObj);
	void ClearCache();
	void clearAndDestroy();
  void setOnlyMasterRead() { m_OnlyMasterRead = true; }
  void resetOnlyMasterRead() { m_OnlyMasterRead = false; }
  bool isOnlyMasterRead() { return m_OnlyMasterRead; } 
  CWLTransactionsObject* GetCachedTransaction(RVCollectableString sKey);

  // Chaim
  void SetBackup (bool sw, RVCollectableString* key);
  bool UseBackup (RVCollectableString* key);
  RVSlistCollectablesQueue* GetSavedTransactions (RVCollectableString* key);
  bool BackupExists (RVCollectableString* key);
};
		
#endif
