// Scan the link given in order to find if url's contain session id.
function ScanLinkForNDSessionId (Link) {

	// We init the NDLink with the link given,
	// if link href contain Session id then it will be
	// set by this operation
	var NDLink = new NDLinkObj(Link.href)
	
	if (!NDLink.ContainSessionId()) {
		for (var i=0; (i<Link.wlSearchPairs.length);i++) {
			if (Link.wlSearchPairs[i].key.toUpperCase() == K_SPIDERSESSION_NAME.toUpperCase()) {
				NDLink.SetSessionId (Link.wlSearchPairs[i].value)
			}
			if (Link.wlSearchPairs[i].key.toUpperCase() == K_UNIQUEVALUE_NAME.toUpperCase()) {
				NDLink.SetUniqueValue (Link.wlSearchPairs[i].value)
			}
		}
	}

	return NDLink

}

// Scan the form given in order to find if it contain session id 
// in one of it's fields
function ScanFormForNDSessionId (Form) {

	var NDLink = new NDLinkObj()
	
	// Scan all document forms elements for spider session id's
	for (var i=0; (i<Form.elements.length);i++) {
		if (Form.elements[i].name.toUpperCase() == K_SPIDERSESSION_NAME.toUpperCase()) {
			if (!NDLink.ContainSessionId()) {
				NDLink.Set (Form.action)
			}
			NDLink.SetSessionId (Form.elements[i].value)
		}
		if (Form.elements[i].name.toUpperCase() == K_UNIQUEVALUE_NAME.toUpperCase()) {
			if (!NDLink.ContainSessionId()) {
				NDLink.Set (Form.action)
			}
			NDLink.SetUniqueValue (Form.elements[i].value)
		}
	}

	return NDLink
}

// This function scan all the dom tree for forms and links which contain 
// spider session id
function ScanDomForNDSessionId (scanedDocument){

	var NDLinkArr  = new Array()
	var NDLink     = new NDLinkObj()
	var LinksArray = scanedDocument.wlGetAllLinks ()
	var FormsArray = scanedDocument.wlGetAllForms ()

	// Go over all links in the dom tree to search for
	// the session ids
	if (LinksArray != undefined) {
		for (var i=0; i<LinksArray.length; i++) {
			NDLink = ScanLinkForNDSessionId (LinksArray[i])
			if (NDLink.ContainSessionId()) {
				NDLinkArr[NDLinkArr.length]=NDLink
			}
		}
	}
	// Go over all forms in the dom tree to search for
	// the session ids
	if (FormsArray != undefined) {
		for (var i=0 ; i < FormsArray.length ; i++ ){
			NDLink = ScanFormForNDSessionId (FormsArray[i])
			if (NDLink.ContainSessionId()) {
				NDLinkArr[NDLinkArr.length]=NDLink
			}

		}
	}
	
	return NDLinkArr
}