
Initialize();

if(wlGlobals.Verification)
{
  wlGlobals.ExpectedDomCreated = false; // Signal the need to create Expected DOMs for this process
  EvaluateScript("functest_AfterInitAgenda();",WLAfterInitAgenda);
  EvaluateScript("functest_InitClient();",WLBeforeInitClient);
}

//we need to check the wlExpectedRepository after init agenda since it is defined in init agenda(when
//using exr) and we want to do it once for all the virtual clients
function functest_AfterInitAgenda()
{
  if( typeof wlExpectedRepository == "undefined" ) //no exr - means we're running in the new Webload console( text verifications only)
  	wlGlobals.Verification = false;
}

//================================================================================================


function functest_InitClient()
{  
  if( libraryFirstInitClient("wlFuncTest") )
  {
    wlLocals.instrumentation = false;
    LoadExpectedDOMs();
    buildGlobalVerification();
	//if(wlGlobals.FunctionalTest_On != undefined)  //variable set true by the Functional Test tool
	if(wlGlobals.VerSetRounds == 100) //100% verification
	{
		wlGlobals.TableCompareRound = true;
		instrumentWlHttp();
	}
  }
}

function UNDOC_AfterRound()
{
}

function UNDOC_BeforeRound()
{
  if(wlGlobals.VerSetRounds != 100 && (wlGlobals.Verification || wlGlobals.FuncVerification_TextSearch)) 
		my_UNDOC_BeforeRound();
}															

function my_UNDOC_BeforeRound()
{
	var numOfRounds = GetRoundNumForScriptInSlave();
	var factor = wlGlobals.factor;         //every how many rounds will be instrumentation
	var factor_150 = wlGlobals.factor_150; //because the first round is always instrumented,the first factor 
											//will be increased by 50%.																				
			
					
	if(factor == -1) //do nothing - it means the wanted percent is 0.
	{
		wlGlobals.TableCompare = false; //Table compare will not be performed as well
		return;
	}
	
	if(factor == 1) //the instrumentation is always on
	{
		wlGlobals.TableCompareRound = true;
		if(wlLocals.instrumentation == false)
			instrumentWlHttp();
		return;
	}
	
	if(numOfRounds > 0)
	{
		// performe the verification on the current round
		if((numOfRounds == factor_150 + 1 || numOfRounds == 1)|| ((numOfRounds > factor_150 + 1) && ((numOfRounds - factor_150 - 1) % factor == 0) ))
		{
			wlGlobals.TableCompareRound = true;
			if(wlLocals.instrumentation == false)
				instrumentWlHttp();
		}
		else
		{
			wlGlobals.TableCompareRound = false;
			if(wlLocals.instrumentation == true)
				cancelInstrumentation();
		}
	}
	
}





function LoadExpectedDOMs()
{
  if( ! wlGlobals.ExpectedDomCreated )  // if the job is not done yet FOR THIS PROCESS
  {
    Lock();
    if( ! wlGlobals.ExpectedDomCreated )  // if the job is not done yet FOR THIS PROCESS
    {
      if( typeof wlExpectedRepository != "undefined" )
      {
        rep = new DomRepository();
        rep.Open(wlExpectedRepository);
        wlGlobals.ExpectedDOMs = new Object;

	      iterator = rep.GetIterator() ;
	      if (iterator == undefined)
	      {
	        wlGlobals.Verification = false;
          WarningMessage("Problem in loading the expected DOM file. Functional Verification will not be activated.");
          delete rep;
          return;
	      }
	
      	item=iterator.GetNextKey();
      	var itemNo = 0
      	var errorItems = 0
        while( item != -1) // loop on "my" items
        {
        	itemNo++
          newDom = CreateExpectedDOM(rep,item);
          if( typeof newDom != "undefined" )
            wlGlobals.ExpectedDOMs[item] = newDom;
          else
          {
          	wlGlobals.ExpectedDOMs[item] = undefined
            WarningMessage("Problem in loading the Expected DOM with ID : "+ itemNo +" - Verification will not be activated for this request.");
						errorItems++
          }
          item=iterator.GetNextKey();
        }
				if (errorItems==itemNo) {
	        wlGlobals.Verification = false;
          WarningMessage("Problem were found in loading the expected DOM for all requests. Functional Verification will not be activated.");
				}

        delete rep;
      }
      else
      {
        wlGlobals.Verification = false; // turn off the verificatiwlGlobals.VerUpperMaxRoundson
        //WarningMessage("Expected Repository is missing. Turning verification off.");
        //WarningMessage("The Expected Repository file was not found. If your agenda contains functional verification, it will be turned off.");
      }
      
      wlGlobals.ExpectedDomCreated = true; // Job done.
    }
    // Unlock the region
    Unlock();
  }
}


function GetPostFunc(httpObj,func,url,name)
{
  if(url == undefined)
    func.apply(httpObj);
  else if(name == undefined)
    func.apply(httpObj,[url]);
  else
    func.apply(httpObj,[url,name]);
}


function VerificationTransaction(httpObj,func,url,name)
{
  var verObj = undefined;
  var target;
  
  target = httpObj.wlTarget;
  if( wlGlobals.Verification )
  {
    if(httpObj.ExpectedDOMID == undefined)
    	WarningMessage("Missing ExpectedDOMID. No verification will take place for transaction "+url+".");
    if( wlGlobals.ExpectedDOMs != undefined && httpObj.ExpectedDOMID != undefined)
      expectedDocument = wlGlobals.ExpectedDOMs[httpObj.ExpectedDOMID];
    else
      expectedDocument = undefined;
    
    // Perform Any verification required
    if( typeof wlHttp.FunctionalVerification != "undefined" )
      verObj = wlHttp.FunctionalVerification;
    else if( typeof wlLocals.FunctionalVerification != "undefined" )
      verObj = wlLocals.FunctionalVerification;
      
    if( verObj != undefined &&
	    (verObj.CompareTableStructure != WLSuccess ||
		 verObj.CompareNrOfTables     != WLSuccess  ) )
      httpObj.ParseTables = true;
		
		httpObj.SaveSource = "Yes";  // needed for reporting
    // Perform the transaction
    httpObj.FoldTransactionsTree = false;	  	
    GetPostFunc(httpObj,func,url,name);
    
    
    
    if( verObj != undefined && expectedDocument != undefined ) // there is a verification to do
    {
      if( target != undefined && target != "" ) // there is a Target
      {
        verObj.ExpectedDom=expectedDocument.document.GetFrameByLocation(target);
        verObj.ActualDom=window.document.GetFrameByLocation(target);
        
        if(verObj.ExpectedDom.toString() != "[object WLWindow]" ||
           verObj.ActualDom.toString() != "[object WLWindow]")
           {
           //if there are test cases the transaction tree will be folded by the IDE
             if(wlHttp.FoldTree == undefined || wlHttp.FoldTree == true)
             	InsertTransactions(); // close transaction tree
             wlHttp.FoldTree = true;
             return;
           }
      }
      else
      {
        verObj.ExpectedDom=expectedDocument;
        verObj.ActualDom=window;
      }
      verObj.Verify();
    }
    //if there are test cases the transaction tree will be folded by the IDE
    if(wlHttp.FoldTree == undefined || wlHttp.FoldTree == true)      
    	InsertTransactions(); // close transaction tree
    wlHttp.FoldTree = true;
  }
  else if(wlGlobals.FuncVerification_TextSearch)
  { 
    if( typeof wlHttp.FunctionalVerification != "undefined" )
      verObj = wlHttp.FunctionalVerification;
    else if( typeof wlLocals.FunctionalVerification != "undefined" )
      verObj = wlLocals.FunctionalVerification;
    
    httpObj.SaveSource = "Yes";
    httpObj.FoldTransactionsTree = false;     
    GetPostFunc(httpObj,func,url,name);
     
    if(verObj != undefined)
    {
        if( target != undefined && target != "" ) // there is a Target
        {
          verObj.ActualDom=window.document.GetFrameByLocation(target);
          if(verObj.ActualDom.toString() != "[object WLWindow]")
          {
           //if there are test cases the transaction tree will be folded by the IDE
             if(wlHttp.FoldTree == undefined || wlHttp.FoldTree == true)
              InsertTransactions(); // close transaction tree
             wlHttp.FoldTree = true;
             return;
          }
        }
        else
          verObj.ActualDom=window;
          
        verObj.prepareTextVerification();
        verObj.globalTextSearch(verObj.ActualDom);
        
        //if there are test cases the transaction tree will be folded by the IDE
        if(wlHttp.FoldTree == undefined || wlHttp.FoldTree == true)      
          InsertTransactions(); // close transaction tree
    
        wlHttp.FoldTree = true;
    }
  }
  else
  {
    GetPostFunc(httpObj,func,url,name);
  }
}

function VerifiedGet(url,name)
{
  VerificationTransaction(this,this.OrigGet,url,name); 
  wlHttp.FunctionalVerification = undefined;
}

function VerifiedPost(url,name)
{
  VerificationTransaction(this,this.OrigPost,url,name);
  wlHttp.FunctionalVerification = undefined;
}


function instrumentWlHttp()
{
  if( wlGlobals.Verification || wlGlobals.FuncVerification_TextSearch ) // if verification is on
  {
    wlLocals.instrumentation = true;

    wlHttp.OrigGet = wlHttp.Get;
    wlHttp.Get = VerifiedGet;
    wlHttp.OrigPost = wlHttp.Post;
    wlHttp.Post = VerifiedPost;
  }
    
  expectedDocument = undefined;
}

function cancelInstrumentation()
{
	wlLocals.instrumentation = false;
	wlHttp.Get = wlHttp.OrigGet;
	wlHttp.Post = wlHttp.OrigPost;
	
}

function buildGlobalVerification()
{
  
  if(wlGlobals.IsFuncVerification && (wlGlobals.Verification || wlGlobals.FuncVerification_TextSearch)) //at least one of the verifications flags is on and Verification is true
  {	
    wlLocals.FunctionalVerification = new Verification;
    wlLocals.FunctionalVerification.CompareTitle=wlGlobals.FuncVerification_CompareTitle;
    wlLocals.FunctionalVerification.CompareNrOfLinks=wlGlobals.FuncVerification_CompareNrOfLinks;
    wlLocals.FunctionalVerification.CompareNrOfImages=wlGlobals.FuncVerification_CompareNrOfImages;
    wlLocals.FunctionalVerification.CompareNrOfFrames=wlGlobals.FuncVerification_CompareNrOfFrames;
    wlLocals.FunctionalVerification.CompareNrOfForms=wlGlobals.FuncVerification_CompareNrOfForms;
    wlLocals.FunctionalVerification.CompareNrOfTables=wlGlobals.FuncVerification_CompareNrOfTables;
    wlLocals.FunctionalVerification.CompareLinksByUrl=wlGlobals.FuncVerification_CompareLinksByUrl;
    wlLocals.FunctionalVerification.CompareFormsByUrl=wlGlobals.FuncVerification_CompareFormsByUrl;
    wlLocals.FunctionalVerification.CompareImagesByUrl=wlGlobals.FuncVerification_CompareImagesByUrl;
    wlLocals.FunctionalVerification.CompareNrOfFormElements=wlGlobals.FuncVerification_CompareNrOfFormElements;
    wlLocals.FunctionalVerification.CompareTableStructure=wlGlobals.FuncVerification_CompareTableStructure;
    //wlLocals.FunctionalVerification.ComparePageSize=wlGlobals.FuncVerification_ComparePageSize;
    
  }
  
}


function Initialize()
{

	FORM_TYPE = "FORM";
	LINK_TYPE = "A";
	AREA_TYPE = "AREA"
	TABLE_TYPE = "TABLE";
	FRAME_TYPE = "FRAME";
	IMAGE_TYPE = "IMG";
	TITLE_TYPE = "TITLE"
	
	CMP_FORMS_BY_URL = "CompareFormsByUrl";
	CMP_LINKS_BY_URL = "CompareLinksByUrl";
	CMP_TABLE_STRUCTURE = "CompareTableStructure";
	CMP_FRAMES_BY_URL = "CompareFramesByUrl";
	CMP_IMAGES_BY_URL = "CompareImagesByUrl";
	CMP_FORM_ELEMENTS = "CompareNrOfFormElements";
	CMP_TITLE = "CompareTitle";
	CMP_LINKS_NR = "CompareNrOfLinks";
	CMP_IMAGES_NR = "CompareNrOfImages";
	CMP_FRAMES_NR = "CompareNrOfFrames";
	CMP_FORMS_NR = "CompareNrOfForms";
	CMP_TABLES_NR = "CompareNrOfTables";
	CMP_PAGE_SIZE = "ComparePageSize";
	GENERAL = "General";
  TEXT_SEARCH = "TextSearch"
	
	DO_NOT_CHECK = WLSuccess;
	REPORT_AS_MINOR_ERROR = WLMinorError;
	REPORT_AS_ERROR = WLError;
	REPORT_AS_SEVERE_ERROR = WLSevereError;
	
	wlGlobals.TableCompare = wlGlobals.Verification;
	wlGlobals.TableCompareRound = false;
	if(wlGlobals.VerSetRounds != 0) //the percent of the rounds for whitch the functional testing is done
	{
		wlGlobals.factor = Math.round(100/wlGlobals.VerSetRounds);
		wlGlobals.factor_150 = Math.round(150/wlGlobals.VerSetRounds); 
	}
	else
	{
		wlGlobals.factor = - 1;
		wlGlobals.factor_150 = - 1;
	}	
}


function InsertTransactions()
{
	wlHttp.ExpectedDOMID = undefined;
	if(wlLocals.instrumentation)
		wlHttp.InsertTransactions();
}

// Add an informative message
// not in use for the verifications
function myVerificationAddMessage(msg)
{
  this.numMessages++;
  this.reporter.AddMessage(msg);
  if( this.useInfoMessage )
    InfoMessage(msg);
}

// Add an error
function myVerificationAddError(msg,expectedData,actualData)
{
  this.errorFlag = true;
  this.numErrors++;
  
  if( expectedData == undefined && actualData == undefined)
  {
    this.reporter.AddMessage(msg);
    if( this.useInfoMessage )
    	InfoMessage(msg);
  }
  else 
  {
    if( actualData != undefined )
      this.reporter.AddError(msg,expectedData,actualData);    
    if( this.useInfoMessage )
      InfoMessage(msg);
  }
}

function myVerificationReport(frame1,frame2,transactionReason)
{
	if(transactionReason == undefined)
		transactionReason = "Functional Testing";
	this.reporter.Html1=frame1.document.wlSource;
	this.reporter.Html2=frame2.document.wlSource;
	this.reporter.RepositoryName="XXX";
	if(this.reporter.ExpectedItemId == undefined)
		this.reporter.ExpectedItemId= wlHttp.ExpectedDOMID;
	if(this.reporter.Location1 == undefined)
		if(frame1.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
  	  this.reporter.Location1 = frame1.document.GetIdentLocation();
  if(this.reporter.Location2 == undefined)
  	if(frame2.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    	this.reporter.Location2 = frame2.document.GetIdentLocation();
	this.reporter.FrameName="XXX";
  wlHttp.SetSeverity(frame2,this.maxSeverity);
  wlHttp.SetFailureReason(frame2,transactionReason,"");
  wlHttp.AddEvent(frame2,this.reporter,this.maxSeverity);
  this.reporter.Clear();
  this.errorFlag = false;
  this.numErrors = 0;
  this.numMessages = 0;
  
}

function textSearchReport(frame2,transactionReason)
{
  if(transactionReason == undefined)
    transactionReason = "Functional Testing";
  this.reporter.Html1="";
  this.reporter.Html2=frame2.document.wlSource;
  this.reporter.RepositoryName="XXX";
  if(this.reporter.Location2 == undefined)
      this.reporter.Location2 = frame2.document.GetIdentLocation();
  this.reporter.FrameName="XXX";
  wlHttp.SetSeverity(frame2,this.maxSeverity);
  wlHttp.SetFailureReason(frame2,transactionReason,"");
  wlHttp.AddEvent(frame2,this.reporter,this.maxSeverity);
  this.reporter.Clear();
  this.errorFlag = false;
  this.numErrors = 0;
  this.numMessages = 0;
  
}


// constructor function for my reporter

function MyVerificationReporter(ver_name,logReport)
{
  if(logReport == undefined)
  	logReport = "Functional test failed.";
  this.reporter = new FunctionalTestReporter(ver_name,logReport);
  this.useInfoMessage = false; // a flag indicating whether to use InfoMessage as well as AddMessage
  this.errorFlag = false;
  this.numErrors = 0;
  this.numMessages = 0;
  this.AddMessage = myVerificationAddMessage;
  this.AddError = myVerificationAddError;
  this.Report = myVerificationReport;
  this.TextSearchReport = textSearchReport;
  this.ExpectedObj = new FunctionalTestObjDetails();
  this.ActualObj = new FunctionalTestObjDetails();
  this.maxSeverity = WLSuccess;
}


function AddErrToReporter(objType,testType,url,expIndex,actIndex,message,reporter)
{
	// the parameters:(objType,testType,index1,index2,x1,y1,x2,y2)
	reporter.ExpectedObj.Set(objType,testType,url,expIndex-1,-1,-1,-1,-1,-1); 
	reporter.ActualObj.Set(objType,testType,url,actIndex-1,-1,-1,-1,-1,-1);
	reporter.AddError(message,reporter.ExpectedObj,reporter.ActualObj);
}

function AddDuplicatedErr(objType,testType,url,expIndex,actIndex,expIndex2,actIndex2,message,reporter)
{
	// the parameters:(objType,testType,index1,index2,x1,y1,x2,y2)
	reporter.ExpectedObj.Set(objType,testType,url,expIndex-1,expIndex2,-1,-1,-1,-1); 
	reporter.ActualObj.Set(objType,testType,url,actIndex-1,actIndex2,-1,-1,-1,-1);
	reporter.AddError(message,reporter.ExpectedObj,reporter.ActualObj);
}

function DisplayMessage (message)
{
if( typeof wlGlobals.AsmDiagnostics != "undefined" && wlGlobals.AsmDiagnostics == true )
	{
	  InfoMessage(message);
	}
}

//error reporting in case there were mismatches

function ReportErrors(window1,window2,Errors,type,reporter)
{
	var inFirstMessage = new String();
  var inSecondMessage = new String();
  var inMisplacedMessage = new String();
  var oneMessage = new String();
  var i;
  var length1, length2, length3;
  var expPos,actPos;
  var url;
	  
  length1 = Errors.InFirst.length;
  length2 = Errors.InSecond.length;
  length3 = Errors.Misplaced.length;
  
  switch(type)
	{
		case "FORM":
			typeMessage = "form";
			propNameMessage = "URL";
			propMessage = "action";
			objType=FORM_TYPE;
			testType=CMP_FORMS_BY_URL;
			break;
		case "LINK":
			typeMessage = "link";
			propNameMessage = "URL";
			propMessage = "href";
			objType=LINK_TYPE;
			testType=CMP_LINKS_BY_URL;
			break;
			case "TABLE":
			typeMessage = "table";
			propNameMessage = "id";
			propMessage = "id";
			objType=TABLE_TYPE;
			testType=CMP_TABLE_STRUCTURE;
			break;
		case "FRAME":
		 	typeMessage = "frame";
		 	propNameMessage = "URL";
			propMessage = "location";
			objType=FRAME_TYPE;
			testType=CMP_FRAMES_BY_URL;
			break;
		case "IMAGE":
		 	typeMessage = "image";
		 	propNameMessage = "URL";
			propMessage = "src";
			objType=IMAGE_TYPE;
			testType=CMP_IMAGES_BY_URL;
			break;
  }	
  
  if(length1 > 0)
	{
		for(i=0;i<length1;i++)
	  {
	  	expPos = Errors.InFirst[i].index + 1;
	  	inFirstMessage += "Expected position: "+expPos+". Expected "+propNameMessage+": "+Errors.InFirst[i].elem[propMessage]+". ";
	  	oneMessage = "Expected "+typeMessage+" not found. Expected position: "+expPos+". Expected "+propNameMessage+": "+Errors.InFirst[i].elem[propMessage]+". ";
	  	if(type == "LINK")
	  		objType = Errors.InFirst[i].elem.tagName;
	  	if(type == "LINK" || type == "IMAGE")
	  		url = Errors.InFirst[i].elem.wlOrigUrl.toString();
	  	else
	  		url = "";
	  	if(Errors.InFirst[i].duplicates == undefined)
	  		AddErrToReporter(objType,testType,url,expPos,-1,oneMessage,reporter);
	  	else
	  		AddDuplicatedErr(objType,testType,url,expPos,-1,Errors.InFirst[i].duplicates,-1,oneMessage,reporter);
	  }
	  DisplayMessage("The following "+typeMessage+"s were expected but not found. "+inFirstMessage);
  }
  
  if(length2 > 0)
	{
		for(i=0;i<length2;i++)
		{
		 	actPos = Errors.InSecond[i].index + 1;
		 		
		 	inSecondMessage += "Actual position: "+actPos+". Actual "+propNameMessage+": "+Errors.InSecond[i].elem[propMessage]+". ";
		 	oneMessage = "Unexpected "+typeMessage+" found. Actual position: "+actPos+". Actual "+propNameMessage+": "+Errors.InSecond[i].elem[propMessage]+". ";
			if(type == "LINK")
	  		objType = Errors.InSecond[i].elem.tagName;
			if(type == "LINK" || type == "IMAGE")
	  		url = Errors.InSecond[i].elem.wlOrigUrl.toString();
	  	else
	  		url = "";		 
	  	if(Errors.InSecond[i].duplicates == undefined)
	  		AddErrToReporter(objType,testType,url,-1,actPos,oneMessage,reporter);
	  	else
	  		AddDuplicatedErr(objType,testType,url,-1,actPos,-1,Errors.InSecond[i].duplicates,oneMessage,reporter);
		}
		DisplayMessage("The "+typeMessage+"s that weren't expected to be found but were found: "+inSecondMessage);
  }
  
  if(length3 > 0)
	{ 
	  for(i=0;i<length3;i++)
	  {
	    expPos = Errors.Misplaced[i].firstIndex + 1;
	    actPos = Errors.Misplaced[i].secondIndex + 1;
	    inMisplacedMessage += "Expected position: "+expPos+". Actual position: "+actPos+". "+propNameMessage+": "+Errors.Misplaced[i].firstElem[propMessage]+". ";
	  }
	  DisplayMessage("The "+typeMessage+"s that were found in another position than the expected one: "+inMisplacedMessage);
  }
}


function AreErrors(Errors)
{
	if(Errors.InFirst.length > 0 || Errors.InSecond.length > 0 || Errors.Misplaced.length > 0)
		return true;
	return false;
}



//empty constractors
function MatchedClass(){}
function ResultsClass(){}
function ErrorsClass(){}
function MisplacedClass(){}
function NotFoundClass(){}
function EntriesObject(){}

function HashObj()
{
	this.Entries = new EntriesObject();
	this.insertByKey=InsertByKey;
	this.getNrOfEntries=GetNrOfEntries; 
	this.getSerialNr=GetSerialNr;
}

function InsertByKey(key,data)
{
	var value;
	
	value = this.Entries[key];
		
	if(value == undefined)
	{
		value = new Array();
		if(data != undefined)
			value[0] = data;
		else
			value[0] = -1;
		this.Entries[key] = value;
	}
	else if(data != undefined)
	{
		value[value.length] = data;
	}
	else
	{
		value[value.length] = -1;
	}
	
}

function GetNrOfEntries(key)
{
	var value;
		
	//value = eval("this.Entries[\""+key+"\"]");
	
	value = this.Entries[key];
	
	if(value == undefined)
		return 0;
	else
		return value.length;
}

function GetSerialNr(key, data)
{
	var i;
	var arr;
	
	arr = this.Entries[key];
	if(arr == undefined)
		return 0;
	else
	{
		for(i=0;i<arr.length;i++)
		{
			if(arr[i] == data)
			{
				return i+1;
			}
		}
		return 0;
	}
}

function getUrl(object,type)
{
	var url;
	
	switch(type)
	  {	
	    case "FORM":
	      url = object.action.toString();
	      return url;
	    case "LINK":
	      url = object.href.toString();
	      return url;
	    case "FRAME":
	      url = object.location.href.toString();
	      return url;
	    case "IMAGE":
	      url = object.src.toString();
	      return url;
	    default:
	      return "unknown object";  //not an implemented type
  	}

}

function IsAsmCollectionMatching(window1,window2,col1,col2,type)
{
	var i,j;
  var iPerfect =0, iFirst=0, iSecond=0, iMisplaced=0; //indexes for the error arrays
  var length1=col1.length;
  var length2=col2.length;
  
  var FoundInSecond = new Array(); //array of indexes showing which elements in the second collection were matched  
  var PerfectMatched = new Array(); //identical elements found at the same index
  
  //error arrays
  var InFirst = new Array(); //elements found in the first colection but not in the second
  var InSecond = new Array();  // elements found in the second colection but not in the first
  var Misplaced = new Array(); //elements found at different indexes in the two collections
  var Results = new ResultsClass();
  var Errors = new ErrorsClass();
  
  var ExpectedUrls = new HashObj();
  var ExpectedAreaLinks = new HashObj();
  
  var ActualUrls = new HashObj();
  var ActualAreaLinks = new HashObj();
  
  var bArea = false;
     
  if(length1 == 0 && length2 ==0) //empty collections
  {
  	Errors.InFirst=InFirst;
	  Errors.InSecond=InSecond;
	  Errors.Misplaced=Misplaced;
	  Results.Errors = Errors;
  	Results.PerfectMatched = PerfectMatched;
  	
  	return Results;
  }
  
	for(j=0;j<length2;j++)  //initializing the indexes of the elements found in the second collection
	{
    FoundInSecond[j]=0;
    if(type == "LINK")
    {
    	if(col2[j].tagName == "AREA")
    	{
    		ActualAreaLinks.insertByKey(getUrl(col2[j],type),j);
    	}
    	else // type is A 
    	{
    		ActualUrls.insertByKey(getUrl(col2[j],type),j);
    	}
    }	
    else // not a link 
    {
    	ActualUrls.insertByKey(getUrl(col2[j],type),j);
    }
  }
  
  for(i=0;i<length1;i++)
  {
  	bArea = false;
  	
  	if(type == "LINK")
		{
			if(col1[i].tagName == "AREA")
		  {
		  	ExpectedAreaLinks.insertByKey(getUrl(col1[i],type),i);
		  	bArea = true;
		  }
		  else // type is A 
		  {
		    ExpectedUrls.insertByKey(getUrl(col1[i],type),i);
		  }
		}	
		else // not a link 
		{
			ExpectedUrls.insertByKey(getUrl(col1[i],type),i);
    }
  	
    	
  	index = AsmMatching(col1[i],window2,i,type);
  	
  	if(index == undefined || index >= length2)  //there was a mistake in AsmMatching
  	{
  		index = -1;
  	}
  	if(index == i)
  	{
  		if(FoundInSecond[i] == 1)
  		{
  			index = -1;
  		}
  		else
  		{
  			FoundInSecond[i]=1;
  			
  			matchedObj = new MatchedClass();
				matchedObj.firstElem = col1[i];
				matchedObj.secondElem = col2[i];
				matchedObj.Index = i;
				if(bArea)
					matchedObj.duplicates = ExpectedAreaLinks.getNrOfEntries(getUrl(col1[i],type));
				else
					matchedObj.duplicates = ExpectedUrls.getNrOfEntries(getUrl(col1[i],type));
				PerfectMatched[iPerfect]=matchedObj;
				iPerfect++;      	
      }
  	}
  	if(index != i && index != -1)
  	{
  		if(FoundInSecond[index] == 1)
  		{
  			index = -1;
  		}
  		else
  		{
  			FoundInSecond[index]=1;
  					        	
				misObj = new MisplacedClass();
				misObj.firstElem = col1[i];
				misObj.secondElem = col2[index];
				misObj.firstIndex = i;
				misObj.secondIndex = index;
				if(bArea)
				{
					misObj.firstDuplicates = ExpectedAreaLinks.getNrOfEntries(getUrl(col1[i],type));
					misObj.secondDuplicates = ActualAreaLinks.getSerialNr(getUrl(col2[index],type),index);
				}
				else
				{
					misObj.firstDuplicates = ExpectedUrls.getNrOfEntries(getUrl(col1[i],type));
					misObj.secondDuplicates = ActualUrls.getSerialNr(getUrl(col2[index],type),index);
				}
				Misplaced[iMisplaced]=misObj;
        iMisplaced++;
  		}
  	}
  	if(index == -1)
  	{
  		notFoundObj = new NotFoundClass();
			notFoundObj.elem = col1[i];
			notFoundObj.index=i;
			if(bArea)
				notFoundObj.duplicates = ExpectedAreaLinks.getNrOfEntries(getUrl(col1[i],type));
			else
				ExpectedUrls.getNrOfEntries(getUrl(col1[i],type));
			InFirst[iFirst]=notFoundObj;
      iFirst++;
  	}
  } //end of for
  
  //finding the elements in the second collection that no element from the first colection matched them
	  
	for(j=0;j<length2;j++)
	{
		
	  if(FoundInSecond[j] == 0) //the j element in the second collection wasn't matched
	  {
	    notFoundObj = new NotFoundClass();
	    notFoundObj.elem = col2[j];
	    notFoundObj.index=j;
	    if(col2[j].tagName == "AREA")
	    	notFoundObj.duplicates = ActualAreaLinks.getSerialNr(getUrl(col2[j],type),j);
	    else
	    	notFoundObj.duplicates = ActualUrls.getSerialNr(getUrl(col2[j],type),j);
	    InSecond[iSecond]=notFoundObj;
	    iSecond++;
	  }
	}
	      
	      
	Errors.InFirst=InFirst;
	Errors.InSecond=InSecond;
	Errors.Misplaced=Misplaced;
	 
	Results.Errors = Errors;
	Results.PerfectMatched = PerfectMatched;
	  
  return Results;
  
}



function AsmMatching(obj1,window2,expectedIndex,type)
{
  var func,text,name,id,url,res;
  var matcher;
  
  switch(type)
  {	
    case "FORM":
      func = "IdentifyForm";
      text = "";
      name = obj1.name;
      if(name == undefined)
      	name = "";
      id = obj1.id;
      if(id == undefined)
      	id = "";
      url = obj1.action.toString();
      break;
    case "LINK":
      func = "IdentifyLink";
      text = obj1.innerText;
      if(text == undefined)
      	text = "";
			name = obj1.name;
			if(name == undefined)
				name = "";
			id = obj1.id;
			if(id == undefined)
				id = ""
      url = obj1.href.toString();
      break;
    case "FRAME":
      func = "IdentifyFrame";
      text = "";
			name = obj1.name;
			if(name == undefined)
				name = "";
			id = "";
      url = obj1.location.href.toString();
      break;
    case "IMAGE":
      func = "IdentifyImage";
      text = "";
			name = "";
			id = obj1.id;
			if(id == undefined)
				id = "";
      url = obj1.src.toString();
      break;
    default:
      return -1;  //not an implemented type
  }
  
  matcher = new WLLink(url,text,name,id);
  res = window2.document[func](matcher,expectedIndex);
  if(res == undefined)
  {
  	return -1;
  }
  
  return res.wlSourceIndex;
  
}


//the function searches for every element of the first collection (col1), a perfect match in the 
//second collection (col2). All mismaches found are saved in 3 arrays:InFirst,InSecond,Misplaced.
//The matches are found in the PerfectMatched array.

function IsCollectionMatching(col1, col2,type)
{
  var i,j;
  var iPerfect =0, iFirst=0, iSecond=0, iMisplaced=0; //indexes for the error arrays
  var length1=col1.length;
  var length2=col2.length;
  var FoundInSecond = new Array(); //array of indexes showing which elements in the second collection were matched
  var wasFound=false; //boolean indicating if a match was found for the first collection elements
  
  var PerfectMatched = new Array(); //identical elements found at the same index
  
  //error arrays
  var InFirst = new Array(); //elements found in the first colection but not in the second
  var InSecond = new Array();  // elements found in the second colection but not in the first
  var Misplaced = new Array(); //elements found at different indexes in the two collections
  var Results = new ResultsClass();
  var Errors = new ErrorsClass();
  
      
  if(length1 == 0 && length2 ==0) //empty collections
  {
  	Errors.InFirst=InFirst;
	  Errors.InSecond=InSecond;
	  Errors.Misplaced=Misplaced;
	  Results.Errors = Errors;
  	Results.PerfectMatched = PerfectMatched;
  	
  	return Results;
  }
  
  
  for(j=0;j<length2;j++)  //initializing the indexes of the elements found in the second collection
    FoundInSecond[j]=0;
  
  for(i=0;i<length1;i++)
  {
    for(j=0;j<length2;j++)
    {
      if(i<length2)
      {
        if(IsMatching(col1[i],col2[i],type)) //cheching first at the expected location in case there are a few identical elements
        {
					if(FoundInSecond[i] == 0) //the matching is valid only if the actual element wasn't already matched
					{
        		matchedObj = new MatchedClass();
				  	matchedObj.firstElem = col1[i];
				  	matchedObj.secondElem = col2[i];
						matchedObj.Index = i;
						PerfectMatched[iPerfect]=matchedObj;
          	iPerfect++;
        	
          	FoundInSecond[i]=1;
          	wasFound = true;
          	break;
          }
        }
      }
      if(type == "TABLE")  //if the 2 tables aren't at the same index,the id mustn't be empty
      {
      	type = "TABLE_ENFORCED";
			}
      if(IsMatching(col1[i],col2[j],type))
      {
        if(FoundInSecond[j] == 0)
        {
        	FoundInSecond[j]=1;
        	wasFound = true;
        	
        	misObj = new MisplacedClass();
        	misObj.firstElem = col1[i];
        	misObj.secondElem = col2[j];
        	misObj.firstIndex = i;
        	misObj.secondIndex = j;
        	Misplaced[iMisplaced]=misObj;
        	iMisplaced++;
        	
        	break;  //already found match for the element
        }
      }
    }
    if(wasFound == false)
    {
      notFoundObj = new NotFoundClass();
      notFoundObj.elem = col1[i];
      notFoundObj.index=i;
      InFirst[iFirst]=notFoundObj;
      iFirst++;
    }
    else
      wasFound = false;  //for the next iteration
  }  
    
    
  //finding the elements in the second collection that no element from the first colection matched them
  
  for(j=0;j<length2;j++)
  {
    if(FoundInSecond[j] == 0) //the j element in the second collection wasn't matched
    {
      notFoundObj = new NotFoundClass();
      notFoundObj.elem = col2[j];
      notFoundObj.index=j;
      InSecond[iSecond]=notFoundObj;
      iSecond++;
    }
  }
      
  
  Errors.InFirst=InFirst;
  Errors.InSecond=InSecond;
  Errors.Misplaced=Misplaced;
  
  Results.Errors = Errors;
  Results.PerfectMatched = PerfectMatched;
  
  return Results;
}



//not in use if using asm
function IsWindowMatching(window1,window2)
{
 if(window1.location.href.toString() != window2.location.href.toString() )
 { 	
    return false;
 }
 return true;
}      
      
function IsTableMatching(table1,table2)
{
  if(table1.id != table2.id)
    return false;
  return true;
}
      

function IsEnforcedTableMatching(table1,table2)
{
  if(table1.id != table2.id)
    return false;
  if(table1.id == undefined ||table1.id == "") //the enforcement to the matching condition
  	return false;
  return true;
}


//not in use if using asm    
function IsFormMatching(form1,form2)
{
  if(form1.name != form2.name || form1.action.toString() != form2.action.toString())
    return false;
  return true;
}


//not in use if using asm
function IsLinkMatching(link1,link2)
{
  var isMatch=true;
  
  if(link1.href != link2.href)
    isMatch=false;
  if(link1.innerText != link2.innerText)
    isMatch=false;
  if(link1.id != link2.id)
    isMatch=false;
  if(link1.name != link2.name)
    isMatch=false;
  if(!isMatch)
    return false;  
  return true;
}


//not in use if using asm
function IsImageMatching(image1,image2)
{
	if(image1.src.toString() != image2.src.toString())
		return false;
	return true;
}


function IsMatching(obj1,obj2,type)
{
  
  switch(type)
  {
    case "FORM":
      return IsFormMatching(obj1,obj2);
    case "LINK":
      return IsLinkMatching(obj1,obj2);
    case "TABLE":
      return IsTableMatching(obj1,obj2);
    case "TABLE_ENFORCED":
      return IsEnforcedTableMatching(obj1,obj2);
    case "FRAME":
      return IsWindowMatching(obj1,obj2);
    case "IMAGE":
      return IsImageMatching(obj1,obj2);
    default:
      return false;  //not an implemented type
  }
}




function CmpTitle(window1,window2)
{
  var message;
  var url;
  
  url = "";
  DisplayMessage("Verifiying titles in frame "+window1.location);
  if(window1.document.title != window2.document.title)
  {
    message = "Compare Title verification failed in frame "+window1.location.href.toString()+". Expected title: "+window1.document.title +". Actual title: "+window2.document.title;
    AddErrToReporter(TITLE_TYPE,CMP_TITLE,url,-1,-1,message,this.reporter);
    DisplayMessage(message);
    this.updateTransactionSeverity(this.CompareTitle);
  }
}


function CmpNrOfLinks(window1,window2)
{
	var message;
	var url;
	  
  url = "";
	DisplayMessage("Verifiying number of links in frame "+window1.location);
  if(window1.document.links.length != window2.document.links.length)
  {
    message = "Compare No. of Links verification failed in frame "+window1.location+". Expected number of links: "+window1.document.links.length +". Actual number of links: "+window2.document.links.length;
    DisplayMessage(message);
    AddErrToReporter(LINK_TYPE,CMP_LINKS_NR,url,-1,-1,message,this.reporter);
    this.updateTransactionSeverity(this.CompareNrOfLinks);
  }
}



function CmpNrOfImages(window1,window2)
{
  var message;
  var url;
	  
  url = "";
  DisplayMessage("Verifiying number of images in frame "+window1.location);
  if(window1.document.images.length != window2.document.images.length)
  {
    message = "Compare No. of Images verification failed in frame "+window1.location+". Expected number of images: "+window1.document.images.length +". Actual number of images: "+window2.document.images.length;
    AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_NR,url,-1,-1,message,this.reporter);
    DisplayMessage(message);
    this.updateTransactionSeverity(this.CompareNrOfImages);
  }
}



function CmpNrOfFrames(window1,window2)
{
	var message;
	var url;
  
  url = ""; 
  DisplayMessage("Verifiying number of frames in frame "+window1.location);

  if(window1.document.frames.length != window2.document.frames.length)
  {
    message = "Compare No. of Frames verification failed in frame "+window1.location+". Expected number of frames: "+window1.document.frames.length +". Actual number of frames: "+window2.document.frames.length;
    AddErrToReporter(FRAME_TYPE,CMP_FRAMES_NR,url,-1,-1,message,this.reporter);
    DisplayMessage(message);
    this.updateTransactionSeverity(this.CompareNrOfFrames);
  }
}



function CmpNrOfTables(window1,window2)
{
	var message;
	var url;
	  
  url = "";
	DisplayMessage("Verifiying number of tables in frame "+window1.location);

  if(window1.document.wlTables.length != window2.document.wlTables.length)
  {
  	message = "Compare No. of Tables verification failed in frame "+window1.location+". Expected number of tables: "+window1.document.wlTables.length +". Actual number of tables: "+window2.document.wlTables.length;

  	AddErrToReporter(TABLE_TYPE,CMP_TABLES_NR,url,-1,-1,message,this.reporter);
  	DisplayMessage(message);
  	this.updateTransactionSeverity(this.CompareNrOfTables);
  }
}



function CmpNrOfForms(window1,window2)
{
	var message;
	var url;
  
  url = ""; 
  DisplayMessage("Verifiying number of forms in frame "+window1.location);
  if(window1.document.forms.length != window2.document.forms.length)
  {
  	message = "Compare No. of Forms verification failed in frame "+window1.location+". Expected number of forms: "+window1.document.forms.length +". Actual number of forms: "+window2.document.forms.length;

  	AddErrToReporter(FORM_TYPE,CMP_FORMS_NR,url,-1,-1,message,this.reporter);
  	DisplayMessage(message);
  	this.updateTransactionSeverity(this.CompareNrOfForms);
  }
}



function CmpFormsByUrl(window1,window2)
{
	var Results, MatchedObj;
	var i,res;

  DisplayMessage("Verifiying forms by URL in frame "+window1.location);
  Results = IsAsmCollectionMatching(window1,window2,window1.document.forms,window2.document.forms,"FORM");
    if(AreErrors(Results.Errors))
    {
      ReportErrors(window1,window2,Results.Errors,"FORM",this.reporter);
      DisplayMessage("Compare Forms by URL verification failed in frame "+window1.location);

      this.updateTransactionSeverity(this.CompareFormsByUrl);
      if(this.CompareNrOfFormElements > 0)
      {
        if(Results.PerfectMatched.length > 0)  //continuing verification with the matched forms
        {
        	for(i=0;i<Results.PerfectMatched.length;i++)
        	{
        		MatchedObj = Results.PerfectMatched[i];
        		DisplayMessage("Verifiying number of form elements in frame "+window1.location.href.toString()+" for the form: "+MatchedObj.firstElem.name );
        		res = CompareTwoFormsElements(window1,window2,MatchedObj.firstElem,MatchedObj.secondElem,MatchedObj.Index+1,MatchedObj.Index+1,this.reporter);
        		if(!res)
        			this.updateTransactionSeverity(this.CompareNrOfFormElements);
        	}
        }
        if(Results.Errors.Misplaced.length > 0)
				{
					for(i=0;i<Results.Errors.Misplaced.length;i++)
					{
						MatchedObj = Results.Errors.Misplaced[i];
						DisplayMessage("Verifiying number of form elements in frame "+window1.location.href.toString()+" for the form: "+MatchedObj.firstElem.name );
						res = CompareTwoFormsElements(window1,window2,MatchedObj.firstElem,MatchedObj.secondElem,MatchedObj.firstIndex+1,MatchedObj.secondIndex+1,this.reporter);
						if(!res)
							this.updateTransactionSeverity(this.CompareNrOfFormElements);
					}
    		}
        if(Results.PerfectMatched.length == 0 && Results.Errors.Misplaced.length == 0)
        {
        	DisplayMessage("Compare No. of Form Elements verification was not performed in frame "+window1.location+" because Compare Forms By Url verification failed for this frame and no forms matched");

        }
      }
    }
    else
    {
      if(this.CompareNrOfFormElements > 0 )
	  {
        res = this.cmpMatchedFormsElements(window1,window2,this.reporter);
        if(!res)
        	this.updateTransactionSeverity(this.CompareNrOfFormElements);
	  }
    }
}



function CmpLinksByUrl(window1,window2)
{
  DisplayMessage("Verifiying links by URL in frame "+window1.location);
  Results =IsAsmCollectionMatching(window1,window2,window1.document.links,window2.document.links,"LINK");

  if(AreErrors(Results.Errors))
	{
  	ReportErrors(window1,window2,Results.Errors,"LINK",this.reporter);
    DisplayMessage("Compare Links by URL verification failed in frame "+window1.location);
    this.updateTransactionSeverity(this.CompareLinksByUrl);
  }
}


function CmpNrOfFormElements(window1,window2) //the comparision will be done only if function CmpFormsByUrl succeeded
{
  if(this.CompareFormsByUrl != undefined && this.CompareFormsByUrl != DO_NOT_CHECK ) // in this case the CmpFormsByUrl function will do the verification.
    return;
  else  //the CmpFormsByUrl comparision wasn't performed
  {
    DisplayMessage("Matching forms by URL in frame "+window1.location+" to compare the number of elements in each form.");

    this.cmpFormsByUrl(window1,window2); 
  }
}



function CmpTableStructure(window1,window2)
{
	var Results,MatchedObj;
	var i,res;
	
	DisplayMessage("Verifiying table structure in frame "+window1.location);
	
	//performing the verification only if there is the same number of tables in both frames
	if(window1.document.wlTables.length != window2.document.wlTables.length)
	{
		DisplayMessage("Compare Table Structure verification was not performed in frame "+window1.location+" because the actual number of tables in this frame is not equal to the expected number of tables.");
 		return;
	}
	
	Results = IsCollectionMatching(window1.document.wlTables,window2.document.wlTables,"TABLE");
  if(AreErrors(Results.Errors))
  {
    ReportErrors(window1,window2,Results.Errors,"TABLE",this.reporter);
    this.updateTransactionSeverity(this.CompareTableStructure);
    if(Results.PerfectMatched.length > 0)  //continuing verification with the matched forms
		{
			for(i=0;i<Results.PerfectMatched.length;i++)
			{
			 	MatchedObj = Results.PerfectMatched[i];
			  DisplayMessage("Verifiying table structure in frame "+window1.location.href.toString()+" for the table: "+MatchedObj.firstElem.id );
			  res = CompareTwoTablesStructure(window1,window2,MatchedObj.firstElem,MatchedObj.secondElem,MatchedObj.Index+1,MatchedObj.Index+1,this.reporter);
			  if(!res)
			  	this.updateTransactionSeverity(this.CompareTableStructure);
			}
		}
		if(Results.Errors.Misplaced.length > 0)
		{
			for(i=0;i<Results.Errors.Misplaced.length;i++)
			{
				MatchedObj = Results.Errors.Misplaced[i];
				DisplayMessage("Comparing the matched tables structure in frame "+window1.location);
				res = CompareTwoTablesStructure(window1,window2,MatchedObj.firstElem,MatchedObj.secondElem,MatchedObj.firstIndex+1,MatchedObj.secondIndex+1,this.reporter);
				if(!res)
					this.updateTransactionSeverity(this.CompareTableStructure);
			}
    }
		if(Results.PerfectMatched.length == 0 && Results.Errors.Misplaced.length == 0)
		{
			DisplayMessage("CompareTableStructure verification wasn't performed in frame "+window1.location+" because the actual tables in this frame do not match the expected tables.");
    }
  }
  else
  {
  	res = this.cmpMatchedTablesStructure(window1,window2,this.reporter);
  	if(!res)
  		this.updateTransactionSeverity(this.CompareTableStructure);
  }
}

function CmpImagesByUrl(window1,window2)
{
	var Results;

	DisplayMessage("Verifiying images by URL in frame "+window1.location);
	Results = IsAsmCollectionMatching(window1,window2,window1.document.images,window2.document.images,"IMAGE");
	if(AreErrors(Results.Errors))
	{
  	DisplayMessage("Compare Images by URL verification failed in frame "+window1.location);
  	ReportErrors(window1,window2,Results.Errors,"IMAGE",this.reporter);
  	this.updateTransactionSeverity(this.CompareImagesByUrl);
	}
}

function CmpPageSize(window1,window2)
{
	var message;
	var url;
  
  url = "";	 
	DisplayMessage("Verifiying page size in frame "+window1.location);
	if(window1.document.wlSource.length != window2.document.wlSource.length)
	{
		message = "Compare Page Size verification failed in frame "+window1.location+". Expected length: "+window1.document.wlSource.length +". Actual length: "+window2.document.wlSource.length;
	  AddErrToReporter(FRAME_TYPE,CMP_PAGE_SIZE,url,-1,-1,message,this.reporter);
	  DisplayMessage(message);
	  this.updateTransactionSeverity(this.ComparePageSize);
  }
}



//the function is called from CompareFormsByUrl only if all the forms of the frame matched.
//otherwise CompareTwoFormsElements is called for every form that matched.

function CmpMatchedFormsElements(window1,window2,reporter)
{
  var i,index;
  var wereErrors = false;
  
  DisplayMessage("Verifiying number of form elements in frame "+window1.location.href.toString());
  for(i=0;i<window1.document.forms.length;i++)
  {
    if(!CompareTwoFormsElements(window1,window2,window1.document.forms[i], window2.document.forms[i],i+1,i+1,reporter))
    {
      wereErrors = true;
    }
  }
  if(wereErrors)
  {
    DisplayMessage("Compare No. of Form Elements verification failed in frame "+window1.location.href.toString());
    return false;
  }
  return true;
}


function CompareTwoFormsElements(window1,window2,form1,form2,index1,index2,reporter)
{
	var message;
	var url;
	  
  url = "";
	if(form1.elements.length != form2.elements.length)
	{
		message = "Error in form number "+index1+" named:"+form1.name+ ". Expected number of elements: "+form1.elements.length +". Actual number of elements: "+form2.elements.length;
		AddErrToReporter(FORM_TYPE,CMP_FORM_ELEMENTS,url,index1,index2,message,reporter);
		DisplayMessage(message);
		return false;
	}
	return true;
}



function CmpMatchedTablesStructure(window1,window2,reporter)
{
  var i,index;
  var wereErrors = false;
  
  for(i=0;i<window1.document.wlTables.length;i++)
  {
    if(!CompareTwoTablesStructure(window1,window2,window1.document.wlTables[i],window2.document.wlTables[i],i+1,i+1,reporter))
    { 
      wereErrors = true;
    }
  }
  if(wereErrors)
  {
    DisplayMessage("Compare Table Structure verification failed in frame "+window1.location.href.toString());
    return false;
  }
  return true;
}



function CompareTwoTablesStructure(window1,window2,table1,table2,index1,index2,reporter)
{
  var i;
  var rowIndex;
  var success = true;
  var message;
  var url;
	  
  url = "";
  if(table1.rows.length != table2.rows.length)
  {
    message = "Error in table number "+index1 + " with id: "+table1.id+" Expected number of rows: "+table1.rows.length+". Actual number of rows: "+table2.rows.length;
    AddErrToReporter(TABLE_TYPE,CMP_TABLE_STRUCTURE,url,index1,index2,message,reporter);
    DisplayMessage(message);
    return false;
  }
  for(i=0;i<table1.rows.length;i++)
    if(table1.rows[i].cells.length != table2.rows[i].cells.length)
    {
      rowIndex = i+1; 
      message = "Error in table number "+index1 + " with id: "+table1.id+" at row number "+rowIndex+". Expected number of cells: "+table1.rows[i].cells.length+". Actual number of cells: "+table2.rows[i].cells.length;
      AddErrToReporter(TABLE_TYPE,CMP_TABLE_STRUCTURE,url,index1,index2,message,reporter);
      DisplayMessage(message);
      success =false;    
    }
  if(success == false)  
    return false;    
  return true;  
}

function PrepareTextVerification()
{
  if(this.Properties.wlTextSearch==undefined)
  {
    var findIndex;
    var textToFindi,textNotToFindi;
    var textToFind,textNotToFind;

    this.Properties.wlTextSearch = wlGlobals.FuncVerification_TextSearch;
    this.Properties.TextToFind1 = wlGlobals.FuncVerification_TextToFind1;
    this.Properties.TextNotToFind1 = wlGlobals.FuncVerification_TextNotToFind1;
    
    findIndex = 2;
    textToFindi = "TextToFind2";
    textToFind = wlGlobals.FuncVerification_TextToFind2;
    while(textToFind != undefined && textToFind != "")
    {
      
      this.Properties[textToFindi] = textToFind;
      findIndex++;
      textToFindi = "TextToFind"+findIndex;
      textToFind = wlGlobals["FuncVerification_"+textToFindi];
    }
    findIndex = 2;
    textNotToFindi = "TextNotToFind2";
    textNotToFind = wlGlobals.FuncVerification_TextNotToFind2;
    while(textNotToFind != undefined && textNotToFind != "")
    {
      this.Properties[textNotToFindi] = textNotToFind;
      findIndex++;
      textNotToFindi = "TextNotToFind"+findIndex;
      textNotToFind = wlGlobals["FuncVerification_"+textNotToFindi];
    }
  }
}

function GlobalTextSearch(window2)
{
  var i;
  var message,textToFind,textNotToFind;
  var textDisplayed = 1000; //the number of characters displayed

  if(this.Properties.wlTextSearch!=undefined && this.Properties.wlTextSearch != DO_NOT_CHECK)
  {
    this.TextSearchReporter = new MyVerificationReporter("Global Text, "+window2.location.href,"Functional Test - Text search verification failed in window "+window2.location.href);

    this.nestedSearchText(window2);

    for(i=1;i<this.TextsToFind.length;i++)
    {
      if(this.TextsToFind[i] < 1)
      {
        textToFind = this.Properties["TextToFind"+i];
        if(textToFind.length > textDisplayed)
          textToFind = textToFind.substr(0,textDisplayed)+"...";
        message = "Text search verification failed. The text \""+textToFind+"\" was not found.";
        AddErrToReporter(FRAME_TYPE,TEXT_SEARCH,"",-1,-1,message,this.TextSearchReporter);
        DisplayMessage(message);
      }
      this.TextsToFind[i]=0;
    }

      for(i=1;i<this.TextsNotToFind.length;i++)
      {
        if(this.TextsNotToFind[i] > 0)
        {
          textNotToFind = this.Properties["TextNotToFind"+i];
          if(textNotToFind.length > textDisplayed)
            textNotToFind = textNotToFind.substr(0,textDisplayed)+"...";
          message = "Text search verification failed. The text \""+textNotToFind+"\" was found "+ this.TextsNotToFind[i]+" times in the actual page.";
          AddErrToReporter(FRAME_TYPE,TEXT_SEARCH,"",-1,-1,message,this.TextSearchReporter);
          DisplayMessage(message);
        }
        this.TextsNotToFind[i]=0;
      }

        if(this.TextSearchReporter.numErrors > 0)
        {
          this.TextSearchReporter.maxSeverity = this.Properties.wlTextSearch;
          this.TextSearchReporter.TextSearchReport(window2);
        }
  }
}

function NestedSearchText(window2)
{
  var i;

  DisplayMessage("Searching for text in frame "+window2.location.href);
  this.searchText(window2);

  if(window2.frames.length > 0)
    for(i=0;i<window2.frames.length;i++)
      this.nestedSearchText(window2.frames[i]);
}


function SearchText(window2)
{
  var textToFind,TextToFindi,textNotToFind,TextNotToFindi;
  var findIndex = 1;
  var doNotFindIndex = 1;


  textToFind = this.Properties.TextToFind1;
  textNotToFind = this.Properties.TextNotToFind1;
  while((textToFind != undefined && textToFind != "")||(textNotToFind != undefined && textNotToFind != ""))
  {
    this.textMatch(window2,textToFind,textNotToFind,findIndex);

    findIndex++;
    TextToFindi = "TextToFind"+findIndex;
    TextNotToFindi = "TextNotToFind"+findIndex;
    textToFind = this.Properties[TextToFindi];
    textNotToFind = this.Properties[TextNotToFindi];
  }

  if (findIndex == 1) // no text to find/notFind
  {
    message = "Text search verification failed. No input text to look for.";
    AddErrToReporter(FRAME_TYPE,TEXT_SEARCH,"",-1,-1,message,this.TextSearchReporter);
    DisplayMessage(message);
  }
}

function TextMatch(window2,textToFind,textNotToFind,findIndex)
{

  var find = true;
  var notFind = true;
  var escapedTextToFind,escapedTextNotToFind,escapedSource;
  var regFind,regNotFind;
  var resArrayFind,resArrayNotFind;
  var source;
  var regSpecialChars;
  var htmlElement;

  if(textToFind == undefined || textToFind =="")
    find = false;
  else
    textToFind = new String(textToFind); //textToFind is not necessarily a string - in case a function is used

  if(textNotToFind == undefined || textNotToFind =="")
    notFind = false;
  else
    textNotToFind = new String(textNotToFind);   //textNotToFind is not necessarily a string - in case a function is used

  htmlElement = window2.document;
  
  if(htmlElement == undefined)
    source = "";
  else
    source = htmlElement.wlSource;

  if(source == undefined)
    source = "";

  if(this.Properties.TextIgnoreWhitespaces != undefined && this.Properties.TextIgnoreWhitespaces)
  {
    //delete ALL white spaces
   if(find)
      escapedTextToFind = textToFind.replace(/[\s]+/mg,"");
    if(notFind)
      escapedTextNotToFind = textNotToFind.replace(/[\s]+/mg,"");

    escapedSource = source.replace(/[\s]+/mg,"");
  }
  else  //delete multiple white spaces
  {
    if(find)
      escapedTextToFind = textToFind.replace(/[\s]+/mg," ");
    if(notFind)
      escapedTextNotToFind = textNotToFind.replace(/[\s]+/mg," ");

    escapedSource = source.replace(/[\s]+/mg," ");
  }

  //replacing the special characters of regular expressions with their ascii value.
  regSpecialChars = /([\.\?\/\\\[\]\{\}\(\)\+\*\|\^\$])/gm ;

  if(find)
  {
    escapedTextToFind = escapedTextToFind.replace(regSpecialChars, "\\$1");
  }
  if(notFind)
  {
    escapedTextNotToFind = escapedTextNotToFind.replace(regSpecialChars, "\\$1");
  }


  //if it's undefined it means it comes from the globals
  if(this.Properties.TextCaseSensitive == undefined || this.Properties.TextCaseSensitive == true)
  {
    if(find)
      regFind = new RegExp(escapedTextToFind,"gm");
    if(notFind)
      regNotFind = new RegExp(escapedTextNotToFind,"gm");
  }
  else //case insensitive
  {
    if(find)
      regFind = new RegExp(escapedTextToFind,"gim");
    if(notFind)
      regNotFind = new RegExp(escapedTextNotToFind,"gim");
  }

  if(find)
  {
    resArrayFind = escapedSource.match(regFind);
    if(!resArrayFind)
    {
      if(this.TextsToFind[findIndex] == undefined)
        this.TextsToFind[findIndex] = 0;
    }
    else
    {
      if(this.TextsToFind[findIndex] == undefined)
        this.TextsToFind[findIndex] = resArrayFind.length;
      else
        this.TextsToFind[findIndex] += resArrayFind.length;
    }
  }
  if(notFind)
  {
    resArrayNotFind = escapedSource.match(regNotFind);
    if(!resArrayNotFind)
    {
      if(this.TextsNotToFind[findIndex] == undefined)
        this.TextsNotToFind[findIndex] = 0;
    }
    else
    {
      if(this.TextsNotToFind[findIndex] == undefined)
        this.TextsNotToFind[findIndex] = resArrayNotFind.length;
      else
        this.TextsNotToFind[findIndex] += resArrayNotFind.length;
    }
  }
}


function CmpInNestedFrames( window1,window2)
{
  var i;
  var Results,MatchedObj;
  var status;
	
  status = Math.floor(window2.document.wlStatusNumber/100);
  if(status == 4 || status == 5|| status == 0) //http errors
  	DisplayMessage("Functional test was not performed in frame "+window2.location+" because of HTTP error.");
  else
  	this.executeFunctions(window1,window2);
	
  if(window1.frames.length > 0 || window2.frames.length > 0)
  {
    Results = IsAsmCollectionMatching(window1,window2,window1.frames, window2.frames,"FRAME");
    if(AreErrors(Results.Errors) == false)
    {  
       if(this.reporter.numErrors > 0)
  			this.reporter.Report(window1,window2);
       for(i=0;i<window1.frames.length;i++)    
       {
        this.cmpInNestedFrames(window1.frames[i],window2.frames[i]); 
       }
    }
    else
    {
      ReportErrors(window1,window2,Results.Errors,"FRAME",this.reporter);
      if(this.reporter.numErrors > 0)
  			this.reporter.Report(window1,window2);
      DisplayMessage("Frames in frame "+window1.location+" do not match.");
      if(Results.PerfectMatched.length > 0)
      {
 				for(i=0;i<Results.PerfectMatched.length;i++)
				{
					MatchedObj = Results.PerfectMatched[i];
					DisplayMessage("Verifiying the frames in frame: "+window1.location);
					this.cmpInNestedFrames(MatchedObj.firstElem,MatchedObj.secondElem);
			  }
      }
      if(Results.Errors.Misplaced.length > 0)
			{
				for(i=0;i<Results.Errors.Misplaced.length;i++)
				{
					MatchedObj = Results.Errors.Misplaced[i];
					DisplayMessage("Verifiying the frames in frame: "+window1.location);
					this.cmpInNestedFrames(MatchedObj.firstElem,MatchedObj.secondElem);
				}
      }
 	  }
 	}
 	else if(this.reporter.numErrors > 0)
  	this.reporter.Report(window1,window2);
}



function UpdateTransactionSeverity(severity)
{
	if(severity == 	REPORT_AS_MINOR_ERROR)
		if(this.reporter.maxSeverity != WLSevereError && this.reporter.maxSeverity != WLError)
			this.reporter.maxSeverity = WLMinorError;
	if(severity == REPORT_AS_ERROR)
		if(this.reporter.maxSeverity != WLSevereError)
			this.reporter.maxSeverity = WLError;
	if(severity == REPORT_AS_SEVERE_ERROR)
		this.reporter.maxSeverity = WLSevereError;
}

//if the user specified at least one verification as true or false the
//variable wasSpecified will get the value of true and only the verifications
//specifically asked for by the user will be done. Otherwise all existing
//verification will be performed.

function doVerification()
{
  var wasSpecified = false;
  var frame1,frame2;
   
   //checking whether any verification was requested
	  
	if( this.CompareTitle != undefined ||
			this.CompareNrOfLinks != undefined ||
	  	this.CompareNrOfImages != undefined ||
	    this.CompareNrOfFrames != undefined ||
	    this.CompareNrOfTables != undefined ||
	    this.CompareNrOfForms != undefined ||
	    this.CompareFormsByUrl != undefined ||
	    this.CompareNrOfFormElements != undefined ||
	    this.CompareLinksByUrl != undefined ||
	    this.CompareTableStructure != undefined ||
	    this.CompareImagesByUrl != undefined 
	    //||
	    //this.ComparePageSize != undefined 
	    )
	{
	 	wasSpecified = true;
  }
  
  if(!wasSpecified) //all the verifications will be performed
	{
	  this.CompareTitle = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfLinks = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfImages = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfFrames = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfTables = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfForms = REPORT_AS_MINOR_ERROR;
	  this.CompareFormsByUrl = REPORT_AS_MINOR_ERROR;
	  this.CompareNrOfFormElements = REPORT_AS_MINOR_ERROR;
	  this.CompareLinksByUrl = REPORT_AS_MINOR_ERROR;
	  this.CompareTableStructure = REPORT_AS_MINOR_ERROR;
	  this.CompareImagesByUrl = REPORT_AS_MINOR_ERROR;
	  //this.ComparePageSize = REPORT_AS_MINOR_ERROR;
	}

		
	if(this.NestedCompare == true)
	{
		this.cmpInNestedFrames(this.ExpectedDom,this.ActualDom);
	}
	else
	{
		this.executeFunctions(this.ExpectedDom,this.ActualDom);
		if(this.reporter.numErrors > 0)
			this.reporter.Report(this.ExpectedDom,this.ActualDom);
	}
} 


function ExecuteFunctions(window1,window2)
{
		
    if(this.CompareTitle!=undefined && this.CompareTitle != DO_NOT_CHECK )
    {
    	this.cmpTitle(window1,window2);
    }
    if(this.CompareNrOfLinks!=undefined && this.CompareNrOfLinks != DO_NOT_CHECK)
    { 
      this.cmpNrOfLinks(window1,window2);
    }  
    if(this.CompareNrOfImages!=undefined && this.CompareNrOfImages != DO_NOT_CHECK)
    { 
      this.cmpNrOfImages(window1,window2);
    }  
    if(this.CompareNrOfFrames!=undefined && this.CompareNrOfFrames != DO_NOT_CHECK)
    {  
      this.cmpNrOfFrames(window1,window2);
    }  
    if(this.CompareNrOfTables!=undefined && this.CompareNrOfTables != DO_NOT_CHECK)
		{  
		  this.cmpNrOfTables(window1,window2);
    }  
    if(this.CompareNrOfForms!=undefined && this.CompareNrOfForms != DO_NOT_CHECK)
    {  
      this.cmpNrOfForms(window1,window2);
    }  
    if(this.CompareFormsByUrl!=undefined && this.CompareFormsByUrl != DO_NOT_CHECK)
    { 
      this.cmpFormsByUrl(window1,window2);
    }  
    if(this.CompareNrOfFormElements!=undefined && this.CompareNrOfFormElements != DO_NOT_CHECK)
    {  
      this.cmpNrOfFormElements(window1,window2);
    }  
    if(this.CompareLinksByUrl!=undefined && this.CompareLinksByUrl != DO_NOT_CHECK)
    {  
      this.cmpLinksByUrl(window1,window2);
    }  
    if(this.CompareTableStructure!=undefined && this.CompareTableStructure != DO_NOT_CHECK)
    {  
      this.cmpTableStructure(window1,window2);
    }  
  	if(this.CompareImagesByUrl!=undefined && this.CompareImagesByUrl != DO_NOT_CHECK)
		{  
		  this.cmpImagesByUrl(window1,window2);
    }  
    /*if(this.ComparePageSize!=undefined && this.ComparePageSize != DO_NOT_CHECK)
		{  
		  this.cmpPageSize(window1,window2);
    }*/  
}

// constructor function for the Verification class

function Verification()
{

  this.Verify=doVerification;
  this.NestedCompare=true;
  this.reporter = new MyVerificationReporter("Functional Test");
	
	
  this.cmpTitle=CmpTitle;
  this.cmpNrOfLinks=CmpNrOfLinks;
  this.cmpNrOfImages=CmpNrOfImages;
  this.cmpNrOfFrames=CmpNrOfFrames;
  this.cmpNrOfTables=CmpNrOfTables;
  this.cmpNrOfForms=CmpNrOfForms;
  this.cmpFormsByUrl=CmpFormsByUrl;
  this.cmpLinksByUrl=CmpLinksByUrl;
  this.cmpNrOfFormElements=CmpNrOfFormElements;
  this.cmpMatchedFormsElements=CmpMatchedFormsElements; 
  this.cmpTableStructure=CmpTableStructure;
  this.cmpMatchedTablesStructure=CmpMatchedTablesStructure;
  this.cmpImagesByUrl=CmpImagesByUrl;
  this.cmpPageSize=CmpPageSize;
  
  this.cmpInNestedFrames=CmpInNestedFrames;
  this.executeFunctions=ExecuteFunctions;
  this.updateTransactionSeverity=UpdateTransactionSeverity;
  this.prepareTextVerification = PrepareTextVerification;
  this.globalTextSearch = GlobalTextSearch;
  this.nestedSearchText = NestedSearchText; //for global text - more than one text
  this.searchText = SearchText;
  this.textMatch = TextMatch;

  this.Properties = new Object;
  this.TextsToFind = new Array;
  this.TextsNotToFind = new Array;
}


