/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <thr.h>
#include <collint.h>
#include <ordered.h>
#include <collstr.h>
#include <thr.h>
#include <thr.h>

#ifdef __TV_UNIX__
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#endif

class CWLHttpRequest {

public:
  CWLHttpRequest(int SleepTime);
  ~CWLHttpRequest();
	void SlaveThread();
	void startSlave();
private:
	int	m_SleepTime;
};

CWLHttpRequest::CWLHttpRequest(int SleepTime) : m_SleepTime(SleepTime){}

void CWLHttpRequest::SlaveThread()
{
	try {
		startSlave();
	}
	catch (...) {
	}
}

void CWLHttpRequest::startSlave()
{
#ifdef __TV_WINDOWS__

#endif

	do {
		::rvSleep(m_SleepTime);
	} while (true);
}


int main(int argc, char *argv[])
{
	int									MAX_THREADS = 20000;
	int									SleepTime = 5000;
	CWLHttpRequest**    m_Request;
	RVThread**          m_RequestThread;
	int									i;
	bool								done = false;
	size_t							reserveSize;
	RWThreadAttribute		threadAtt;

	if (argc > 1) {
		const char * helpV = argv[1];
		sscanf(helpV, "%d", &MAX_THREADS);
		if (argc > 2) {
			if (threadAtt.canSetStackReserveSize()) {
				const char * helpV = argv[2];
				sscanf(helpV, "%d", &reserveSize);
				threadAtt.setStackReserveSize(reserveSize);
			}
		}
		if (argc > 3) {
			const char * helpV = argv[3];
			sscanf(helpV, "%d", &SleepTime);
		}
	}

	m_Request = (CWLHttpRequest**)malloc(MAX_THREADS * sizeof(CWLHttpRequest*));

	m_RequestThread = (RVThread**)malloc(MAX_THREADS * sizeof(RVThread*));

	try 
	{
		for (i=0; i<MAX_THREADS;i++) {

			m_Request[i] = new CWLHttpRequest (SleepTime);

			m_RequestThread[i] = new RVThread;

			#if !defined(RV_THR_CANT_EXTRACT_TEMPLATE_ARGS_FROM_SIGNATURE)            
					*m_RequestThread[i] = rvMakeThreadFunction(*m_Request[i], &CWLHttpRequest::SlaveThread);
			#else
					*m_RequestThread[i] = rvMakeThreadFunctionM(CWLHttpRequest, *m_Request[i], int, &CWLHttpRequest::SlaveThread);
			#endif

			m_RequestThread[i]->start();
			cout << " Thread  " << i << "  Started ..." << '\n' << flush;
		}

		do {
			::rvSleep(SleepTime);
		} while (true);
	}
	catch (RVTHRInvalidPointer e) {
			cout << " RVTHRInvalidPointer Exception raised at : " << i << '\n' << flush;
	}
	catch (RVTHRThreadActive e) {
			cout << " RVTHRThreadActive Exception raised at : " << i << '\n' << flush;
	}
	catch (RVTHRResourceLimit e) {
		 	cout << " RVTHRResourceLimit Exception raised at : " << i << '\n' << flush;
	}
	catch (RVTHRInternalError e) {
			cout << " RVTHRInternalError Exception raised at : " << i << '\n' << flush;
	}
	catch (...) {
			cout << " Unknown Exception raised at : " << i << '\n' << flush;
	}

cout << flush ;

#ifndef __TV_UNIX__
	TerminateProcess(GetCurrentProcess(),0);
#else
	kill(getpid(), SIGKILL);
#endif
	return 0;
}
