/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// OutputBuf.cpp: implementation of the OutputBuf class.
//
//////////////////////////////////////////////////////////////////////

#include "OutputBuf.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OutputBuf::OutputBuf(const char* cFileName/*NULL*/)
{
  m_bOpen = false ;

  SetOutput(cFileName);
}


OutputBuf::~OutputBuf()
{}



bool OutputBuf::SetOutput(const char *cFileName/*NULL*/)
{
  ResetOutput();
  m_bOpen = true ;

  return IsOpen();
}

bool OutputBuf::ResetOutput()
{
  m_Output = "" ;
  m_bOpen = false ;

  return !IsOpen();
}

void OutputBuf::Write(const char* pch, int nCount)
{
  if (IsOpen())
    m_Output.append(pch, nCount);
}

int OutputBuf::GetLength()
{
  return m_Output.length();
}

const char* OutputBuf::GetData()
{
  return m_Output.data();
}



