/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef HEADER_CLoadProbingClientUITest
#define HEADER_CLoadProbingClientUITest

#include "rtamscript.h"
#include "HttpCallback.h"

//#include <rw/gslist.h>
#include <tptrslist.h>

class CScriptFile;
//declare(RWGSlist, CScriptFile)

class CScriptFile: public iAgendaFile, public RVCollectable {

public:

	explicit CScriptFile(const char*);
	virtual ~CScriptFile();

	const char* fGetName() const;
	
	void fSourceExport( iEmbedderCallContext&, iSourceCommit& );
	
private:
	RVCString m_Name;
};  


/*
class cStubEmbedderReportInfo:
	public iLoadEmbedderReportInfo {

public:
	explicit cStubEmbedderReportInfo(const char*);
	const char* fGetMessage() const;
		
private:
	const char* mMessage;

	};

*/

class IGeneralProbingClientUITest{

protected:
	static RVCString fsReportFormat( WLLogMessage::Severity, const char* );
};


/*
	class
cPCUi: public iLoadProbingClient, RV_INHERIT_PROTECTED iGeneralUi {

public:

	explicit cPCUi();

	virtual ~cPCUi();

	iAgendaFile* fGetFile( bool&, iEmbedderCallContext&, const char*);

	void fCopyFile( iEmbedderCallContext&, const char*, const char* );


	void fScriptHook(cScript&,iFile&,const char*,tLineNumber,tLineNumber);

	void fReporter( WLLogMessage::Severity, const char* );

	tSCActionReporterReturn fStubEmbedderReporter(iFile&,tLineNumber,tColumn,const char*,iSCActionReportInfo&);
		
	tReporterReturn fReporter(iFile&,tLineNumber,tColumn,const char*,iReportInfo&);
	void fReportDMHook(tInterruptionControl&,iFile&,tLineNumber);
	tNormalDMHookReturn vInterruptDMHook_iLoadProbingClient(tInterruptionControl&,iFile&,tLineNumber);
	tNormalDMHookReturn fBreakPointDMHook(tInterruptionControl&,iFile&,tLineNumber);
	tNormalDMHookReturn fKeywordDMHook(tInterruptionControl&,iFile&,tLineNumber);
	tThrowDMHookReturn fThrowDMHook(tInterruptionControl&,iFile&,tLineNumber);

	void fSetDebugger(iDebugger&,nMT::cSStm&);

protected:

	tNormalDMHookReturn fDMHookX2(tInterruptionControl&,const char*,iFile&,tLineNumber);

	bool fDMHookX1(tInterruptionControl&,const char*,iFile&,tLineNumber);
	
	bool fDMHookX0(const char*,iFile&,tLineNumber,tInterruptionControl&);

	void fBeforeInitAgenda( iInterruptionControlCommit& );
	void fBeforeTerminateAgenda( iInterruptionControlCommit& );
	void fBeforeOnErrorTerminateAgenda( iInterruptionControlCommit& );
	void fBeginClient( iInterruptionControlCommit& );
	void fBeforeInitClient( iInterruptionControlCommit& );
	void fBeforeTerminateClient( iInterruptionControlCommit& );
	void fBeforeOnErrorTerminateClient( iInterruptionControlCommit& );
	bool fBeforeRound( unsigned long, iInterruptionControlCommit& );
	void fBeforeOnScriptAbort( iInterruptionControlCommit& );
	void fEndClient( iInterruptionControlCommit& );
		


private:
	nMT::cSStm* mSStm;
	iDebugger* mDebugger;

	std::list< std::auto_ptr<cScriptFile> > mFiles;


	};
*/





class ILoadProbingClientUITest: RV_INHERIT_PROTECTED IGeneralProbingClientUITest, RV_INHERIT_PROTECTED iHttpProbingClient
{

public:

	explicit ILoadProbingClientUITest( cSingleClientProcess&, int nRoundsToDo=0);
	virtual ~ILoadProbingClientUITest();

	void fCopyFile( iEmbedderCallContext&, const char*, const char* );

	void fBeforeInitAgenda( iInterruptionControlCommit& );
	void fBeforeTerminateAgenda( iInterruptionControlCommit& );
	void fBeforeOnErrorTerminateAgenda( iInterruptionControlCommit& );
 	void fBeginClient( iInterruptionControlCommit& );
 	void fBeforeInitClient( iInterruptionControlCommit& );
	void fBeforeTerminateClient( iInterruptionControlCommit& );
	void fBeforeOnErrorTerminateClient( iInterruptionControlCommit& );
	bool fBeforeRound( unsigned long, iInterruptionControlCommit& );
	void fBeforeOnScriptAbort( iInterruptionControlCommit& );
 	void fEndClient( iInterruptionControlCommit& );

	void fReporter(WLLogMessage::Severity,const char *);

	iAgendaFile* fGetFile( bool& IsNew, iEmbedderCallContext&ecx, const char* Name) ;

////////////////Debugger's pure virtual functions : 
/*
	void fReporter( WLLogMessage::Severity, const char* );
*/



	void fScriptHook( iScriptHookable&, bool Creating );

	tSCActionReporterReturn fStubEmbedderReporter(iFile&,tLineNumber,tColumn,const char*,iSCActionReportInfo&);

	void fReporter(iReportInfo&);
	void fReportDMHook( tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState& );
	tNormalDMHookReturn vInterruptDMHook_iLoadProbingClient( tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState& );
	tNormalDMHookReturn fBreakPointDMHook( tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState& );
	tNormalDMHookReturn fKeywordDMHook( tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState& );
	tThrowDMHookReturn fThrowDMHook( tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState& );
  void fExecReporter(iReportThreadState* rThreadState,iReportInfo& rInfo );
  tDebugReporterReturn fDebugReporter(	iReportThreadState& rThreadState,	iReportInfo& rReportInfo );

	tNormalDMHookReturn fDMHookX2(tInterruptionControl&,const char*, iDMThreadState& );
	bool fDMHookX1(tInterruptionControl&,const char*, iDMThreadState& );
	bool fDMHookX0(const char*, iDMThreadState& ,tInterruptionControl&);


private:
	//RWGSlist(CScriptFile) m_FileList;
	RVTPtrSlist<CScriptFile> m_FileList;
	int m_RoundsToDo;



};




#endif HEADER_CLoadProbingClientUITest
