/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// general functions
#define wl_valueOf_str	"valueOf"
#define wl_toString_str	"toString"
#define wl_Clone_str		"Clone"

//html props
#define WLJSNAME_PROP_SRC															"src"
#define WLJSNAME_PROP_ID															"id"
#define WLJSNAME_PROP_INNERHTML												"innerHTML"

//class WLXml	
#define WLJSNAME_PROP_DOCUMENTELEMENT									"documentElement"
#define WLJSNAME_PROP_XMLDOCUMENT											"XMLDocument"

//class WLXmlDocument props 
#define WLJSNAME_PROP_ASYNC														"async"
#define WLJSNAME_PROP_DOCTYPE													"doctype"
#define WLJSNAME_PROP_DOCUMENTELEMENT									"documentElement"
#define WLJSNAME_PROP_IMPLEMENTATION									"implementation"
#define WLJSNAME_PROP_ONDATAAVAILABLE									"ondataavailable"  //property
#define WLJSNAME_PROP_ONREADYSTATECHANGE							"onreadystatechange"//property
#define WLJSNAME_PROP_ONTRANSFORMNODE									"ontransformnode"   //property
#define WLJSNAME_PROP_PARSEERROR											"parseError"				//object w/last parse error
#define WLJSNAME_PROP_PRESERVEWHITESPACE							"preserveWhiteSpace"
#define WLJSNAME_PROP_READYSTATE											"readyState"
#define WLJSNAME_PROP_RESOLVEEXTERNALS								"resolveExternals"
#define WLJSNAME_PROP_URL															"url"
#define WLJSNAME_PROP_VALIDATEONPARSE									"validateOnParse"

//class WLXmlDocument methods
#define WLJSNAME_METHOD_ABORT													"abort"
#define WLJSNAME_METHOD_CREATEATTRIBUTE								"createAttribute"
#define WLJSNAME_METHOD_CREATECDATASECTION						"createCDATASection"
#define WLJSNAME_METHOD_CREATECOMMENT									"createComment"
#define WLJSNAME_METHOD_CREATEDOCUMENTFRAGMENT				"createDocumentFragment"
#define WLJSNAME_METHOD_CREATEELEMENT									"createElement"
#define WLJSNAME_METHOD_CREATEENTITYREFERENCE					"createEntityReference"
#define WLJSNAME_METHOD_CREATENODE										"createNode"
#define WLJSNAME_METHOD_CREATEPROCESSINGINSTRUCTION		"createProcessingInstruction"
#define WLJSNAME_METHOD_CREATETEXTNODE								"createTextNode"
#define WLJSNAME_METHOD_GETELEMENTSBYTAGNAME					"getElementsByTagName"
#define WLJSNAME_METHOD_LOAD													"load"
#define WLJSNAME_METHOD_LOADXML												"loadXML"
#define WLJSNAME_METHOD_NODEFROMID										"nodeFromID"
#define WLJSNAME_METHOD_SAVE													"save"

//class WLXmlDocument events
#define WLJSNAME_PROP_ONDATAAVAILABLE									"ondataavailable"  //event 
#define WLJSNAME_PROP_ONREADYSTATECHANGE							"onreadystatechange"//event 
#define WLJSNAME_PROP_ONTRANSFORMNODE									"ontransformnode"   //event 

//class WLXmlDocumentType props
#define WLJSNAME_PROP_NAME														"name"
#define WLJSNAME_PROP_NOTATIONS												"notations"
#define WLJSNAME_PROP_ENTITIES												"entities"

//class WLXmlElement props
#define WLJSNAME_PROP_TAGNAME													"tagName"

//class WLXmlElement methods
#define WLJSNAME_METHOD_GETATTRIBUTE									"getAttribute"
#define WLJSNAME_METHOD_GETATTRIBUTE_NODE							"getAttributeNode"
#define WLJSNAME_METHOD_GETELEMENTS_BY_TAGNAME				"getElementsByTagName"
#define WLJSNAME_METHOD_NORMALIZE											"normalize"
#define WLJSNAME_METHOD_REMOVEATTRIBUTE								"removeAttribute"
#define WLJSNAME_METHOD_REMOVEATTRIBUTE_NODE					"removeAttributeNode"
#define WLJSNAME_METHOD_SETATTRIBUTE									"setAttribute"
#define WLJSNAME_METHOD_SETATTRIBUTE_NODE							"setAttributeNode"

//class WLXmlParseError props
#define WLJSNAME_PROP_ERRORCODE												"errorCode"
#define WLJSNAME_PROP_FILEPOS													"filePos"
#define WLJSNAME_PROP_LINE														"line"					
#define WLJSNAME_PROP_LINEPOS													"linePos"	
#define WLJSNAME_PROP_REASON													"reason"
#define WLJSNAME_PROP_SRCTEXT													"srcText"
#define WLJSNAME_PROP_URL															"url"

//class WLXmlNameNodeMap props
#define WLJSNAME_PROP_LENGTH													"length"

//class WLXmlNode properties
#define WLJSNAME_PROP_ATTRIBUTES											"attributes"
#define WLJSNAME_PROP_BASENAME												"baseName"
#define WLJSNAME_PROP_CHILDNODES											"childNodes"
#define WLJSNAME_PROP_DATATYPE												"dataType"
#define WLJSNAME_PROP_DEFINITION											"definition"
#define WLJSNAME_PROP_FIRSTCHILD											"firstChild"
#define WLJSNAME_PROP_LASTCHILD 											"lastChild"
#define WLJSNAME_PROP_NEXTSIBLING											"nextSibling"
#define WLJSNAME_PROP_NODENAME												"nodeName"
#define WLJSNAME_PROP_NODETYPE												"nodeType"
#define WLJSNAME_PROP_NAMESPACEURI										"namespaceURI"
#define WLJSNAME_PROP_NODETYPESTRING									"nodeTypeString"
#define WLJSNAME_PROP_NODETYPEDVALUE									"nodeTypedValue"
#define WLJSNAME_PROP_NODEVALUE												"nodeValue"
#define WLJSNAME_PROP_OWNERDOCUMENT										"ownerDocument"
#define WLJSNAME_PROP_PARENTNODE											"parentNode"
#define WLJSNAME_PROP_PARSED													"parsed"
#define WLJSNAME_PROP_PREFIX													"prefix"
#define WLJSNAME_PROP_PREVIOUSSIBLING									"previousSibling"
#define WLJSNAME_PROP_SPECIFIED												"specified"
#define WLJSNAME_PROP_TEXT														"text"
#define WLJSNAME_PROP_XML															"xml"

//class WLXmlAttribute
#define WLJSNAME_PROP_VALUE														"value"

//class WLxmlCharcterData
#define WLJSNAME_PROP_DATA														"data"

//class WLXmlEntity
#define WLJSNAME_PROP_PUBLICID												"publicId"
#define WLJSNAME_PROP_SYSTEMID												"systemId"
#define WLJSNAME_PROP_NOTATIONNAME										"notationName"

#define WLJSNAME_PROP_TARGET														"target"
