/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <ace/OS.h>
#include "wlxmlcom.h"
#include "wlxmlfuncs.h"
#include <string.h>
#include <RVCString.h>
#include "rvjsapi.h"
#include "wlxmlfuncs.h"
#include "xmlreplyprops.h"
#include "xmlerrorreporter.h"
#include "jsxmlreplynames.h"
#include "jsxmlprivate.h"
#include "jsxmlwrappers.h"
#include "tracedll.h"
#ifdef _DEBUG
#include <iostream.h>
#endif


JSBool
xmlattribute_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	TRY_COM{
		WlTraceMsg("Inside xmlattribute_getProperty");
		IXMLDOMAttributePtr pAttributeInterface = pNodePtr;
		if ((pAttributeInterface != NULL) && JSVAL_IS_STRING(id)) {
			JSString* str = JSVAL_TO_STRING(id);
			char* prop = JS_GetStringBytes(str);
			if (!strcmp(prop, WLJSNAME_PROP_NAME)) {	
				_bstr_t name;
				name = pAttributeInterface->Getname();
				return WLXmlSetStringValue( cx,	obj, NULL, (char*)name, vp);
			}
			else if (!strcmp(prop, WLJSNAME_PROP_VALUE)) {	
				_variant_t var;
				var = pAttributeInterface->Getvalue();
				return WLXmlSetVariantValue(cx, obj, var, vp);
			} 	
		}
		return JS_TRUE;
	}
	CATCH_COM(cx)
}

JSBool
xmlattribute_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{

	TRY_COM{
		WlTraceMsg("Inside xmlattribute_setProperty");
		IXMLDOMAttributePtr pAttributeInterface = pNodePtr;
		if ((pAttributeInterface != NULL) && JSVAL_IS_STRING(id) && vp) {
		JSString* str = JSVAL_TO_STRING(id);
		char* prop = JS_GetStringBytes(str);
		if (!strcmp(prop, WLJSNAME_PROP_VALUE)) {				
			_variant_t var;
			if(WLXmlJsvalToVariant(*vp, var))
					pAttributeInterface->Putvalue(var);
        else {
          WlAssert(piHLErrorReporter);
					return piHLErrorReporter->ReportXMLError(cx, XML_ERROR_FILE, 15);
        }
			}
		}
		
	return JS_TRUE;
	}
	CATCH_COM(cx)
}
