/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <ace/OS.h>
#include "wlxmlcom.h"
#include "wlxmlfuncs.h"
#include <string.h>
#include "rvjsapi.h"
#include "xmlreplyprops.h"
#include "jsxmlreplynames.h"
#include "jsxmlprivate.h"
#include "jsxmlwrappers.h"

JSBool
xmldocumenttype_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	TRY_COM {
		WlTraceMsg("Inside xmldocumenttype_getProperty");
		IXMLDOMDocumentTypePtr pDocType = pNodePtr;
		if ((pDocType != NULL) && JSVAL_IS_STRING(id)) {
			JSString* str = JSVAL_TO_STRING(id);
			char* prop = JS_GetStringBytes(str);
			if (!strcmp(prop, WLJSNAME_PROP_NAME)) {		
				_bstr_t name = pDocType->Getname();
				return WLXmlSetStringValue(cx, obj, prop, (char*)name, vp);
			}
			else if (!strcmp(prop, WLJSNAME_PROP_ENTITIES)) {	
				IXMLDOMNamedNodeMapPtr* pNamedMapPtr  = new IXMLDOMNamedNodeMapPtr;
				*pNamedMapPtr = pDocType->Getentities();
				CWLXmlNamedNodeMapWrapper* wrapper  = new CWLXmlNamedNodeMapWrapper(pNamedMapPtr);
				return WLXmlSetNamedNodeMapInterfaceValue(cx, obj,wrapper, vp);
			}
			else if (!strcmp(prop, WLJSNAME_PROP_NOTATIONS)) {	
				IXMLDOMNamedNodeMapPtr* pNamedMapPtr  = new IXMLDOMNamedNodeMapPtr;
				*pNamedMapPtr = pDocType->Getnotations();
				CWLXmlNamedNodeMapWrapper* wrapper  = new CWLXmlNamedNodeMapWrapper(pNamedMapPtr);
				return WLXmlSetNamedNodeMapInterfaceValue(cx, obj,wrapper, vp);
			}
		}
		return JS_TRUE;
	}
	CATCH_COM(cx)
}

JSBool
xmldocumenttype_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr){
	WlTraceMsg("Inside xmldocumenttype_setProperty");
	return JS_TRUE;
}


