/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <ace/OS.h>
#include "wlxmlcom.h"
#include "wlxmlfuncs.h"
#include <string.h>
#include <RVCString.h>
#include "rvjsapi.h"

#include "xmlreplyprops.h"
#include "jsxmlreplynames.h"
#include "jsxmlprivate.h"
#include "jsxmlwrappers.h"
#ifdef _DEBUG
#include <iostream.h>
#endif


JSBool
xmlentity_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	TRY_COM {
		WlTraceMsg("Inside xmlentity_getProperty");
		if ((pNodePtr != NULL) && JSVAL_IS_STRING(id)) {
			IXMLDOMEntityPtr entityPtr = pNodePtr;
			JSString* str = JSVAL_TO_STRING(id);
			char* prop = JS_GetStringBytes(str);
			if (!strcmp(prop, WLJSNAME_PROP_PUBLICID)) {
				_variant_t publicId = entityPtr->GetpublicId();
				return WLXmlSetVariantValue(cx, obj, publicId, vp);				
			}
			else if (!strcmp(prop, WLJSNAME_PROP_SYSTEMID)) {	
				_variant_t systemId = entityPtr->GetsystemId();
				return WLXmlSetVariantValue(cx, obj, systemId, vp);				
			}
			else if (!strcmp(prop, WLJSNAME_PROP_NOTATIONNAME)) {	
				_bstr_t notation = entityPtr->GetnotationName();
				return WLXmlSetStringValue(cx, obj, NULL, (char*)notation, vp);
			}	
		}
		return JS_TRUE;
	}
	CATCH_COM(cx)
}

JSBool
xmlentity_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	WlTraceMsg("Inside xmlentity_setProperty");
	return JS_TRUE;
}

