/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <ace/OS.h>
#include "wlxmlcom.h"
#include "wlxmlfuncs.h"
#include <string.h>
#include <RVCString.h>
#include "rvjsapi.h"

#include "xmlreplyprops.h"
#include "jsxmlreplynames.h"
#include "jsxmlprivate.h"
#include "jsxmlwrappers.h"
#ifdef _DEBUG
#include <iostream.h>
#endif
#include "xmlerrorreporter.h"
#include "tracedll.h"

JSBool
xmltext_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	WlTraceMsg("Inside xmltext_getProperty");
	return xmlcharacterdata_getProperty(cx, obj, id, vp, pNodePtr);
}

JSBool
xmltext_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr)
{
	WlTraceMsg("Inside xmltext_setProperty");
	return xmlcharacterdata_setProperty(cx, obj, id, vp, pNodePtr);
}

JSBool
xmltext_splitText(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr)
{
  WlAssert(piHLErrorReporter);
	TRY_COM {
		WlTraceMsg("Inside xmltext_setProperty");	
		if(argc != 1)//error
			return piHLErrorReporter->ReportXMLError(cx, XML_ERROR_FILE, 12, "splitText", 1);
		if(!JSVAL_IS_INT(argv[0]))
			return piHLErrorReporter->ReportXMLError(cx, XML_ERROR_FILE, 13, "splitText");
		IXMLDOMTextPtr textNodePtr	=  pNodePtr;
		jsint offset = JSVAL_TO_INT(argv[0]);
		IXMLDOMNodePtr* nodePtr = new IXMLDOMNodePtr;
		*nodePtr  = textNodePtr->splitText((long)offset);
		CWLXmlNodeWrapper* returnNodeWrapper = new CWLXmlNodeWrapper(nodePtr);
		return WLXmlSetNodeInterfaceValue(cx, obj, returnNodeWrapper, rval);
	}
	CATCH_COM(cx)
}

