/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "xmlerrorreporter.h"
#include "tracedll.h"

iXMLVirtualErrorReporter* piHLErrorReporter = NULL;

iXMLVirtualErrorReporter::iXMLVirtualErrorReporter(){
}

iXMLVirtualErrorReporter::~iXMLVirtualErrorReporter(){
}

int iXMLVirtualErrorReporter::ReportXMLError(JSContext* cx, const char* frmName, int frmId, ...){
  WLLogMessage::Severity sev = WLERRGetErrorSeverity(frmName, frmId);

  char    buf[1024];
  va_list ap;

  va_start(ap, frmId);
	  vsprintf(buf, WLERRGetErrorFormat(frmName,frmId), ap);
  va_end(ap);

  if (sev > WLLogMessage::Note) {
		return vReport(cx, sev, (const char*)buf);
		}

	return JS_TRUE;
}

void SetErrorReporter(iXMLVirtualErrorReporter* rVirtualErrorReporter){
  piHLErrorReporter = rVirtualErrorReporter;
}


