/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// ProtocolAutoDiscovery.h: interface for the CProtocolAutoDiscovery class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__JVM_AUTO_DISCOVERY_H__)
#define __JVM_AUTO_DISCOVERY_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "tvenv.h"
#include <RVCString.h>
#include <hashdict.h>

#define USE_MSXML
#ifdef USE_MSXML
#include "crvxmldocument.h"
#include "crvxmlelement.h"
#else
#include "rvxmldocument.h"
#include "rvxmlelement.h"
#endif // USE_MSXML


class CJVMAutoDiscovery  : public CFindFileFunctor
{
public:
	CJVMAutoDiscovery();
	virtual ~CJVMAutoDiscovery();

	virtual bool handleFile( const char* filePath );
	const char* getLastError();
	bool discoverPath( const char* path, const char* spec, bool lookInSubDirs );

	RVCString* findJVMPath(RVCString* JVMType);

protected:

	bool loadJVMPath( CRVXMLElement* pJVMNode, RVCString& JVMType, RVCString& JVMPath);

private:
	RVCString m_LastErrorDescription;
	RVHashDictionary	m_JVMDict;
};

#endif // !defined(__JVM_AUTO_DISCOVERY_H__)
