/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __AgendaFile_H
#define __AgendaFile_H

#include "tracedll.h"
#include "rvjs.h"	

class DllExport iSourceCommit;
class DllExport iFileSourceCommit;
class DllExport iAgendaFile;

class iSourceCommit {
	
public:
		virtual ~iSourceCommit();
		virtual void fTake( int, const char* ) = 0;
};



class iFileSourceCommit: public iSourceCommit {
	
public:
		explicit iFileSourceCommit( iFile& );
		
		void fTake( int, const char* );
		
private:
		virtual void fTakeFile( const char*, int, const char* ) = 0;
		iFile& mFile;
};




class iAgendaFile: public iFile {
		friend class iFileSourceCommit;
public:
		explicit iAgendaFile();

		void vPick() {}
		bool vDrop() {return false;}
	
		virtual void fSourceExport( iEmbedderCallContext&, iSourceCommit& ) = 0;
};





#endif //_AgendaFile_H

