/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADAGENDACONTEXT_H
#define	__WL_LOADAGENDACONTEXT_H

#include "rvjsembed.h"
#include "generalprocess.h"
#include "wlleprotocol.h"
#include "wlleprotocolcontainer.h"

class CWLJSBaseObject;
class CWLJSScript;
class CWLJSThread;
class iLEProtocolEmbedContext;
struct JSContext;

class DllExport iLEAgendaJSEmbedContext;

class iLEAgendaJSEmbedContext : public iLEJSEmbedContext {
public:	
	explicit iLEAgendaJSEmbedContext ();
	virtual ~iLEAgendaJSEmbedContext ();

	bool IsJSActive();
	JSContext* vCurrentJSContext();

  // The implemenator is required to return its base object as well as script,
  // even though the base object might be be the script anyway. The base object is for internal
  // iLEAgendaJSEmbedContext use and the script is because a lot of users need it

	virtual CWLJSScript& GetJSScript() = 0;

	// Common virtuals (for global funcs, mostly)
  virtual int GetErrorCounter() = 0;
  virtual int GetWarningCounter() = 0;
  virtual void IncrementErrorCounter() = 0;
  virtual void IncrementWarningCounter() = 0;
	virtual int GetNumScriptInMix() = 0;
  virtual CGeneralProcess& fGetProcess() = 0;
  virtual IFileDictionary* GetFileDict() = 0;
  virtual bool InInitAgenda() = 0;
  virtual bool isAbort(bool CheckInScript = true) = 0;
	virtual void UserLock() = 0;
	virtual void UserUnlock() = 0;
  virtual void OnSevereError() = 0; 
	virtual IGeneralGlobalsRequestHandler* GetGlobalsRequestHandler() = 0;

	static iLEAgendaJSEmbedContext* fGetAgendaEmbedContext(JSContext* cx) {
		WlAssert(dynamic_cast<iLEAgendaJSEmbedContext*>(iLEJSEmbedContext::fsGet(cx)));
		return static_cast<iLEAgendaJSEmbedContext*>(iLEJSEmbedContext::fsGet(cx));
	}

private:
	virtual CWLJSBaseObject& GetJSBaseObject() = 0;

};

#endif //__WL_LOADAGENDACONTEXT_H



