/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_COPY_FILE_OBJECT_H
#define __WL_COPY_FILE_OBJECT_H

#include <hashdict.h>
#include <thr.h>
#ifdef __TV_WINDOWS__
//#include "loadagendamanager.h"
#else
#include "no_windows.h"
#endif

class CLoadAgendaManager;

class CLoadCopyFileObject {
private:
  CLoadAgendaManager  *m_LoadAgendaManager;
  RVCriticalSection   m_CopyFileMutex;
  RVHashDictionary		m_CopyFileHashTable;
  RVHashDictionary    m_IncludeFileList;
public:
  CLoadCopyFileObject() {};
  ~CLoadCopyFileObject() ;
  void SetLoadAgendaManager(CLoadAgendaManager* lam);

  bool CopyMonitorFile(const char* sourcefilename, 
											 const char* targetfilename,
											 const char* agendaPath,
											 RVCString& errormessage);

  bool IncludeMonitorFile(const char* sourcefilename,
													const char** data,
													const char* agendaPath,
													RVCString& errormessage);
};

#endif __WL_COPY_FILE_OBJECT_H

