/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADENGINE_STATISTICS_H
#define __WL_LOADENGINE_STATISTICS_H

#include "platform.h"
#include "wlstatisticsgenerator.h"

void SetStatisticsFileName(const char* name);
RVCString GetTestLogFileName(const char* name);
const char*  GetStatisticsFileName();

class CLoadThreadsManagerScript;

//
// statistics class
class DllExport CAgendaStatistics : public CWLStatGenMain {
private:
  CLoadThreadsManagerScript* m_pMyLoadThreadsManagerScript;
  FILE*                      m_StatisticsFile;
  bool                       m_ExtraStatisticsFirstTime;
	bool											 m_SendClientStatistics;
  RVCString                  m_SendClientStatisticsFilter;
  

public:
  CAgendaStatistics(const char* name);
  virtual ~CAgendaStatistics() {}

  void Init(CLoadThreadsManagerScript* ag);
  void Start(double BeginTime, double sliceSizeResolution, bool pSendClientStatistics, const char* pSendClientStatisticsFilter);

  virtual void SendDictionaryString( RVCString &str, double sliceTime, const char* agendaName );
	virtual void CalculateExtraStatisticsForDictionary( CWLStatGenMeasurementDictionary *pDic, double lastSliceSize, double lastSliceTime);		 	
	virtual void CalculateExtraStatisticsForCurrentClientDictionary( CWLStatGenMeasurementDictionary *pDic, int ClientId, double SliceEndTime);		 	

	CWLStatGenMeasurementDictionary* getCurrentStatGenMeasurementDictionary() { return total; };

private:
	bool ShouldSendCurrentSlice(int ClientId);
};

#endif //__WL_LOADENGINE_STATISTICS_H

