/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADGENERATORSCRIPT_H
#define	__WL_LOADGENERATORSCRIPT_H

class CWLJSJavaApplet;
class CLoadThreadInstance;
class CRTAMThreadInstance;
class CLoadThreadsManager;
class CLoadGeneratorSlave;
class iLEProtocolVCInMix;
class iLEProtocolEmbedContext;


#include "exception"
#include <collstr.h>
#include <tvordvec.h>
//#include <thr.h>
#include <thr.h>
#include <thr.h>

#include "loadinputfile.h"
#include "loadinputfileinterface.h"
#include "loadjsfile.h"
#include "loadjsshell.h"
#include "loadenginestatistics.h"
//new

#include "loadengineverification.h"
#include "slaveloadsizemanager.h"
#include "loadjsgcthread.h" 
#include "rvjsembed.h"

#include "loadagendacontext.h"
#include "managerscriptdata.h"
#include "generalprocess.h"

class DllExport iLEVCJSThread;
class CLoadGeneralThreadInstanceScript;
class CLoadThreadInstanceScript;
class CLoadThreadsManagerScript;
class CLoadThreadInstanceScriptContainer;
class CLoadThreadsManagerScriptContainer;
class CThreadsManagerGlobalsRequestHandler;
class iLoadSingleClient;

class CUserLockObject {
private:
	RVMutexLock m_Lock;
	volatile int m_Count;
	volatile int m_Owner;
public:
	explicit CUserLockObject();
	void Lock( int ThreadNum, JSContext* );
	void Unlock(int ThreadNum, JSContext* );
	bool CheckUnlock(int ThreadNum);
};

class iLEVCJSThread
{
public:
	explicit iLEVCJSThread();
	virtual ~iLEVCJSThread();

	virtual CLoadGeneralThreadInstanceScript& vGetGeneralThreadInstanceScript() = 0;
		CLoadGeneralThreadInstanceScript& fGetGeneralThreadInstanceScript() {return vGetGeneralThreadInstanceScript();}

	virtual JSContext* vGetContext() = 0;
		JSContext* fGetContext() {return vGetContext();}

	virtual iLEJSMachineThread& vGetMachineThread() = 0;
		iLEJSMachineThread& fGetMachineThread() {return vGetMachineThread();}
};

class CLoadGeneralThreadInstanceScript : public RVCollectableString, public iLEAgendaJSEmbedContext, public iLEVCJSThread  {
public:
  CLoadGeneralThreadInstance* m_MyThreadInstance;
  CWLJSThread                 m_MyJSThread;
  bool                        m_JSThreadInitDone;
  unsigned long               m_RoundNum;
  
	explicit CLoadGeneralThreadInstanceScript(CLoadGeneralThreadInstance*, CWLJSScript&);
	virtual ~CLoadGeneralThreadInstanceScript();
  
  // From CLoadThreadInstanceScript
	void ToggleJavaDefaultStatistics(bool);
	bool IsDisabledJavaDefaultStatistics();
	void EnterJava();
	void ExitJava();

  virtual void addMeasurement(const char *name, double l) = 0;
  virtual void addTimer(const char *name, double l) = 0;
  virtual void addCounter(const char *name) = 0;
  virtual void addAccumulator(const char *name, double l) = 0;
  virtual void addLast(const char *name, double l, CWLStatPointTypeEnum::PointType type) = 0;
	virtual void resetTimer(const char *name) = 0;
	virtual void sendTimer(const char *name) = 0;
	virtual int GetNumScriptInMix() = 0;

  bool InInitAgenda() { return false;};
  bool isAbort(bool CheckInScript = true);
  void sleep(int milisec);
  bool BeforeSleep(long int Time);
  void AfterSleep(long int Time);
  virtual bool vBeforeSleep(long int Time) = 0;
	virtual void vAfterSleep() = 0;

  // From CLoadThreadData
  void vEnterJava( const char* rClassDescriptionName, const char* rMemberName, tJavaCallType );
	void vExitJava( JSBool rOK, const char* rClassDescriptionName, const char* rMemberName, tJavaCallType );
	void reportApply( iReport& );
	void reportLog( iReport& );

	virtual void CreateApplet(JSContext*                cx,
                             const char*              appletClassName,
										        const char*               appletCodeBase,
                            const char*               appletDocumentBase,
  											    RVHashDictionary*         appletParams,
                            CWLJSJavaApplet*&         javaApplet);

  virtual bool ClassAppletExists(JSContext*  cx,
                                 const char* appletClassName,
 							                   bool& classAppletExists);

	virtual bool AddJavaStream(JSContext*  cx,
                             const char* streamName,
                             const char* codeBase,
                             RVCString& javaStream);

	virtual bool JavaStreamExists(const char* streamName);

  virtual void VerificationSetFailureReason(const char* reason, const char* description, double time, bool isEvent );
  virtual void VerificationRecordEvent(const char* reason, const char* description, double time, WLLogMessage::Severity severity = WLLogMessage::Note, const char* extraDataType = NULL, void* extraData = NULL, unsigned long len = 0, bool IsLog = true );
  virtual bool VerificationBeginTransaction(const char* transname, double time, const char* extraDataType, void* extraData, unsigned long len);
  virtual bool VerificationEndTransaction(const char* transname, double time, WLLogMessage::Severity severity, bool save, bool SendTimers, bool IsLog );
  virtual bool VerificationEndTransactionFailure(const char* transname, double time, WLLogMessage::Severity severity,const char* reason, bool SendTimers, bool IsLog, bool isFailureEvent );
  virtual int  VerificationGetTransactionDepth();
  virtual const char* VerificationGetCurrentTransaction();
  virtual void endMultiThread();
	virtual void reportApplyEvent( WLLogMessage::Severity sev, const char* msg);
	virtual bool report( WLLogMessage::Severity sev, const char* msg);
	virtual bool reportTime( WLLogMessage::Severity sev, const char*, double Time, WLLogMessage::Severity ErrorInTransTree = WLLogMessage::Success );
	virtual bool report( WLErrorException& exc);
	virtual bool reportTime( WLErrorException& exc, double Time );
	virtual bool reportMultiThread( iReportInfo& info);
	virtual bool reportMultiThread( WLLogMessage::Severity sev, const char* msg);
	virtual bool reportMultiThread( WLErrorException& exc);
  virtual CLEVariablesData* GetCurrentLoadEngineVariablesData();
	virtual WLEThreadType GetThreadType();
  virtual unsigned long TotalRoundNum();
  virtual unsigned long CurrentScriptRoundNum();
	virtual unsigned long GetRoundNumScriptInSlave();
	virtual unsigned long GetRoundNumMixInSlave();
	void OnSevereError(); 
  virtual int GetLGThreadNum();
  virtual WLLogMessage::Severity getErrorSeverity();
  virtual bool InScript();
  virtual bool IsOneClient();
  virtual bool IsLoadServer();
  virtual bool IsRTAM();
	virtual void UserLock();
	virtual void UserUnlock();
  virtual int GetAgendaNumRunning();
  virtual const char* GetLoadGeneratorNo();
  virtual int GetErrorCounter();
  virtual int GetWarningCounter();
  virtual void IncrementErrorCounter();
  virtual void IncrementWarningCounter();
  virtual const char* GetAgendaName();
  virtual CGeneralProcess& fGetProcess();
  virtual int GetSlaveThreadNum();
  virtual SynchronizationPointStatus SynchronizationPoint(int timeoutmillis);
	virtual IGeneralGlobalsRequestHandler* GetGlobalsRequestHandler();
  
	iSession& vGetSession();

  virtual bool Init() = 0;

  // Enacapsulate script manager functions (because we didn't create a common script manager class
  // for load and RTAM.
  virtual RVCString& GetScriptName() = 0;
	virtual RVCString& GetScriptFileName() = 0;

  void InitProtocols(CWLJSThread&, IGeneralManagerScriptData&, JSContext*, JSObject*, CLEVariablesData*);
  bool ProtocolOnThreadActivation();
  bool ProtocolBeforeInitClient();
  bool ProtocolAfterInitClient();
  bool ProtocolBeforeRound();
  bool ProtocolAfterRound();
  bool ProtocolBeforeTerminateClient();
  bool ProtocolAfterTerminateClient();
  bool ProtocolOnThreadTermination();
  bool ProtocolOnThreadRestart();
  void ProtocolExceptionHandler(std::exception& e);
  void ProtocolBeforeSleep(long int sleepTime);
  void ProtocolAfterSleep(long int sleepTime);
  void ProtocolSleepDisabled(long int recordedSleepTime);
  void ProtocolBeginTransaction(const char* transname, double time, const char* extraDataType, void* extraData, unsigned long len);
  void ProtocolEndTransaction(const char* transname, double time, WLLogMessage::Severity severity, bool save, bool SendTimers, bool IsLog );
  iLEProtocolContainer& GetProtocolVCInMixContainer() { return m_ProtocolVCInMixContainer; };
  iLEProtocolJSEmbedContext& GetProtocolJSEmbedContext(WLProtocolIndex p_ProtocolIndex);

  void vEnterControlMachineThread_iLEJSEmbedContext();
  void vExitControlMachineThread_iLEJSEmbedContext();
  bool vIsUserSection();

	void fEnterCriticalSection();
	void fExitCriticalSection();

//iLEVCJSThread overrides

	CLoadGeneralThreadInstanceScript& vGetGeneralThreadInstanceScript();
	JSContext* vGetContext();
	iLEJSMachineThread& vGetMachineThread();

  // Chaim - serves to distinguish ambiguouity between iLEAgendaJSEmbedContext and iLEVCJSThread
  iLEJSMachineThread& fGetMachineThread();


protected:
	iLEProtocolContainer m_ProtocolVCInMixContainer;

private:
  // For iLEAgendaJSEmbedContext
  CWLJSBaseObject& GetJSBaseObject() { WlAssert(m_MyJSThread); return m_MyJSThread;};
};


class CLoadThreadInstanceScriptContainer : public RVHashDictionary {
private:
  CLoadThreadsManagerScriptContainer *m_ScriptContainer;
  //CLoadThreadsManagerScript          *m_CurrentScript;

public:
  CLoadThreadInstanceScriptContainer(CLoadThreadsManagerScriptContainer*);
  virtual ~CLoadThreadInstanceScriptContainer();

  bool Init(CLoadThreadInstance*);

  void TerminateClient();
	bool TerminateJSThreads();
	bool RestartJSThreads();

  CLoadThreadInstanceScript* SelectScript(CLoadThreadInstance*,CLoadThreadInstanceScript*, unsigned long& RoundNumScriptInSlave, unsigned long& RoundNumMixInSlave );
  void ReleaseThreadsManagerScript(CLoadThreadInstanceScript*);
//  CLoadThreadsManagerScriptContainer* GetScriptContainer() {return m_ScriptContainer;};

};

class CLoadThreadsManagerScript : public RVCollectableString {
  friend class CLoadThreadInstanceScript;
  friend class CLoadThreadInstanceScriptContainer;
  friend class CLoadThreadsManagerScriptContainer;
  friend class CAgendaStatistics;
private:
  CLoadThreadsManagerScriptContainer *m_MyContainer;

	CLoadManagerScriptData m_ScriptData;

  RVCString           m_ScriptName;
  RVCString           m_ScriptFileName;
  RVCString           m_ScriptCode;

 
  CWLJSScript         m_WLJSScript;
  
  RVThread            m_StatPackThread;
  RVThread            m_StatGarbageThread;
  TVPManualEvent      m_StatStartEvent;
  TVPManualEvent      m_StatPackEvent;
  TVPManualEvent      m_StatGarbageEvent;

  CAgendaStatistics   m_AgendaStat;
  CWLStatGenClient    m_StatClient;

  CLoadFileDictionary   m_InputFileDict;

  double              m_Weight;
  unsigned long       m_RoundsCounter;

  double              m_RuntimeTotal;
  int                 m_RunningTotal;

  bool                m_InitAgendaDone;
  bool                m_SevereErrorOccurred;

  double              m_DelayTime;

	//RVMutexLock					*m_SynchronizationPointMutex;
	RVCondition					*m_SynchronizationPointCondition;
	RVCondition					*m_SynchronizationPointFinishEvent;
	int									m_SynchronizationPointTreated;
	SynchronizationPointStatus m_SynchronizationPointStatus;

  CSlaveLoadSizeManager      m_LoadSizeManager;

	CUserLockObject	m_UserLockObj;

	int m_numScriptInMix;
	

public:
  
  CLoadThreadsManagerScript(CLoadThreadsManagerScriptContainer*, const char* scriptName, int NumScriptInMix);
  ~CLoadThreadsManagerScript();

	IGeneralManagerScriptData& GetScriptData();

  void StartLoad(double startTime, int sliceSize);
  double DelayTime() {return m_DelayTime;};

  void RequestForTerminate();
  void OnSevereError();
  void WaitForTerminateToEnd();

  bool InitAgenda(const char* InitializationScript);
  void TerminateAgenda();

  void LoadScript(const char* scriptName, const char* scriptFileName, const char* ScriptCode, double weight);
  void AddNumRunning();

  double CalculateCurrentWeight(bool PreviosIsCurrentScript);

  void StatPackFunc();
  void StatGarbageFunc();

  CLoadGeneratorSlave* GetLoadGenerator();//there are 2 api to get that pointer (because historical reasons)
	CLoadGeneratorSlave* GetLoadGeneratorSlave();//there are 2 api to get that pointer (because historical reasons)
  CLoadThreadsManager* GetThreadsManager();
	RVCString& GetScriptFileName();
	RVCString& GetScriptName();

  IFileDictionary* GetFileDict() {return &m_InputFileDict;};
	IGeneralGlobalsRequestHandler *GetGlobalsRequestHandler();

  bool InInitAgenda() {return GetJSScript().IsInInitAgenda();};
  bool IncludeMonitorFile(const char* filename, bool execute );
  bool CopyMonitorFile(const char* source,const char* target );

  void AppendStringForEvaluation(const char*,CWLJSScript::WhenToRunScript whenToRunScript);
	RVCString&  GetEvaluationStringBeforeInitClient();
	RVCString&  GetEvaluationStringAfterInitAgenda();
//	RVCString&	GetEvaluationStringOnThreadTermination();
	RVCString&  GetEvaluationStringBeforeThreadActivation();
	RVCString&  GetEvaluationStringOnThreadActivation();
	RVCString&	GetEvaluationStringAfterTerminateClient();
	RVCString&	GetEvaluationStringBeforeRound();
	RVCString&	GetEvaluationStringAfterRound();
	RVCString&	GetEvaluationStringAfterTerminateAgenda();


  void ReleaseSynchronizationPoints();
  SynchronizationPointStatus SynchronizationPoint(int timeoutmillis);

	void UserLock( int ThreadNum, JSContext* );
	void UserUnlock(int ThreadNum, JSContext* );
	bool UserCheckUnlock(int ThreadNum);

  CWLJSScript& GetJSScript()  {return m_WLJSScript;};
  RVCString& ScriptName()     {return m_ScriptName;};
	RVCString& ScriptFileName() {return m_ScriptFileName;};
  void FillInputFileQueue(CAssociativeArray* AssoArray) {m_InputFileDict.GetWLFileDict().FillTheQueue(AssoArray);};
//  void InputFileRelease() {m_InputFileDict.GetWLFileDict().Release();};
  void InputFileTerminate() {m_InputFileDict.GetWLFileDict().Terminate();};

	void EnterJava();// will set the boolean m_IsRunningJava
	void ExitJava();// will reset the boolean m_IsRunningJava
	
	void SetJavaThreadWrapperCreationScript();
	bool IsJavaThreadWrapperCreationScriptExists();

	int GetNumScriptInMix() const { return m_numScriptInMix; }
	
	void ExceptionHandler(std::exception*);
	CWLStatGenMeasurementDictionary* getCurrentStatGenMeasurementDictionary() { return m_AgendaStat.getCurrentStatGenMeasurementDictionary(); };
};


class CLoadThreadsManagerScriptContainer : public RVHashDictionary {
  friend class CLoadThreadsManagerScript;

private:
  CLoadThreadsManager   *m_MyLoadThreadsManager;

  unsigned long         m_RoundsCounter;
  RVCriticalSection     m_RoundsMutex;

  RVThread              m_StatLoadSizeThread;
  TVPManualEvent        m_StatStartEvent;

  bool                  m_StatisticsOn;
  bool                  m_Terminate;
  int                   m_StatisticsFrequency;

  double                m_RuntimeTotal;
  TVPTimerObject        m_TimerTotal;

public:
	CLoadThreadsManagerScriptContainer();
  virtual ~CLoadThreadsManagerScriptContainer();

	void InitParent(CLoadThreadsManager*);

  void Init();
  void Terminate();
  void OnSevereError();

//  bool InitAgenda(const char* InitializationScript);
  void TerminateAgenda();

  bool LoadScript(const char* scriptName, const char* scriptFileName, const char* scriptCode, double weight, const char* InitScript, int NumAgendaInMix);
  void StatLoadSizeFunc();
  void JSGarbageCollectorFunc();

  void StartLoad(double startTime, int sliceSize);

  CLoadThreadsManagerScript* GetThreadsManagerScript(const char* name) const;

  const char* SelectThreadsManagerScript(CLoadThreadInstance*,CLoadThreadInstanceScript*, unsigned long& RoundNumScriptInSlave, unsigned long& RoundNumMixInSlave );
  void ReleaseThreadsManagerScript(CLoadThreadInstanceScript*);
	void ReleaseSynchronizationPoints();

  CLoadGeneratorSlave* GetLoadGenerator();
  CLoadThreadsManager* GetThreadsManager() { return m_MyLoadThreadsManager; };
  void InputFileData(CAssociativeArray* AssoArrayCommand);
//  void InputFileRelease();
  void InputFileTerminate();
};

class CLoadThreadInstanceScript : public CLoadGeneralThreadInstanceScript{
public:
  CLoadThreadsManagerScript* m_MyThreadsManagerScript;

  CWLStatGenClient    m_StatClient;


	bool                m_ThreadActivationDone;
  bool                m_InitClientDone;

  CLoadThreadTransactionManager m_TransactionManager;

public:
  CLoadThreadInstanceScript(CLoadThreadsManagerScript*, CLoadThreadInstance*);
  ~CLoadThreadInstanceScript();

  bool Init();
	bool ThreadActivation();
  bool InitClient();
  void TerminateClient();
  void OnScriptAbort();

  bool runJScript();

  void addLast(const char *name, double l, CWLStatPointTypeEnum::PointType type);
	void resetTimer(const char *name);
	void sendTimer(const char *name);
  bool InScript();

  SynchronizationPointStatus SynchronizationPoint(int timeoutmillis);
  
	void UserLock();
	void UserUnlock();
	bool UserCheckUnlock();

	CLoadGeneratorSlave* GetLoadGeneratorSlave();
  CLEVariablesData* GetLoadEngineVariablesData() { return m_MyJSThread.GetLoadEngineVariablesData(); }
  IFileDictionary* GetFileDict();

	int GetNumScriptInMix() ;

  virtual void CreateApplet(JSContext*          cx,
                            const char*         appletClassName,
                            const char*         appletCodeBase,
                            const char*         appletDocumentBase,
                            RVHashDictionary*   appletParams,
                            CWLJSJavaApplet*&   javaApplet);
                                        
  virtual bool ClassAppletExists(JSContext*  cx,
                                 const char* appletClassName,
 							                   bool& classAppletExists);


  // For iLEAgendaJSEmbedContext
  CWLJSScript& GetJSScript() { WlAssert(m_MyThreadsManagerScript); return m_MyThreadsManagerScript->GetJSScript();};

  // Moved from Thread Data
  bool vIsJSGC();
  void addMeasurement(const char *name, double l);
  void addTimer(const char *name, double l);
  void addCounter(const char *name);
  void addAccumulator(const char *name, double l);

  RVCString& GetScriptName() { return m_MyThreadsManagerScript->m_ScriptName; };
	RVCString& GetScriptFileName() { return m_MyThreadsManagerScript->m_ScriptFileName; };

  bool vBeforeSleep(long int Time) { return true;};
  void vAfterSleep() {};

private:
  RVCriticalSection   *m_StatisticsMutex;

};

class CRTAMThreadInstanceScript : public CLoadGeneralThreadInstanceScript{
private:
  iLoadSingleClient*  m_LoadSingleClient;
public:
  CRTAMThreadInstanceScript (CRTAMThreadInstance*, iLoadSingleClient*);
  ~CRTAMThreadInstanceScript();

  bool Init();
  void addMeasurement(const char *name, double l);
  void addTimer(const char *name, double l);
  void addCounter(const char *name);
  void addAccumulator(const char *name, double l);
  void addLast(const char *name, double l, CWLStatPointTypeEnum::PointType type);
  void resetTimer(const char *name);
  void sendTimer(const char *name);
  IFileDictionary* GetFileDict();
  bool vIsJSGC();

  // For iLEAgendaJSEmbedContext
  CWLJSScript& GetJSScript();
  
  int GetNumScriptInMix() { return 1;};
  
  RVCString& GetScriptName();
	RVCString& GetScriptFileName();

  bool vBeforeSleep(long int Time);
  void vAfterSleep();
};
#endif //__WL_LOADGENERATORSCRIPT_H

