/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __JSGCThread_H
#define __JSGCThread_H
class CGeneralProcess;
class CWLJSScript;
class CJSLoadScope;
class CLoadGeneratorSlave;

#include <thr.h>
#include "platform.h"
#include "wlerrorlib.h"
#include "rvjsapi.h"

#include "rvjsmachinethread.h"
#include "rvjsembed.h"
#include <exception>

class DllExport cLEJSGCThread;

class cLEJSGCThread:
	public iLEJSAgendaMachineThread,
	public iLEJSEmbedContext
{
public:
	explicit cLEJSGCThread( CLoadGeneratorSlave& );
	virtual ~cLEJSGCThread();

	void fPreInit( CJSLoadRuntime& rLoadRuntime );
	void fExecute();
	void fTerminate();
  iLEProtocolJSEmbedContext& GetProtocolJSEmbedContext(WLProtocolIndex pProtocolIndex);

	RVTRecursiveLock<RVMutexLock> mJSGCLock;

private:
	CLoadGeneratorSlave& mLoadGeneratorSlave;
	JSContext* mGCCx;
	volatile bool mShouldExecute; // boolean dont need mutex

// iLEJSAgendaMachineThread overrides

// iLEJSEmbedContext overrides
	iSession& vGetSession();
		
	void reportApply( iReport& );
	void reportLog( iReport& );
	bool IsJSActive();
	JSContext* vCurrentJSContext();

	iLEJSMachineThread& vGetMachineThread();
	void vEnterJava( const char* rClassDescriptionName, const char* rMemberName, tJavaCallType );
	void vExitJava( JSBool rOK, const char* rClassDescriptionName, const char* rMemberName, tJavaCallType );

	bool vIsJSGC();

	bool vIsUserSection() {return false;}
	
  void ExceptionHandler(std::exception*);
};




#endif //__JSGCThread_H
