/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __RVInheritArc_H
#define __RVInheritArc_H


template< typename rcDerived_, typename rcBase_ >
class eiRVInheritArc: public rcBase_ 
{
public:
	typedef rcDerived_ rcDerived;
	typedef rcBase_ rcBase;
	typedef eiRVInheritArc< rcDerived, rcBase > jiRVInheritArc;

public:
	explicit eiRVInheritArc()
	:
		rcBase()
	{}

	explicit eiRVInheritArc(
		rcBase& r )
	:
		rcBase(r)
	{}

	explicit eiRVInheritArc(
		const rcBase& r )
	:
		rcBase(r)
	{}

	rcDerived* down_ptr() {
		return static_cast<rcDerived*>(this);
	}

	const rcDerived* down_const_ptr() const {
		return static_cast<const rcDerived*>(this);
	}

	rcDerived& down_ref() {
		return *(static_cast<rcDerived*>(this));
	}

	const rcDerived& down_const_ref() const {
		return *(static_cast<const rcDerived*>(this));
	}

};




#endif //__RVInheritArc_H
