/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __JavaMachineThread_H
#define __JavaMachineThread_H

class cRVJVM;

#include "platform.h"
//#include "wlerrorlib.h"
#include "rvjsapi.h"
#include "rvjsjava.h"
//#include "rvjsembed.h"
//#include <collint.h>
//#include "rw/thr/threadid.h"

class DllExport iRVJavaMachineThread;

class iRVJavaMachineThread
{
// general 
public:
	explicit iRVJavaMachineThread();
	virtual ~iRVJavaMachineThread();

	void fInit();
	void fFinal();

// EmbedContext, Java, JSJ
public:
	JNIEnv* fGetJEnv();
	JSJavaThreadState* fGetJSJThreadState();

	cRVJVM& fGetJVM() { return vGetJVM(); }

// Java, JSJ

	bool fIsJEnv();
	JNIEnv* fGetifJEnv();

private:
	JNIEnv* mJEnv;
	JSJavaThreadState* mJSJThreadState;

	virtual cRVJVM& vGetJVM() = 0;
};


#endif //__JavaMachineThread_H
