/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __JSMachineThread_H
#define __JSMachineThread_H

class iLEJSEmbedContext;
class CGeneralProcess;
class cRVJVM;
class iLEProtocolAgendaMachineThread;

#include "platform.h"
#include "wlerrorlib.h"
#include "rvjsapi.h"
#include "rvjsjava.h"
#include <collint.h>
#include <thr.h>

#include "rvjavamachinethread.h"
#include "wlleprotocolcontainer.h"
#include "wlleprotocolbasetypes.h"

class DllExport iLEJSMachineThread;
class DllExport iLEJSAgendaMachineThread;


class cLEJSMachineThreadKey: public RVCollectableInt
{
public:
	explicit cLEJSMachineThreadKey();
	explicit cLEJSMachineThreadKey( RVThreadId );
};

class iLEJSMachineThread: public RVCollectable, public iRVJavaMachineThread
{
// general 
public:
	typedef cLEJSMachineThreadKey cKey;

	explicit iLEJSMachineThread(CGeneralProcess&);
	virtual ~iLEJSMachineThread();

	void fInit(); 
	void fFinal();

	RVThreadId fGetMachineThreadId();
	CGeneralProcess& fGetProcess();

  virtual iLEProtocolMachineThread& GetProtocolMachineThread(WLProtocolIndex) = 0;

protected:
	CGeneralProcess& mProcess;
	RVThreadId mThreadId;
	cKey mThreadKey;

public:
	long mGCLockDepth;

// EmbedContext, Java, JSJ
public:
	iLEJSEmbedContext* fGetCurrentEmbedContext();
	iLEJSEmbedContext* fSetCurrentEmbedContext(iLEJSEmbedContext*);

protected:
	iLEJSEmbedContext*    mCurrentEmbedContext;

	cRVJVM& vGetJVM();
};

class iLEJSAgendaMachineThread: public iLEJSMachineThread {

public:
  explicit iLEJSAgendaMachineThread(CGeneralProcess&);
	virtual ~iLEJSAgendaMachineThread();

  void fInit(WLProtocolThreadType p_ProtocolThreadType);
	void fFinal();
	virtual iLEProtocolMachineThread& GetProtocolMachineThread(WLProtocolIndex);

private:
  iLEProtocolContainer  m_ProtocolAgendaMachineThreadContainer;

  void ProtocolAgendaMachineThreadSetUp(iLEProtocolContainer& p_ProtocolProcessContainer, WLProtocolThreadType p_ProtocolThreadType);
  void ProtocolAgendaMachineThreadInitialize();
  void ProtocolAgendaMachineThreadTermination();

};

#endif //__JSMachineThread_H
