/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// SlaveCountManager.h: interface for the CSlaveCountManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__LOADENGINE_SLAVECOUNTMANAGER_H__)
#define __LOADENGINE_SLAVECOUNTMANAGER_H__

#include <ordered.h>
#include <thr.h>

class CSlaveCountManager 
{
private:
  RVOrdered           m_SlaveCountList;
  RVReadersWriterLock m_ListLock;
  int                 m_NumSlaves;

public:
	CSlaveCountManager();
	virtual ~CSlaveCountManager();

  // ?ToDo: Remove Insert
  void Insert( double time, long newSlaveCount );
  void AddSlave( double time );
  long GetSlaveCount( double time );
};

#endif // !defined(__LOADENGINE_SLAVECOUNTMANAGER_H__)

