/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// WLGlobalsTable.h: interface for the CWLGlobalsTable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WLGLOBALSTABLE_H__3C10F6D9_4811_11D4_8805_0004AC15A422__INCLUDED_)
#define AFX_WLGLOBALSTABLE_H__3C10F6D9_4811_11D4_8805_0004AC15A422__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "associativearray.h"

class CWLGlobalsObject;
class CGlobalVariableProperties;



class DllExport CWLGlobalsTable: public RVHashDictionary
{
public:
	CWLGlobalsTable(void);
	virtual ~CWLGlobalsTable(void);

	void Set(const char* globlasObjectName, const char* variableName, CGlobalVariableProperties *newProperties);	  
	void Add(const char* globlasObjectName, const char* variableName, CGlobalVariableProperties *value);   
	CGlobalVariableProperties* SyncAdd(const char* globlasObjectName, const char* variableName, CGlobalVariableProperties *value);   
	CGlobalVariableProperties* Get(const char* globlasObjectName, const char* variableName);

	CWLGlobalsObject *CreateWLGlobalsObject(const char *requestedName);
	inline CWLGlobalsObject *GetGlobalsObject(const char* globlasObjectName);
	void RemoveGlobalsObject(const char* globlasObjectName);
};

#endif // !defined(AFX_WLGLOBALSTABLE_H__3C10F6D9_4811_11D4_8805_0004AC15A422__INCLUDED_)

