/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// File: WLMonitorGlobalsHandler.h
//
// Containes:
// Interface for CWLMonitorGlobalsHandler class.
//////////////////////////////////////////////////////////////////////

#if !defined(_WLMONITORGLOBALHANDLER_H__)
#define _WLMONITORGLOBALHANDLER_H__

#include <thr.h> 
#include <collectable.h>

#include "netkernelmessagehandler.h"
#include "tvpeventqueue.h"
#include "wlglobalstable.h"


class CGlobalVariableProperties;


/**
 * Class CWLMonitorGlobalsHandler
 *
 * This class has only one instance per Monitor (session)
 * and will keep and handle global variables for Test
 * and Agenda levels shared between all LGs.
 **/
class DllExport CWLMonitorGlobalsHandler: public CNetMessageHandler  
{
private:
	CWLGlobalsTable m_GlobalsTable;
	
public:
	CWLMonitorGlobalsHandler(const char *baseName);
	virtual ~CWLMonitorGlobalsHandler(void);

	virtual bool IsAgendaStoped(const char* agendaName) = 0;
	virtual bool IsAgendaPaused(const char* agendaName) = 0;
	virtual bool IsAgendaExists(const char* agendaName) = 0;

	virtual void CleanGlobalsDictionary(void);
	virtual void SendMessageErrorHandler(CAssociativeArray& message , const char* sendTo, const char* errorMsg, bool status);
	virtual void MessageHandler(CAssociativeArray& request);

protected:
	virtual void SendReplyData(CAssociativeArray& request, CGlobalVariableProperties* properties);
};


#endif // _WLMONITORGLOBALHANDLER_H__

