/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "loadgeneratorcommunicator.h"
#include "loadagendamanager.h"
#include "loadgenerator.h"
#include "tracedll.h"
#include "loadenginedecs.h"
#include "loadengineinifileproperties.h"


/*
CLoadGeneratorCommunicator::CLoadGeneratorCommunicator(CLoadGenerator *pLG, const char* name) :
m_pMyLoadGenerator(pLG),
CNetMessageHandler("LGCommunicator")
{
  m_SenderName.append(name);
}
*/

CLoadGeneratorCommunicator::CLoadGeneratorCommunicator(const char* name) :
CNetMessageHandler("LGCommunicator")
{
	m_SenderName.append(name);
}


void CLoadGeneratorCommunicator::InitParent(CLoadGenerator *pLG) {
	m_pMyLoadGenerator = pLG;
}

CLoadGeneratorCommunicator::~CLoadGeneratorCommunicator(){
}

void CLoadGeneratorCommunicator::MessageHandler( CAssociativeArray& AssoArrayCommand )
{
  try
  {
    if ( AssoArrayCommand.KeyExists( "$PING" ) )
    {
      CAssociativeArray PingReply;
      PingReply.AddCouple("$PINGREPLY",1L);
      if ( AssoArrayCommand.KeyExists( "$PINGID" ) )
        PingReply.AddCouple("$PINGID", AssoArrayCommand.GetLongValueOfParameter("$PINGID"));
      WlTraceMsg("CLoadGeneratorCommunicator::MessageHandler - Ping Reply(%s)", PingReply.ToString());
      m_pMyLoadGenerator->SendMessage(PingReply, 1);
      
    }
    else if (AssoArrayCommand.KeyExists( "$BRUTALEXIT" ))
    {
      WlTraceMsg("CLoadGeneratorCommunicator::MessageHandler - received $BRUTALEXIT, terminating the process");
      
#ifndef __TV_UNIX__
      TerminateProcess(GetCurrentProcess(), 0);
#else
      kill(getpid(), SIGKILL);
#endif
      
    }
    // handle next lines here and not inside LG main loop: 
    else if ( AssoArrayCommand.KeyExists( "$GLOBALSNAME" ) )
    {
      CAssociativeArray *wlGlobalsMessage = new CAssociativeArray();
      wlGlobalsMessage->FromString(AssoArrayCommand.ToString());
      // @@@@
      m_pMyLoadGenerator->GetAgendaManager()->GetFirstLoadGeneratorSlaveProxy()->SendMessageToSlave(wlGlobalsMessage);
    }
    else 
    {
      //
      // put in my Load Generator's queue.
      CAssociativeArray* pAssociativeArray = new CAssociativeArray;
      pAssociativeArray->FromString(AssoArrayCommand.ToString());
      WlTraceMsg("LoadGenerator gets : %s",pAssociativeArray->ToString());
      m_pMyLoadGenerator->PutMessage(pAssociativeArray);
    }
  } catch (WLErrorException e) {
				WlAssert(0);
        //    WlTraceMsg("CNetKernelProxy::MainLoop : Exception: %s",e.GetErrorMsg());
  } catch (...) {
    WlErrorMsg("CNetKernelProxy::MainLoop : Unknown exception");
    printf("CNetKernelProxy::MainLoop : Unknown exception");
    WlAssert(0);
  }
}

void CLoadGeneratorCommunicator::SendMessageErrorHandler( CAssociativeArray& Message , const char* SendTo, const char* ErrorMsg, bool status)
{
  //
  // Stop my Load-Generator.
	WlTraceMsg("CLoadGeneratorSlaveCommunicator::SendMessageErrorHandler invoked");

	if (CLEIniFileProperties::EnableStopgeneratorOnNetErrors) {
	  WlTraceMsg("call stopMe %s",Message.ToString());
	  m_pMyLoadGenerator->StopMe();
	}
}

