/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlleprotocolclient.h"
#include "loadthreadinstance.h"

//####### The implementation of the class iLEProtocolJSClientThread  #########

iLEProtocolJSClientThread::iLEProtocolJSClientThread(){
}

iLEProtocolJSClientThread::~iLEProtocolJSClientThread(){
}

void iLEProtocolJSClientThread::fInit(iLEProtocolVCJSThread& rVCJSThread){
  m_JSClientThread.fInit(rVCJSThread.fGetVCJSThread());
}

void iLEProtocolJSClientThread::fFinal(){
  m_JSClientThread.fFinal();
}

JSContext* iLEProtocolJSClientThread::fGetContext(){
  return m_JSClientThread.fGetContext();
}

iLEJSClientThread& iLEProtocolJSClientThread::GetLEJSClientThread(){
  return m_JSClientThread;
}

//####### The implementation of the class cLEProtocolJSClientMachineThread  #########

cLEProtocolJSClientMachineThread::cLEProtocolJSClientMachineThread(iLEProtocolAgendaJSEmbedContext& rProtocolAgendaJSEmbedContext):
  iLEProtocolMachineThread(rProtocolAgendaJSEmbedContext.GetProtocolProcess(), THREAD_TYPE_CLIENT),
  m_JSClientMachineThread(static_cast<CLoadGeneralThreadInstanceScript&>(rProtocolAgendaJSEmbedContext.GetInternalLEJSEmbedContext()).fGetProcess() , *this),
  m_TIS(static_cast<CLoadGeneralThreadInstanceScript&>(rProtocolAgendaJSEmbedContext.GetInternalLEJSEmbedContext()))
{
}

cLEProtocolJSClientMachineThread::~cLEProtocolJSClientMachineThread(){
}

void cLEProtocolJSClientMachineThread::fInit(){
  m_JSClientMachineThread.fInit(m_TIS);
}

void cLEProtocolJSClientMachineThread::fFinal(){
  m_JSClientMachineThread.fFinal();
}

iLEJSMachineThread& cLEProtocolJSClientMachineThread::GetJSMachineThread(){
  return m_JSClientMachineThread;
}


iLEVCJSThread& cLEProtocolJSClientMachineThread::vGetVCJSThread(){
  return m_JSClientMachineThread;
}

//####### The implementation of the class cLEProtocolVirtualReflectorJSClientEmbedContext  #########

cLEProtocolVirtualReflectorJSClientEmbedContext::cLEProtocolVirtualReflectorJSClientEmbedContext(iLEProtocolJSClientEmbedContext& pProtocolJSClientEmbedContext):
  m_ProtocolJSClientEmbedContext(pProtocolJSClientEmbedContext),
  iLEJSClientEmbedContext(pProtocolJSClientEmbedContext)
{
}

cLEProtocolVirtualReflectorJSClientEmbedContext::~cLEProtocolVirtualReflectorJSClientEmbedContext(){
}

void cLEProtocolVirtualReflectorJSClientEmbedContext::vReporter(WLLogMessage::Severity rSeverity, const char* rMessage){
  m_ProtocolJSClientEmbedContext.vReporter(rSeverity, rMessage);
}

iLEProtocolJSEmbedContext& cLEProtocolVirtualReflectorJSClientEmbedContext::GetProtocolJSEmbedContext(WLProtocolIndex pProtocolIndex){
  return m_ProtocolJSClientEmbedContext;
}

iLEJSClientThread& cLEProtocolVirtualReflectorJSClientEmbedContext::vGetThread(){
  return m_ProtocolJSClientEmbedContext.vGetThread().GetLEJSClientThread();
}


//####### The implementation of the class iLEProtocolJSClientEmbedContext  #########

iLEProtocolJSClientEmbedContext::iLEProtocolJSClientEmbedContext(iLEProtocolProcess* rProtocolProcess):
  m_VirtualReflectorJSClientEmbedContext(*this),
  m_ProtocolProcess(rProtocolProcess)
{
}

iLEProtocolJSClientEmbedContext::~iLEProtocolJSClientEmbedContext(){
}

JSObject* iLEProtocolJSClientEmbedContext::fSet( JSObject* rGlobal ){
  return m_VirtualReflectorJSClientEmbedContext.fSet(rGlobal);
}

void iLEProtocolJSClientEmbedContext::fClear(){
  m_VirtualReflectorJSClientEmbedContext.fClear();
}

JSBool iLEProtocolJSClientEmbedContext::fCallFunction( JSObject* rScope, jsval rFuncVal, uintN rArgc, jsval rArgv[], jsval& oRval ){
  return m_VirtualReflectorJSClientEmbedContext.fCallFunction(rScope, rFuncVal, rArgc, rArgv, oRval);
}

JSContext* iLEProtocolJSClientEmbedContext::fGetContext(){
  return m_VirtualReflectorJSClientEmbedContext.fGetContext();
}

bool iLEProtocolJSClientEmbedContext::Report(iLoadReportInfo& pReportInfo){
  return m_VirtualReflectorJSClientEmbedContext.Report(pReportInfo);
}

void iLEProtocolJSClientEmbedContext::endMultiThread(){
  CLoadGeneralThreadInstanceScript& aGTIS = m_VirtualReflectorJSClientEmbedContext.fGetThreadInstanceScript();
  aGTIS.m_MyThreadInstance->endMultiThread();
}

bool iLEProtocolJSClientEmbedContext::IsJSActive(){
  return GetLEJSClientEmbedContext().IsJSActive();
}

JSContext* iLEProtocolJSClientEmbedContext::fCurrentJSContext(){
  return m_VirtualReflectorJSClientEmbedContext.fCurrentJSContext();
}

iLEJSEmbedContext& iLEProtocolJSClientEmbedContext::GetInternalLEJSEmbedContext(){
  return m_VirtualReflectorJSClientEmbedContext;
}

iLEProtocolAgendaJSEmbedContext& iLEProtocolJSClientEmbedContext::GetProtocolAgendaJSEmbedContext(){
  WlAssert(dynamic_cast<iLEProtocolAgendaJSEmbedContext*>(&(m_VirtualReflectorJSClientEmbedContext.fGetThreadInstanceScript().GetProtocolJSEmbedContext(m_ProtocolProcess->GetProtocolIndex()))));
  return static_cast<iLEProtocolAgendaJSEmbedContext&>(m_VirtualReflectorJSClientEmbedContext.fGetThreadInstanceScript().GetProtocolJSEmbedContext(m_ProtocolProcess->GetProtocolIndex()));
}

iLEJSMachineThread& iLEProtocolJSClientEmbedContext::vGetMachineThread(){
  return GetLEJSClientEmbedContext().vGetMachineThread();
}

void iLEProtocolJSClientEmbedContext::vEnterJava( const char* rClassDescriptionName, const char* rMemberName, tJavaCallType rJavaCallType){
  GetLEJSClientEmbedContext().vEnterJava(rClassDescriptionName, rMemberName, rJavaCallType);
}

void iLEProtocolJSClientEmbedContext::vExitJava( JSBool rOK, const char* rClassDescriptionName, const char* rMemberName, tJavaCallType rJavaCallType){
  GetLEJSClientEmbedContext().vExitJava(rOK, rClassDescriptionName, rMemberName, rJavaCallType);
}

bool iLEProtocolJSClientEmbedContext::vIsJSGC(){
  return GetLEJSClientEmbedContext().vIsJSGC();
}

JSContext* iLEProtocolJSClientEmbedContext::vCurrentJSContext(){
  return GetLEJSClientEmbedContext().vCurrentJSContext();
}

iSession& iLEProtocolJSClientEmbedContext::vGetSession(){
  return GetLEJSClientEmbedContext().vGetSession();
}

//####### The implementation of the class cLEProtocolJSFunctionHandle  #########

cLEProtocolJSFunctionHandle::cLEProtocolJSFunctionHandle(cLEJSFunctionStatementInfo& rFunctionStatementInfo):
m_JSFunctionHandle(rFunctionStatementInfo)
{
}

cLEProtocolJSFunctionHandle::~cLEProtocolJSFunctionHandle(){
}

bool cLEProtocolJSFunctionHandle::fSet( iLEProtocolJSClientEmbedContext& rEmbedContext, cLEJSFunctionStatementCompileInfo& rFunctionCompileInfo){
	return m_JSFunctionHandle.fSet(rEmbedContext.GetLEJSClientEmbedContext(), rFunctionCompileInfo);
}

bool cLEProtocolJSFunctionHandle::fSet( iLEProtocolJSClientEmbedContext& rEmbedContext, jsval rFuncVal ){
	return m_JSFunctionHandle.fSet(rEmbedContext.GetLEJSClientEmbedContext(), rFuncVal);
}

bool cLEProtocolJSFunctionHandle::fIsSet(){
	return m_JSFunctionHandle,fIsSet();
}

JSBool cLEProtocolJSFunctionHandle::fCall( iLEProtocolJSClientEmbedContext& rEmbedContext, jsval& oRval ){
	return m_JSFunctionHandle.fCall(rEmbedContext.GetLEJSClientEmbedContext(), oRval);
}

jsval cLEProtocolJSFunctionHandle::fGetFuncVal(iLEProtocolJSClientEmbedContext& rEmbedContext){
  return m_JSFunctionHandle.fGetFuncVal(rEmbedContext.GetLEJSClientEmbedContext());
}

const char* cLEProtocolJSFunctionHandle::fGetToString( JSContext* cx){
  return m_JSFunctionHandle.fGetToString(cx);
}

const char* cLEProtocolJSFunctionHandle::fGetToString( iLEProtocolJSClientEmbedContext& rEmbedContext){
  return m_JSFunctionHandle.fGetToString(rEmbedContext.GetLEJSClientEmbedContext());
}

void cLEProtocolJSFunctionHandle::fFinal( iLEProtocolJSClientEmbedContext& rEmbedContext){
	m_JSFunctionHandle.fFinal(rEmbedContext.GetLEJSClientEmbedContext());
}



//####### The implementation of the class cLEProtocolJSScriptHandle  #########
cLEProtocolJSScriptHandle::cLEProtocolJSScriptHandle(cLEJSScriptStatementInfo& rScriptStatementInfo):
m_JSScriptHandle(rScriptStatementInfo)
{
}

cLEProtocolJSScriptHandle::~cLEProtocolJSScriptHandle(){
}

JSBool cLEProtocolJSScriptHandle::fExecute(iLEProtocolJSClientEmbedContext& rEmbedContext, cLEJSScriptStatementCompileInfo& rScriptCompileInfo, jsval& oRval){
	return m_JSScriptHandle.fExecute(rEmbedContext.GetLEJSClientEmbedContext(), rScriptCompileInfo, oRval);
}

JSBool cLEProtocolJSScriptHandle::fExecuteProlog(iLEProtocolJSClientEmbedContext& rEmbedContext, cLEJSScriptStatementCompileInfo& rScriptCompileInfo, jsval& oRval){
	return m_JSScriptHandle.fExecuteProlog(rEmbedContext.GetLEJSClientEmbedContext(), rScriptCompileInfo, oRval);
}

JSBool cLEProtocolJSScriptHandle::fExecuteMain(iLEProtocolJSClientEmbedContext& rEmbedContext, jsval& oRval){
	return m_JSScriptHandle.fExecuteMain(rEmbedContext.GetLEJSClientEmbedContext(), oRval);
}

void cLEProtocolJSScriptHandle::fFinal( iLEProtocolJSClientEmbedContext& rEmbedContext){
	m_JSScriptHandle.fFinal(rEmbedContext.GetLEJSClientEmbedContext());
}

//####### The implementation of the class cLEProtocolJSEmbedContextControlMachineThread  #########

cLEProtocolJSEmbedContextControlMachineThread::cLEProtocolJSEmbedContextControlMachineThread(){
}

cLEProtocolJSEmbedContextControlMachineThread::cLEProtocolJSEmbedContextControlMachineThread(iLEProtocolJSClientEmbedContext& rEmbedContext):
  m_EmbedContextControlMachineThread(rEmbedContext.GetLEJSClientEmbedContext())
{
}

cLEProtocolJSEmbedContextControlMachineThread::cLEProtocolJSEmbedContextControlMachineThread(iLEProtocolJSClientEmbedContext& rEmbedContext, bool rDoBegin ):
  m_EmbedContextControlMachineThread(rEmbedContext.GetLEJSClientEmbedContext(), rDoBegin)
{
}

cLEProtocolJSEmbedContextControlMachineThread::~cLEProtocolJSEmbedContextControlMachineThread(){
}

void cLEProtocolJSEmbedContextControlMachineThread::fBegin(){
  m_EmbedContextControlMachineThread.fBegin();
}

void cLEProtocolJSEmbedContextControlMachineThread::fEnd(){
  m_EmbedContextControlMachineThread.fEnd();
}


//####### The implementation of the class cLEProtocolJSClientEmbedContextBeginEndRequest  #########

cLEProtocolJSClientEmbedContextBeginEndRequest::cLEProtocolJSClientEmbedContextBeginEndRequest(iLEProtocolJSClientEmbedContext& pProtocolJSClientEmbedContext):
  m_BeginEndRequest(pProtocolJSClientEmbedContext.GetLEJSClientEmbedContext())
{
}

  

//####### The implementation of the class cLEProtocolJSClientEmbedContextSuspendResumeRequest  #########
  
cLEProtocolJSClientEmbedContextSuspendResumeRequest::cLEProtocolJSClientEmbedContextSuspendResumeRequest(iLEProtocolJSClientEmbedContext& pProtocolJSClientEmbedContext):
  m_SuspendResumeRequest(pProtocolJSClientEmbedContext.GetLEJSClientEmbedContext())
{
}
