/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
#include <thr.h>
#include <stdlib.h>
#include <iostream.h>

#include "rvjsapi.h"


void ErrorReporter(JSContext *cx, const char *message, JSErrorReport *report) {
  printf(message,"%s");
}


int main(int argc, char *argv[])
{
  JSRuntime *rt;
  JSContext *cx;

  rt = JS_NewRuntime(8L*1024L*1024L);

  cx = JS_NewContext(rt,8192);

  JS_SetErrorReporter(cx,ErrorReporter);

	JS_ReportError( cx, "dasdas" );

	JS_DestroyContext(cx);
	JS_DestroyRuntime(rt);

  return 0;

}


/*
// function for resolving functions from prototype.
static JSBool
proto_resolve_stub(JSContext *cx, JSObject *obj, jsval id) {
  jsval v;
  JSObject *func;
  const char* name;
  JSBool ok;

  if (!JSVAL_IS_STRING(id)) return JS_FALSE;
  name = JS_GetStringBytes(JSVAL_TO_STRING(id));
  if (!name) return JS_FALSE;
  
  JSObject* proto = JS_GetPrototype(cx,obj);
  if (!proto) return JS_FALSE;

  ok = JS_LookupProperty(cx,proto,name,&v);
  if (!ok) return JS_FALSE;

  if (!JSVAL_IS_VOID(v)) {
    if (JS_TypeOfValue(cx,v) == JSTYPE_FUNCTION) {

      func = JS_CloneFunctionObject(cx, JSVAL_TO_OBJECT(v), obj);
      if (!func) return JS_FALSE;

      ok = JS_DefineProperty(cx,obj, name ,OBJECT_TO_JSVAL(func), JS_PropertyStub, JS_PropertyStub, JSPROP_ENUMERATE | JSPROP_PERMANENT);
      if (!ok) return JS_FALSE;
    }
  }

  return JS_TRUE;
}

static JSClass stub_class = {
	"stub_class", 0,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_EnumerateStub,
	JS_ResolveStub,
	JS_ConvertStub,
	JS_FinalizeStub
};

static JSClass proto_stub_class = {
	"proto_stub_class", JSCLASS_NEW_RESOLVE,
	JS_PropertyStub,	// add
	JS_PropertyStub,	// del
	JS_PropertyStub,	// get
	JS_PropertyStub,	// set
	JS_EnumerateStub,
  proto_resolve_stub,
	JS_ConvertStub,
	JS_FinalizeStub
};

void ErrorReporter(JSContext *cx, const char *message, JSErrorReport *report) {
  printf(message,"%s");
}

int main(int argc, char *argv[])
{
  JSRuntime *rt;
  JSContext *super_context,*thr_context;
  JSObject  *super_object,*thr_global_obj;

// The following section is done once for the process in the main thread for all the threads
// using the JS.

  // create runtime
  rt = JS_NewRuntime(8L*1024L*1024L);
	if (!rt) return 1;

  // create super cx
  super_context = JS_NewContext(rt,8192);
	if (!super_context) return 1;

  // create super obj
  super_object = JS_NewObject(super_context, &stub_class, NULL, NULL);
	if (!super_object) return 1;
  JS_SetPrototype(super_context, super_object, NULL);
  JS_SetParent(super_context, super_object, NULL);

  // add js functions to the super js
  if (!JS_InitStandardClasses(super_context,super_object)) return 1;

  JS_SetGlobalObject(super_context, super_object);

  // Define the property which should be common to all threads.
  JS_DefineProperty(super_context,super_object, "superglobal" ,INT_TO_JSVAL(1), NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT);

  // compile the script once for all threads
  JSObject  **so;
  JSScript* script = JS_CompileFile(super_context, super_object, "c:\\test.js");
	if (!script) return 1;

  // create script object and AddRoot for the GC
  so = (JSObject**)malloc(sizeof(JSObject *));
	*so = JS_NewScriptObject(super_context, script);
	if (!*so) return 1;
    
  if (!JS_AddRoot(super_context, so)) return 1;


// The following section is done in each thread. In current example it is in the main thread
// for convenience. The same MT problems occurs also in one thread when I implement it the
// same way I implement the MT.
  
  // define private cx for the thread
  thr_context = JS_NewContext(rt,8192);
	if (!thr_context) return 1;
  JS_SetErrorReporter(thr_context,ErrorReporter);

  // define global object for the thread using the super_object as proto
//  thr_global_obj = JS_NewObject(thr_context,&proto_stub_class,super_object,NULL);
  thr_global_obj = JS_NewObject(thr_context,&proto_stub_class,NULL,NULL);
  JS_SetPrototype(thr_context, thr_global_obj, super_object);
  JS_SetParent(thr_context, thr_global_obj, NULL);
  JS_SetGlobalObject(thr_context,thr_global_obj);

  // compile the script once for all threads
  JSObject  **sot;
  JSScript* scriptt = JS_CompileFile(thr_context, thr_global_obj, "c:\\test.js");
	if (!scriptt) return 1;

  // create script object and AddRoot for the GC
  sot = (JSObject**)malloc(sizeof(JSObject *));
	*so = JS_NewScriptObject(thr_context, scriptt);
	if (!*so) return 1;
    
  if (!JS_AddRoot(thr_context, so)) return 1;

  // Define the property which should be common to all functions in the thread. Each thread
  // need to have its own thrglobal.
  JS_DefineProperty(thr_context,thr_global_obj, "thrglobal" ,INT_TO_JSVAL(0), NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT);
  
  jsval result;
  JSBool ok;
  for (int i=0; i<10000; i++) {
    ok = JS_ExecuteScript(thr_context,thr_global_obj,scriptt,&result);
    if (ok == JS_FALSE) cout << "bug";
  }
  
  char buf[80];
  cin.getline(buf,sizeof(buf));

  return 0;

}

*/

