/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
#include <stdlib.h>
#include <iostream.h>

#include "rvjsapi.h"

#include "jstestpr.h"

#define ExistingProperty "ExistingProperty"
#define NonExistingProperty "NonExistingProperty"

#define NUM_THREADS 10
#define SCRIPT_NAME "jstry.js"

JSRuntime *rt;
JSContext *super_context;
JSObject  *super_object;
JSScript  *script;

static JSClass stub_class = {
	"stub_class", 0,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_EnumerateStub,
	JS_ResolveStub,
	JS_ConvertStub,
	JS_FinalizeStub
};

//
// function for resolving functions from prototype.
static JSBool
proto_resolve_stub(JSContext *cx, JSObject *obj, jsval id) {
  jsval v;
  JSObject *func;
  const char* name;
  JSBool ok;

  if (!JSVAL_IS_STRING(id)) return JS_FALSE;
  name = JS_GetStringBytes(JSVAL_TO_STRING(id));
  if (!name) return JS_FALSE;
  //cout << "Proto resolve stub: called with - " << name <<  " Thread " << JS_GetContextThread(cx) << endl;
  
  JSObject* proto = JS_GetPrototype(cx,obj);
  if (!proto) return JS_FALSE;

  // cloning functions

  ok = JS_LookupProperty(cx,proto,name,&v);
  if (!ok) return JS_FALSE;

  if (!JSVAL_IS_VOID(v)) {
    if (JS_TypeOfValue(cx,v) == JSTYPE_FUNCTION) {
      //cout << "Proto resolve stub: resolving function - " << name << endl;

      func = JS_CloneFunctionObject(cx, JSVAL_TO_OBJECT(v), obj);
      if (!func) return JS_FALSE;

      ok = JS_DefineProperty(cx,obj, name ,OBJECT_TO_JSVAL(func), JS_PropertyStub, JS_PropertyStub, JSPROP_ENUMERATE | JSPROP_PERMANENT);
      if (!ok) return JS_FALSE;
    }
  }

  return JS_TRUE;
}

static JSClass proto_stub_class = {
	"proto_stub_class", JSCLASS_NEW_RESOLVE,
	JS_PropertyStub,	// add
	JS_PropertyStub,	// del
	JS_PropertyStub,	// get
	JS_PropertyStub,	// set
	JS_EnumerateStub,
  proto_resolve_stub,
	JS_ConvertStub,
	JS_FinalizeStub
};

//
// my_f
//
// the function thats being called from the script.
// UnComment only one of the lines.
static JSBool
my_f(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

  //*rval = JSVAL_ONE;

	jsval testVal;
  // The following 2 lines runs OKay
  JSBool ret = JS_LookupProperty(cx, obj, ExistingProperty, &testVal);
  //JSBool ret = JS_GetProperty(cx, obj, ExistingProperty, &testVal);

  // The following 2 lines cause the error.
  //JSBool ret = JS_LookupProperty(cx, obj, NonExistingProperty, &testVal);
  //JSBool ret = JS_GetProperty(cx, obj, NonExistingProperty, &testVal);
  
  return JS_TRUE;	
}


static JSBool
JSTest(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

  //*rval = JSVAL_ONE;

	jsval testVal;
  // The following 2 lines runs OKay
  JSBool ret = JS_LookupProperty(cx, obj, ExistingProperty, &testVal);
  //JSBool ret = JS_GetProperty(cx, obj, ExistingProperty, &testVal);

  // The following 2 lines cause the error.
  //JSBool ret = JS_LookupProperty(cx, obj, NonExistingProperty, &testVal);
  //JSBool ret = JS_GetProperty(cx, obj, NonExistingProperty, &testVal);
  
  return JS_TRUE;	
}

static JSBool
JSTestSleep(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) 
{
  return JS_TRUE;
}

static JSBool
JSTestPrint(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) 
{
  return JS_TRUE;
}

static JSBool
JSTestLookupProperty(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) 
{
  return JS_TRUE;
	jsval testVal;
  JSBool ret = JS_LookupProperty(cx, obj, ExistingProperty, &testVal);
}

//static JSBool
//JSTest(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
//{
//  return JS_TRUE;
//}

static JSBool JSTestDefineFunctions(JSContext* cx, JSObject* obj)
{
  return JS_TRUE;
}

//
//
JSScript *MyCompileScript(JSContext* cx, JSObject* obj, const char* scriptName)
{
  JSObject  **so;
  // compile the script
  JSScript* script = JS_CompileFile(cx, obj, scriptName);
	if (!script) {
    JSTestPR_Output("Error compiling script %s\n", scriptName);
    return  NULL;
  }

  // create script object and AddRoot for the GC
  so = (JSObject**)malloc(sizeof(JSObject *));
	*so = JS_NewScriptObject(cx, script);
	if (!*so) {
    JSTestPR_Output("Error creating new script object for %s\n", scriptName);
    return  NULL;
  }
  
  if (!JS_AddRoot(cx, so)) {
    JSTestPR_Output("Error in AddRoot for script %s\n", scriptName);
    return  NULL;
  }

  return script;
}

void JSGCFunc() {
  JSTestPR_Output("*** Starting GC Thread.\n");
	JSContext* cx = JS_NewContext(rt,8192);

  int round=0;
  while (!JSTestPR_IsTerminate()) {
		JS_GC(cx);
    round++;
    if (round%1000 == 0)
      JSTestPR_Output("*** GC Thread, round %d\n", round);

		//JSTestPR_Sleep(10);
  }
  JS_DestroyContext(cx);
}

void ThreadFuncWithLocalScript(int threadNum, JSContext *cx) 
{
	JSObject  *obj;
	jsval result;

	if (!cx) {
    JSTestPR_Output("Null context for thread %d.\n", threadNum);
    exit(0);
  }

  JS_SetContextThread(cx);
  JS_BeginRequest(cx);

  //
  // create a global-object with normal stub-class
  obj = JS_NewObject(cx, &stub_class, NULL, NULL);
	if (!obj) {
    JSTestPR_Output("Error in NewContext for thread %d.\n", threadNum);
    exit(0);
  }
  JS_SetGlobalObject(cx, obj);

  //
  // Initialize JS standard classes
  if (!JS_InitStandardClasses(cx,obj)) {
    JSTestPR_Output("Error in InitStandardClasses for thread %d.\n", threadNum);
    exit(0);
  }
  
  //
  // Define my_f for usage from script.
  JS_DefineFunction(cx ,obj,"my_f",my_f,0,0);

  //  
  // compile the script
  JSScript *script = MyCompileScript(cx, obj, SCRIPT_NAME);
	if (!script) 
    exit(0);

  //
  // Define an existing property.
	if (!JS_DefineProperty(cx, obj, ExistingProperty, INT_TO_JSVAL(threadNum),NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY)) {
    JSTestPR_Output("Error in Define property for thread %d.\n", threadNum);
    exit(0);
  }

  JS_EndRequest(cx);

  //
  // wait for all threads to be ready.
  JSTestPR_ThreadStarted();
  JSTestPR_WaitForNThreads(NUM_THREADS);

  int round=0;
  while(!JSTestPR_IsTerminate()) {
    round++;
		JS_BeginRequest(cx);
		JS_ExecuteScript(cx,obj,script,&result);
    JS_EndRequest(cx);
    JSTestPR_IncNumRounds(threadNum);
	}

  JS_DestroyContext(cx);
  JSTestPR_ThreadDone();
}

void ThreadFuncWithGlobalScript(int threadNum, JSContext *cx) 
{
	JSObject  *obj;
	jsval result;

	if (!cx) {
    JSTestPR_Output("Null context for thread %d.\n", threadNum);
    exit(1);
  }

  JS_SetContextThread(cx);

  JS_BeginRequest(cx);
  //
  // create a global-object with proto resolve.
  obj = JS_NewObject(cx, &proto_stub_class, super_object, NULL);
	if (!obj) {
    JSTestPR_Output("Error in NewContext for thread %d.\n", threadNum);
    exit(1);
  }
  JS_SetGlobalObject(cx,obj);

  //
  // Define an existing property.
	if (!JS_DefineProperty(cx, obj, ExistingProperty, INT_TO_JSVAL(threadNum),NULL, NULL, JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_READONLY)) {
    JSTestPR_Output("Error in Define property for thread %d.\n", threadNum);
    exit(0);
  }

  JS_EndRequest(cx);

  //
  // wait for all threads to be ready.
  JSTestPR_ThreadStarted();
  JSTestPR_WaitForNThreads(NUM_THREADS);

  int round=0;
  while(!JSTestPR_IsTerminate()) {
    round++;
		JS_BeginRequest(cx);
		JS_ExecuteScript(cx,obj,script,&result);
    JS_EndRequest(cx);
    JSTestPR_IncNumRounds(threadNum);
	}

  JS_DestroyContext(cx);
  JSTestPR_ThreadDone();
}

int main(int argc, char *argv[])
{
  // create runtime
  rt = JS_NewRuntime(8L*1024L*1024L);
	if (!rt) return 1;

  // create super cx
  super_context = JS_NewContext(rt,8192);
	if (!super_context) 
    return 0;

  // create super obj
  super_object = JS_NewObject(super_context, &stub_class, NULL, NULL);
	if (!super_object) 
    return 0;

  // add js functions to the super js
  if (!JS_InitStandardClasses(super_context,super_object)) 
    return 0;

  JS_DefineFunction(super_context ,super_object,"my_f",my_f,1,0);

  script = MyCompileScript(super_context, super_object, SCRIPT_NAME);
	if (!script) 
    return 0;

  JSTestPR_CreateGcThread(JSGCFunc);

  JSTestPR_CreateThreads(ThreadFuncWithGlobalScript, rt, super_context, NUM_THREADS);
  //JSTestPR_CreateThreads(ThreadFuncWithLocalScript, rt, super_context, NUM_THREADS);
  
  char buf[80];
  cin.getline(buf,sizeof(buf));
  JSTestPR_TerminateAll();
  cout << "Done ...";
  
  return 0;
}
*/

