/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef dXMLStream
#define dXMLStream

#pragma warning( disable: 4786 )


class iXMLStream
{
public:
	explicit iXMLStream();
	virtual ~iXMLStream();

	void fPushXML( const char* String );
	void fPushName( const char* String );
	void fPushData( const char* String );

	virtual void fPush( char Char ) = 0;
};


class iXMLElement
{
};


class cXMLElement:
	public iXMLElement
{
public:
	explicit cXMLElement( iXMLStream&, const char* Name, const char* Value );
	virtual ~cXMLElement();

protected:
	iXMLStream& fGetStream();

private:
	iXMLStream& mStream;
	const char* mName;

};


class iXMLElementRoot:
	public iXMLElement
{
public:
	typedef int cLevel;
};

class cXMLElementRoot:
	public cXMLElement,
	public iXMLElementRoot
{
public:
	explicit cXMLElementRoot( iXMLStream&, const char* Name, const char* Value, cLevel ParentLevel );

public:
	cLevel fGetLevel();

private:
	cLevel mLevel;
};
	

#endif // dXMLStream

