/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_BUFF_PART__
#define __WL_BUFF_PART__

#include <colclass.h>
#include <ordered.h>
#include <collectable.h>
//#include <stdio.h>
#include <ordered.h>
#include <RVCString.h>
#include "platform.h"

class DllExport CWLBuffPart : public RVCollectable {
private:
	const char *originBuffer;  //! the buffer which being pointed to
	char *privateBuffer; //! will hold a private copy of the part
	int   startLocation; //! start of buffer part (index)
	int   buffLength;        //! length of buffer part (charecters)


public:
	CWLBuffPart(const char *buff = NULL, int start = 0, int len = 0) :
	  originBuffer(buff), startLocation(start),
	  buffLength(len), privateBuffer(NULL)
	  {}

	virtual ~CWLBuffPart();

	void setPart(const char *buff, int start, int len);
	void resetPart();

	void updatePart(const char *newBuff);
	void updatePart(RVCString&  cstr) {updatePart((const char *)cstr);}

	void getPart(const char **part, int *l); //! get the part details
	const char *getPart();  //! get a pointer to the part
	bool isEmpty() { return (buffLength == 0); }
	int  length() { return buffLength; }

	//! works like strcpy. Returns -1,0,1 according to compare results
	int compare(const char *str, int l, bool p_bCaseInsensitive = false);  //! compare a sub-string
	int compare(const char *str, bool p_bCaseInsensitive = false); //! compare a null terminated string
	int compare(CWLBuffPart& part, bool p_bCaseInsensitive = false);
	int compare(RVCString& cstr, bool p_bCaseInsensitive = false);
};


#endif



