/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_URL_BASE__
#define __WL_URL_BASE__


#include <RVCString.h>
#include "platform.h"

//===========================URLBASE======================================
class DllExport urlBase
{
private:  
  RVCString m_OrigBase; //! The full usrl without the hash (for use with hash)
  RVCString m_base;			//! Full URL without query string and hash
  RVCString m_protocol;		//! -->http:// https:// ftp://
  RVCString m_host;			//! -->www.radview.com
  //RVCString port;			//! -->host:port
  //RVCString uri;			//! -->path + file
  RVCString m_path;			//! -->/subdir1/subdir2/
  RVCString m_file;			//! -->file.html
  //RVCString hash;			//! -->......#"..."
  
  int  m_subDirCount ;
  bool m_Parsed;
  
public:  
  explicit urlBase();
  explicit urlBase( const RVCString& p_sNewBase );
  virtual ~urlBase() {}
  
  //RVCString returnFile(){return file;}
  const RVCString& returnBase() const {return m_base;}
  void  calcUrl( const RVCString& srcUrl, RVCString& destUrl, bool bCalcEmpty=false, bool bUnEscapeURL = true);
  int		setBase( const RVCString& );  //! must be by value.
  int		parse();  //! must be by value.
  const char* host()    { if ( ! m_Parsed ) parse(); return m_host.    data(); }
  const char* path()    { if ( ! m_Parsed ) parse(); return m_path.    data(); }
  const char* protocol(){ if ( ! m_Parsed ) parse(); return m_protocol.data(); }   
};
#endif


