/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "rvhtmlattributefinder.h"
#include "rvhtmloffsetparser.h"
#include "rvhtmldietvirtualqueue.h"
#include <RVFile.h>


int main(int argc, char* argv[])
{ 
  if (argc < 2)
  {
    cout<<"You must supply filename"<<endl;
    return 1;
  }
  RVCString sFileName = argv[1];
  RVFile rwFile(sFileName);
  if (!rwFile.Exists())
  {
    cout<<"File not found"<<endl;
    return 1;
  }

  char sBuffer[10240];
  RVCString rwsBuffer;
  do
  {
    rwFile.Read(sBuffer, 10240);
    rwsBuffer.append(sBuffer);
  } while (!rwFile.eof());

  CHTMLOffsetParser* parser = new CHTMLOffsetParser("http://server.domain.com/");
  CRVHtmlDietVirtualQueue queue;
  parser->SetDietVirtualQueue(&queue);
	if (argc == 2)
  parser->ParseHTML(rwsBuffer.data(), rwsBuffer.length());
	else if (argc == 3)
		parser->ParseCSS(rwsBuffer.data());
	
  parser->PrintAll();
  delete parser;
  return 0;
}
