/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// CRVXMLElement.h: interface for the CRVXMLElement class.
//
//////////////////////////////////////////////////////////////////////

#ifndef CRVXMLELEMENT_H
#define CRVXMLELEMENT_H
#include <RVCString.h>

#include <tvslist.h>
#include <tvsldict.h>
#include "wlerrorlib.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRVXMLElement;
class CRVXMLDocument;

typedef RVTValSlist<CRVXMLElement> CRVXMLElementList;
typedef RVTValSlistDictionary<RVCString, RVCString> AttrDict;


#import "msxml.dll" named_guids
using namespace MSXML;

//#define DllExport   __declspec( dllexport )
class DllExport CRVXMLElement
{
friend CRVXMLDocument;
public:
	virtual ~CRVXMLElement();
	AttrDict get_attributes(CWLErrorInfo& p_ErrorInfo);
	RVCString get_attribute(RVCString p_sAttributeName, CWLErrorInfo& p_ErrorInfo);
	bool set_attribute(RVCString p_sAttributeName, RVCString p_sAttributeValue, CWLErrorInfo& p_ErrorInfo);
	RVCString get_name(CWLErrorInfo& p_ErrorInfo);
	RVCString get_value(CWLErrorInfo& p_ErrorInfo);
	bool set_value(RVCString p_sValue, CWLErrorInfo& p_ErrorInfo);
	CRVXMLElement get_parentElement(CWLErrorInfo& p_ErrorInfo);
	CRVXMLElementList get_childElements(CWLErrorInfo& p_ErrorInfo);
	CRVXMLElement add_childElement(CRVXMLElement& p_CRVXMLElement, CWLErrorInfo& p_ErrorInfo);
	CRVXMLElement add_childElement(RVCString p_sName, RVCString p_sValue, CWLErrorInfo& p_ErrorInfo);
	CRVXMLElement add_childElement(RVCString p_sName, RVCString p_sValue, AttrDict p_Attributes, CWLErrorInfo& p_ErrorInfo);
	bool is_empty(CWLErrorInfo& p_ErrorInfo);
	RVCString get_xml(CWLErrorInfo& p_ErrorInfo);
	CRVXMLElementList getElementsByTagName(RVCString p_sTagName, CWLErrorInfo& p_ErrorInfo);

private:
	IXMLDOMElementPtr m_pXMLDOMElement;
	IXMLDOMDocumentPtr m_pXMLDocument;
	CRVXMLElement(IXMLDOMDocumentPtr p_pXMLDomDocument, IXMLDOMElementPtr p_pXMLDomElement);
	CRVXMLElement(IXMLDOMDocumentPtr p_pXMLDomDocument, RVCString p_sName, RVCString p_sValue = "");
};


#endif // !defined(AFX_RVXMLELEMENT_H__A7784973_87E0_4B18_BB88_603E95F0D47F__INCLUDED_)
