/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//////////////////////////////////////////////////////////////////////
//
// RVXMLDocument.h: interface for the RVXMLDocument class.
//
//////////////////////////////////////////////////////////////////////
/*!
*
* \brief 
RadView XML Wrapper using xerces_c
*
* \author	Sergei Lvov
* \date		1/04/01
*
*/
#ifndef _RVXMLDOCUMENT_H_
#define _RVXMLDOCUMENT_H_
#include <RVCString.h>

#include <tvslist.h>
#include "rvxmlelement.h"

#include <xercesc/dom/DOMBuilder.hpp>
#include <xercesc/dom/DOMDocument.hpp>


class DllExport RVXMLDocument
{
public:
	RVXMLDocument(RVCString p_sRootElementName = "root");
	virtual ~RVXMLDocument();

	bool load(RVCString p_sURL,CWLErrorInfo& p_ErrorInfo);
#ifdef notdef
	RVCString get_xml(CWLErrorInfo& p_ErrorInfo);
#endif //notdef
	RVXMLElement get_documentElement(CWLErrorInfo& p_ErrorInfo);
	RVTValSlistDictionary<RVCString, RVCString> get_parseError(CWLErrorInfo& p_ErrorInfo);
private:
  XERCES_CPP_NAMESPACE::DOMBuilder* m_DOMparser;
  XERCES_CPP_NAMESPACE::DOMDocument* m_pDocument;
	RVXMLElement m_RootElement;
  static bool m_Initialized;
	RVTValSlistDictionary<RVCString, RVCString> m_parseErrors;

};

#endif // _RVXMLDOCUMENT_H_
