/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <iostream.h>
#include <RVCString.h>

#include <tvslist.h>
#define USE_MSXML
#ifdef USE_MSXML
#include "crvxmldocument.h"
#include "crvxmlelement.h"
#else
#include "rvxmldocument.h"
#include "rvxmlelement.h"
#endif // USE_MSXML

#include "FileAutoDiscovery.h"

////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////
void serialize(CRVXMLElement& p_DOMNode)
{
	CWLErrorInfo errorInfo;

	if (p_DOMNode.is_empty(errorInfo)) return;
	
	cout<<"| Node Name: "<<p_DOMNode.get_name(errorInfo);
	cout<<" | Node Value: "<<p_DOMNode.get_value(errorInfo);
	cout<<" | Node Type: "<<p_DOMNode.get_attribute("type",errorInfo)<<"|"<<endl;
//	cout<<endl<<"Node XML: "<<p_DOMNode.get_xml(errorInfo);
	

	CRVXMLElementList childNodes = p_DOMNode.get_childElements(errorInfo);
	for (unsigned int i = 0 ; i < childNodes.entries(); i++)
	{
		serialize(childNodes[i]);
	}
}

int main(int argc,char *argv[])
{
	CFileAutoDiscovery fad;
	fad.discoverPath( "E:\\IO_test\\testXML", "*.xml", true );
	return 0;
//ofer	using namespace MSXML;
	cout<<"/////////////////////////////////////////////////////////////////"<<endl;
	cout<<"/////////////////////////////////////////////////////////////////"<<endl;
	CWLErrorInfo errorInfo;
#ifdef USE_MSXML
	CRVXMLDocument rvXMLDoc(MSXMLParser);
#else
	CRVXMLDocument rvXMLDoc;
#endif //USE_MSXML
  //RVCString fn="v:\\bin\\dbIEui.xml";
  //RVCString fn="E:\\IO_test\\testXML\\DllNames.xml";
  RVCString fn="E:\\IO_test\\testXML\\DIR\\DllNames2.xml";
  if (argv[1] && *argv[1]) {
    fn = argv[1];
  }
	rvXMLDoc.load(fn.data(), errorInfo);
	cout<<"/////////////////////////////////////////////////////////////////"<<endl;
	cout<<endl<<endl;
//	cout<<rvXMLDoc.get_xml(errorInfo)<<endl;

	cout<<"/////////////////////////////////////////////////////////////////"<<endl;
	CRVXMLElement docElement = rvXMLDoc.get_documentElement(errorInfo);
	RVTValSlist<CRVXMLElement> children = docElement.get_childElements(errorInfo);
	serialize(docElement);

	cout<<"/////////////////////////////////////////////////////////////////"<<endl;
	cout<<"/////////////////////////////////////////////////////////////////"<<endl;

#ifdef USE_MSXML
	CRVXMLDocument xmlDoc(MSXMLParser);
//	cout<<xmlDoc.get_xml(errorInfo)<<endl;
#else
	RVXMLDocument xmlDoc;

#endif //USE_MSXML

	CRVXMLElement docRoot = xmlDoc.get_documentElement(errorInfo);

	CRVXMLElement newElement = docRoot.add_childElement("sergei", "rules",errorInfo);
	


	newElement.set_attribute("attrName1", "attrValue1", errorInfo);
	newElement.set_attribute("attrName2", "attrValue2", errorInfo);
	newElement.set_attribute("attrName3", "attrValue3", errorInfo);
	newElement.set_attribute("attrName4", "attrValue4", errorInfo);
	newElement.set_value("new value", errorInfo);

	AttrDict dict = newElement.get_attributes(errorInfo);
	
	docRoot.add_childElement("newElement1","el1 value",errorInfo);
	docRoot.add_childElement("newElement2","el2 value",errorInfo);
	docRoot.add_childElement("newElement3","el3 value",errorInfo);
	docRoot.add_childElement("newElement4","el4 value",errorInfo);
	::cout<<endl<<endl<<endl;
//	::cout<<xmlDoc.get_xml(errorInfo)<<endl;
	
	

	::cout<<"new Value: "<<newElement.get_value(errorInfo)<<endl;
	::cout<<endl<<endl<<endl;
//	::cout<<xmlDoc.get_xml(errorInfo)<<endl;

	CRVXMLElementList list = docRoot.get_childElements(errorInfo);

	for (unsigned int i = 0 ; i < list.entries(); i++)
	docRoot.add_childElement(list[i],errorInfo);

	::cout<<"==========================================================================";
	::cout<<endl<<endl<<endl;
	serialize(docRoot);

	//	::cout<<xmlDoc.get_xml(errorInfo)<<endl;

/*	CWLDialog* dialogs = new CWLDialog;
	loadDialogsTable(&dialogs);
	delete dialogs;*/
	return 0;
}
