
#ifndef rvjsapi_h___
#define rvjsapi_h___

#if defined(jsapi_h___) && !defined(SPIDERMONKEY4)
    #error jsapi.h already included. You must not #include "jsapi.h".
#endif

#ifndef JS_THREADSAFE
#define JS_THREADSAFE // in this module it is pre-defined, so order does not matter
#endif

#ifndef JS_PARANOID_REQUEST
#define JS_PARANOID_REQUEST
#endif

#ifdef DEBUG
#ifndef HASHMETER
#define HASHMETER
#endif
#endif

#ifndef GC_MARK_DEBUG
//#define GC_MARK_DEBUG
#endif

#include "jsapi.h"

JS_BEGIN_EXTERN_C

// jsapi.c

extern JS_PUBLIC_API(void) RVJS_SetAtomTimeclipState( JSRuntime*, JSBool isActive );
extern JS_PUBLIC_API(uint32) RVJS_AtomTimeclipBegin( JSContext* );
extern JS_PUBLIC_API(void) RVJS_AtomTimeclipEnd( JSContext*, uint32 timeclipIndex );

#define RVJS_CONTEXT_COUNTER_GC_SECTION 0
extern JS_PUBLIC_API(jsint*) RVJS_RefContextCounter( JSContext*, jsint index );
extern JS_PUBLIC_API(jsint) RVJS_GetContextCounter( JSContext*, jsint index );


// rvjsapi.c

extern JS_PUBLIC_API(JSBool) RVJS_IsInstanceOf( JSContext* cx, jsval val, JSClass* clasp );
extern JS_PUBLIC_API(JSBool) RVJS_IsFunction( JSContext* cx, jsval val );
extern JS_PUBLIC_API(JSIntn) RVJS_AtomicIntCounter( int* ArgList );
extern JS_PUBLIC_API(JSBool) RVJS_DefaultValue( JSContext* cx, jsval v, jsval* vp );
extern JS_PUBLIC_API(void*) RVJS_GetPrivate( JSContext* cx, JSObject* obj );
extern JS_PUBLIC_API(JSBool) RVJS_DefinePropertyId(JSContext *cx, JSObject *obj, jsval id, jsval value, JSPropertyOp getter, JSPropertyOp setter, uintN attrs);
extern JS_PUBLIC_API(JSBool) RVJS_DefineProperty(JSContext *cx, JSObject *obj, jsval id, jsval value, JSPropertyOp getter, JSPropertyOp setter, uintN attrs);
extern JS_PUBLIC_API(JSBool) RVJS_ReportUncaughtException( JSContext *cx );
extern JS_PUBLIC_API(void) RVJS_Assert( JSBool cond );

extern JS_PUBLIC_API(JSBool) RVJS_InitFunctionAndObjectClasses(JSContext *cx, JSObject *obj);


#ifdef JS_PARANOID_REQUEST
extern JS_PUBLIC_API(JSContext *) RVJS_NewContextThreadSafe(JSRuntime *rt, size_t stackChunkSize, JSBool isCheckRequest);
extern JS_PUBLIC_API(JSContext *) RVJS_NewContext(JSRuntime *rt, size_t stackChunkSize );
#endif

extern JS_PUBLIC_API(JSReportErrorFilenameCallback) RVJS_SetReportErrorFilenameCallbackRT(JSRuntime *rt, JSReportErrorFilenameCallback cb);

extern JS_PUBLIC_API(JSCompileErrorCallback) RVJS_SetCompileErrorCallbackRT(JSRuntime *rt, JSCompileErrorCallback cb);

extern JS_PUBLIC_API(JSReferenceErrorCallback) RVJS_SetReferenceErrorCallbackRT(JSRuntime *rt, JSReferenceErrorCallback cb);

extern JS_PUBLIC_API(JSThreadIdCallback) RVJS_SetThreadIdCallbackRT(JSRuntime *rt, JSThreadIdCallback cb);

extern JS_PUBLIC_API(JSExtraWhiteSpaceCallback) RVJS_SetExtraWhiteSpaceCallbackRT(JSRuntime *rt, JSExtraWhiteSpaceCallback cb);

extern JS_PUBLIC_API(JSReservedKeywordsCallback) RVJS_SetReservedKeywordsCallbackRT(JSRuntime *rt, JSReservedKeywordsCallback cb);

extern JS_PUBLIC_API(uint32) RVJS_GetAtomTableNentries( JSContext *cx );

extern JS_PUBLIC_API(const char**) RVJS_HashTableMeterNames();
extern JS_PUBLIC_API(void) RVJS_HashTableMeter( JSContext*, uint32 rTable, uint32* roSize, uint32* oMeters );

extern JS_PUBLIC_API(void) RVJS_StateInfo( JSContext* rCx, JSObject** oScopeChain );

extern JS_PUBLIC_API(void) RVJS_StateInfo( JSContext* rCx, JSObject** oScopeChain );

extern JS_PUBLIC_API(JSBool) RVJS_SwitchObjectContent( JSContext* cx, JSObject* obj1, JSObject* obj2 );

extern JS_PUBLIC_API(const char*) RVJS_GetClassName( JSObject* obj );

// Note that when string is not a valid number, 0 will be returned
extern JS_PUBLIC_API(JSBool) RVJS_JSVAL_To_Int( JSContext* cx, jsval v, int *pVal );

extern JS_PUBLIC_API(JSBool) RVJS_IsCallOpNext( JSContext* cx );

JS_END_EXTERN_C

#define RVJS_JSCLASS_FLAGS           JSCLASS_HAS_PRIVATE | JSCLASS_PROPERTY_GET_DEFINES
#define RVJS_PROPERTY_FLAGS          JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_GET_DEFINES
#define RVJS_READONLY_PROPERTY_FLAGS JSPROP_ENUMERATE | JSPROP_PERMANENT | JSPROP_GET_DEFINES | JSPROP_READONLY


#endif /* rvjsapi_h___ */

