# find platform, to determine compiler invokement command and options
WL_PLATFORM_TYPE := $(shell $(WL_TOP)/wl_platform_type)
ifneq ($(WL_PLATFORM_TYPE),)
include $(WL_TOP)/makefile.common.$(WL_PLATFORM_TYPE)
WL_BUILD_TYPE := $(WL_PLATFORM_TYPE)
ifdef OPTIMIZE
WL_BUILD_TYPE := $(WL_PLATFORM_TYPE)_OPTIMIZE
endif # on OPTIMIZE
endif # on WL_PLATFORM_TYPE

ifeq ($(WL_PLATFORM_TYPE),solaris)
JDK_SUBDIR := solaris
endif
ifeq ($(WL_PLATFORM_TYPE),solaris7)
JDK_SUBDIR := solaris
endif
ifeq ($(WL_PLATFORM_TYPE),linux)
JDK_SUBDIR := linux
endif
ifeq ($(WL_PLATFORM_TYPE),ppc750_linux)
JDK_SUBDIR := ppc750_linux
endif



INC_INSTALL_LOC    := $(INSTALL_TOP)/inc
FRM_INSTALL_LOC    := $(INSTALL_TOP)/frm
LIB_INSTALL_LOC    := $(INSTALL_TOP)/$(WL_BUILD_TYPE)/lib/$($(LIBR)_DIR)
BIN_INSTALL_LOC    := $(INSTALL_TOP)/$(WL_BUILD_TYPE)/bin/$($(LIBR)_DIR)


INCLUDES += -I../inc -I$(WL_TOP)/inc -I$(RW_ROOT)

OTHER_LIBS += -L$(RW_ROOT)/lib

DEFINES += $(PLATFORM_DEFINES) $(STD_JV_DEFINES) 





init :
	echo "do nothing"


lib ::
	+$(LOOP_OVER_PREDIRS) 

lib :: $(LIBRARY)

lib ::
	+$(LOOP_OVER_DIRS)
 

programs :
	echo "do nothing"

tests : $(PROGRAM)

install : install_lib install_extra

install_programs :
	echo "do nothing"

install_lib : $(SHARED_LIBRARY) 
	$(INSTALL_BIN) $(SHARED_LIBRARY) $(LIB_INSTALL_LOC)


#install_extra :          		\
#		./jsjava.h  \
#		./loadengineextras.h \
#		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jni.h \
#		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jni_md.h \
#		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jawt_md.h
#	$(INSTALL) $^ $(INC_INSTALL_LOC)


ifeq ($(WL_PLATFORM_TYPE),solaris)
install_extra :          		\
		./jsjava.h  \
		./loadengineextras.h \
		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jni.h \
		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jni_md.h \
		../../../tools/Solaris_JDK_1.2.2_05/include/solaris/jawt_md.h
#		$(JDK)/include/jni.h \
#		$(JDK)/include/$(JDK_SUBDIR)/jni_md.h \
#		$(JDK)/include/$(JDK_SUBDIR)/jawt_md.h
endif
ifeq ($(WL_PLATFORM_TYPE), solaris7)
install_extra :				\
		./jsjava.h		\
		./loadengineextras.h	\
		$(JDK)/include/jni.h	\
		$(JDK)/include/$(JDK_SUBDIR)/jni_md.h
endif
ifeq ($(WL_PLATFORM_TYPE),linux)
install_extra :          		\
		./jsjava.h  \
		./loadengineextras.h \
		$(JDK)/include/jni.h \
		$(JDK)/include/$(JDK_SUBDIR)/jni_md.h
endif
	$(INSTALL) $^ $(INC_INSTALL_LOC)



