# find platform, to determine compiler invokement command and options
WL_PLATFORM_TYPE := $(shell $(WL_TOP)/wl_platform_type)
ifneq ($(WL_PLATFORM_TYPE),)
include $(WL_TOP)/makefile.common.$(WL_PLATFORM_TYPE)
WL_BUILD_TYPE := $(WL_PLATFORM_TYPE)
ifdef OPTIMIZE
WL_BUILD_TYPE := $(WL_PLATFORM_TYPE)_OPTIMIZE
endif # on OPTIMIZE
endif # on WL_PLATFORM_TYPE



INC_INSTALL_LOC    := $(INSTALL_TOP)/inc
INC_PLATFORM_INSTALL_LOC := $(INSTALL_TOP)/inc_$(WL_PLATFORM_TYPE)
FRM_INSTALL_LOC    := $(INSTALL_TOP)/frm
LIB_INSTALL_LOC    := $(INSTALL_TOP)/$(WL_BUILD_TYPE)/lib/$($(LIBR)_DIR)
BIN_INSTALL_LOC    := $(INSTALL_TOP)/$(WL_BUILD_TYPE)/bin/$($(LIBR)_DIR)

WL_INCLUDES := -I$(WL_TOP)/tools/include \
                -I$(SSLPLUS_ROOT)/ssl/include \
                -I$(SSLPLUS_ROOT)/ssl/api \
                -I$(SSLPLUS_ROOT)/shared/api \
                -I$(SSLPLUS_ROOT)/cert/api \
                -I$(SSLPLUS_ROOT)/ezcrypto_c/api \
                -I$(MOZILLA_ROOT)/dist/include \
                -I$(MOZILLA_ROOT)/dist/include/xpcom \
                -I$(MOZILLA_ROOT)/dist/include/nspr \
                -I$(MOZILLA_ROOT)/dist/include/string \
                -I$(MOZILLA_ROOT)/dist/include/htmlparser \
                -I$(MOZILLA_ROOT)/dist/include/necko \
                -I$(MOZILLA_ROOT)/dist/include/unicharutil \
                -I$(WL_TOP)/inc \
                -I$(WL_TOP)/inc_$(WL_PLATFORM_TYPE) \
                -I$(RW_ROOT) \
                -I$(WL_TOP)/tools/galtech_u/all/Include \
                $(NULL)


INCLUDES += -I../../inc -I$(WL_TOP)/inc $(WL_INCLUDES)

OTHER_LIBS += -L$(RW_ROOT)/lib

DEFINES += $(PLATFORM_DEFINES) $(STD_JV_DEFINES) 





init :
	@echo "Nothing to do for target $@"


lib ::
	+$(LOOP_OVER_PREDIRS) 

lib :: $(SHARED_LIBRARY) install_extra_platform

lib ::
	+$(LOOP_OVER_DIRS)
 

programs :
	@echo "Nothing to do for target $@"

tests : $(PROGRAM)

install : install_extra install_extra_platform install_lib

install_programs :
	@echo "Nothing to do for target $@"

install_lib : $(SHARED_LIBRARY) 
ifneq ($(SHARED_LIBRARY),)
	$(INSTALL_BIN) $(SHARED_LIBRARY) $(LIB_INSTALL_LOC)

else
install_lib :
	@echo "Nothing to do for target $@"

endif

ifeq ($(DEPTH),.)
install_extra : \
jscompat.h \
jsapi.h \
jscpucfg.h \
jsdate.h \
jsdbgapi.h \
jslong.h \
jsnum.h \
jsotypes.h \
jsopcode.h \
jsopcode.tbl \
jsosdep.h \
jsprvtd.h \
jspubtd.h \
jstypes.h \
liveconnect/jsjava.h \
../jsd/jsdebug.h
	$(INSTALL) $^ $(INC_INSTALL_LOC)




install_extra_platform : \
$(OBJDIR)/jsautocfg.h
	$(INSTALL) $^ $(INC_PLATFORM_INSTALL_LOC)

else
install_extra :
	@echo "Nothing to do for target $@"

install_extra_platform :
	@echo "Nothing to do for target $@"

endif

