/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// "WLStatManagerGlobals.h"

#ifndef __WLStatManaferGlobals_H__
#define __WLStatManaferGlobals_H__


#define INSERT_DATA_FAILED        0
#define INSERT_DATA_OK            1

#define STATISTIC_TYPES_NAMES_NUM 12

#define MON_DB_OPEN_FILE          0
#define MON_DB_CREATE_FILE        1
#define MON_DB_START_CODE         3

#define SAVED_SESSION             0
#define RUNNING_SESSION           1

#define SECTION_BY_AGENDA         0
#define SECTION_BY_MEASUREMENT    1

#define ITERATOR_NUM_OF_CACHES    5
#define MEASUREMENT_CACHE_SIZE    20

#define LOAD_SIZE_STR             "LoadSize"
#define TIMER_STR                 "Timer"
#define PERF_MON_STR              "NTPerformance"
#define TRANSACTION_COUNTER_STR        "TransactionCounter"
#define TRANSACTION_TIMER_STR          "TransactionTimer"
#define TRANSACTION_REASON_COUNTER_STR "TransactionReasonCounter"
#define COUNTER_STR               "Counter"  // Stat
#define COUNTER_PER_SEC_STR       "CounterPerSec"
#define MEASUREMENT_STR           "Measurement"
#define MEASUREMENT_PER_SEC_STR   "MeasurementPerSec"
#define ACCUMULATOR_STR           "Accumulator"
#define ACCUMULATOR_PER_SEC_STR   "AccumulatorPerSec"

/*  Old Setting
==========================================
#define LOAD_SIZE_MASK            275   // min, max, average, current value (last sum)
#define TIMER_MASK                535   // min, max, count, average, l_min, l-Max, current value (last average)
#define PERF_MON_MASK             531   // min, max, average, current value (last average)
#define TRANSACTION_COUNTER_MASK  283   // min, max, sum, average, current value (last Sum)
#define TRANSACTION_TIMER_MASK    535   //
#define TRANSACTION_REASON_COUNTER_MASK 283
#define COUNTER_MASK              283   // min, max, sum, average, current value (last sum)
#define COUNTER_PER_SEC_MASK      275   // min, max, average, current value (last sum)
#define ACCUMULATOR_MASK          283   // min, max, sum, average, current value (last Sum)
#define ACCUMULATOR_PER_SEC_MASK  275   // min, max, sum, average, current value (last Sum)
#define MEASUREMENT_MASK          531   // min, max, average, current value (last average)
#define MEASUREMENT_PER_SEC_MASK  531   // min, max, average, current value (last average)

#define TIMER_CUR_VALUE_INDEX               9
#define COUNTER_CUR_VALUE_INDEX             8
#define LOAD_SIZE_CUR_VALUE_INDEX           8
#define PERF_MON_CUR_VALUE_INDEX            9
#define COUNTER_PER_SEC_CUR_VALUE_INDEX     8         // Last Sum
#define TRANSACTION_COUNTER_CUR_VALUE_INDEX 8         // Last Sum
#define TRANSACTION_TIMER_CUR_VALUE_INDEX   9         // Last Average
#define TRANSACTION_REASON_COUNTER_CUR_VALUE_INDEX 8  // Last Sum
#define ACCUMULATOR_CUR_VALUE_INDEX         8
#define ACCUMULATOR_PER_SEC_CUR_VALUE_INDEX 8
#define MEASUREMENT_CUR_VALUE_INDEX         9
#define MEASUREMENT_PER_SEC_CUR_VALUE_INDEX 9         // Last Sum

*/

// Min	Max	count	Sum	Avg	STDev	L-Min	L-Max	L-Count	L-Sum	L-Avg	L-STDev
// 1	  2	  4	    8	  16	32	  64	  128	  256	    512	  1024  2048

const int LOAD_SIZE_MASK_ADV                       = 567  ;
const int TIMER_MASK_ADV                           = 4095 ;
const int PERF_MON_MASK_ADV                        = 4095 ;

const int COUNTER_MASK_ADV                         = 1595 ;
const int COUNTER_PER_SEC_MASK_ADV                 = 1587 ;
const int ACCUMULATOR_MASK_ADV                     = 1595 ;
const int ACCUMULATOR_PER_SEC_MASK_ADV             = 1587 ;
const int MEASUREMENT_MASK_ADV                     = 3835 ;
const int MEASUREMENT_PER_SEC_MASK_ADV             = 2827 ;

const int TRANSACTION_COUNTER_MASK_ADV             = 1595 ;
const int TRANSACTION_REASON_COUNTER_MASK_ADV      = 1595 ;
const int TRANSACTION_TIMER_MASK_ADV               = 4095 ;
///////////////////////////////////////////////////////
const int LOAD_SIZE_MASK                       = 531  ;
const int TIMER_MASK                           = 1047 ;
const int PERF_MON_MASK                        = 1043 ;

const int COUNTER_MASK                         = 539 ;
const int COUNTER_PER_SEC_MASK                 = 531 ;
const int ACCUMULATOR_MASK                     = 539 ;
const int ACCUMULATOR_PER_SEC_MASK             = 531 ;
const int MEASUREMENT_MASK                     = 1043 ;
const int MEASUREMENT_PER_SEC_MASK             = 1043 ;

const int TRANSACTION_COUNTER_MASK             = 539 ;
const int TRANSACTION_REASON_COUNTER_MASK      = 539 ;
const int TRANSACTION_TIMER_MASK               = 1047 ;

// 0-min    1-max    2-count    3-sum    4-average
// 5-Lmin   6-Lmax   7-Lcount   8-Lsum   9-Laverage

// Type Mask ( Test Summery - Current Slice )
enum { CURRENT_SLICE_MASK = 4032 };
enum { TEST_SUMMARY_MASK  = 63 };

/*
 Old seting
   8 = Last Sum
   9 = Last Average
*/
#define TIMER_CUR_VALUE_INDEX               10
#define COUNTER_CUR_VALUE_INDEX             9
#define LOAD_SIZE_CUR_VALUE_INDEX           9
#define PERF_MON_CUR_VALUE_INDEX            10
#define COUNTER_PER_SEC_CUR_VALUE_INDEX     9         // Last Sum
#define TRANSACTION_COUNTER_CUR_VALUE_INDEX 9         // Last Sum
#define TRANSACTION_TIMER_CUR_VALUE_INDEX   10         // Last Average
#define TRANSACTION_REASON_COUNTER_CUR_VALUE_INDEX 9  // Last Sum
#define ACCUMULATOR_CUR_VALUE_INDEX         9
#define ACCUMULATOR_PER_SEC_CUR_VALUE_INDEX 9
#define MEASUREMENT_CUR_VALUE_INDEX         10
#define MEASUREMENT_PER_SEC_CUR_VALUE_INDEX 10         // Last Sum

#define HEADERSIZE   1000



#define WRITE_NUM                 10

// Used from the Monitor
typedef enum { SDTMin,
               SDTMax,
               SDTCount,
               SDTSum,
               SDTAverage,
               SDTSTDev,
               SDTLastMin,
               SDTLastMax,
               SDTLastCount,
               SDTLastSum,
               SDTLastAverage,
               SDTLastSTDev,
               SDTCurrentValue,
               SDTError
} StatisticsDataType;



// the statistic points members
typedef struct {  double  time;
	                double	min;
	                double	max;
	                double	count;
	                double	sum;
	                double	average;
	                double	lastMin;
	                double	lastMax;
	                double	lastCount;
	                double	lastSum;
	                double	lastAverage;
                } MeasurementArrayItem_45;

const double FIRST_STDEV_VERSION = 5.0;
const double FIRST_HITS_VERSION = 5.0;
const double FIRST_NO_PERSEC_KEEP_VERSION = 3.0;

typedef struct {  double  time;
	                double	min;
	                double	max;
	                double	count;
	                double	sum;
	                double	average;
                  double	STDev;
	                double	lastMin;
	                double	lastMax;
	                double	lastCount;
	                double	lastSum;
	                double	lastAverage;
                  double	lastSTDev;
                } MeasurementArrayItem;

typedef enum  { PER_SECOND  } ConversionType;

#endif


