/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// WLStatPointTypeEnum.h: interface for the CWLStatPointTypeEnum class.
// 
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WLSTATPOINTTYPEENUM_H__FCE61BD3_D494_11D3_9650_0090272BB4A4__INCLUDED_)
#define AFX_WLSTATPOINTTYPEENUM_H__FCE61BD3_D494_11D3_9650_0090272BB4A4__INCLUDED_

#include <RVCString.h>
#include "platform.h"

class DllExport CWLStatPointTypeEnum  
{
public:
  typedef enum {
    NotSet = 0,
    Measurement = 1,
	  Timer = 2,
	  Counter = 4,
	  Accumulator = 8,
	  LoadSize = 16,
    TransactionCounter = 32,
    TransactionTimer = 64,
    TransactionReasonCounter = 128,
    MeasurementPerSec = 256,
    CounterPerSec = 512,
    NTPerformance = 1024,
    AccumulatorPerSec = 2048
  } PointType;

  

public: 
	static const char* GetStringFromEnumType(PointType type);
	static const char* GetTypeName(PointType  type);
	static void GetEnumTypeFromString(const RVCString& StringType, PointType& retType);
	CWLStatPointTypeEnum();
	virtual ~CWLStatPointTypeEnum();
};

#endif // !defined(AFX_WLSTATPOINTTYPEENUM_H__FCE61BD3_D494_11D3_9650_0090272BB4A4__INCLUDED_)

