/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// CEASTestTalkClient.h: interface for the CEASTestTalkClient class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CEASTESTTALKCLIENT_H__7770B943_740B_11D4_8831_0004AC15A422__INCLUDED_)
#define AFX_CEASTESTTALKCLIENT_H__7770B943_740B_11D4_8831_0004AC15A422__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "udpsender.h"
#include "udpreceiver.h"
#include <RVCString.h>


#define PING_CONFIGURATION_FILE "EASTestTalkConfig.ini"


class CEASTestTalkClient: public UDPSender 
{
public:
	CEASTestTalkClient();
	virtual ~CEASTestTalkClient();

	virtual int  Init(u_short listenPort);
	virtual void Start(void);
	virtual void Stop(void);

	const char* GetClientName(void);

	int  LoadConfigFile(void);
	int  UpdateConfigFile(void);

protected:
	virtual int Run(void);

protected:
	UDPReceiver				m_Receiver;
	RVCString					m_EASTTServerName;
	RVCString					m_EASTTClientName;
	RVCString         m_ConfigFilePath;
};

#endif // !defined(AFX_CEASTESTTALKCLIENT_H__7770B943_740B_11D4_8831_0004AC15A422__INCLUDED_)

