/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TestTalkClass_H
#define __TestTalkClass_H

#include <RVCString.h>
#include "wlerrorlib.h"
#include "platform.h"

class CTestTalkEventServer;     
class CTestTalkNetListener;     
class CTestTalkClientListener;  

typedef unsigned short u_short;

class DllExport CTestTalkClass 
{
public:
	u_short                   m_tcpNetPort;
	u_short                   m_tcpClientsPort;

	CTestTalkEventServer     *m_EventServer;
  
  CTestTalkNetListener     *m_NetListenSock;
  CTestTalkClientListener  *m_ClientsListenSock;

	RVCString                 m_LocalHostName;
	RVCString                 m_LocalHostAddress;
  RVCString                 m_ErrorMessage;

public:
  CTestTalkClass();
  ~CTestTalkClass();

  virtual bool Init();
  virtual void Terminate();
  virtual bool IsOtherTestTalkAlive();

  virtual void ErrorMessageHandler(WLLogMessage::Severity severity, const char* errorMsg);

protected:
  virtual void MarkTestTalkAlive();
  virtual void ReportPortBusyError(int portNumber);
};

#endif //__TestTalkClass_H

