/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TestTalkClientCommunicator_H
#define __TestTalkClientCommunicator_H

#include <colclass.h>
#include <thr.h>

#include "tvpsync.h"
#include "streamsocket.h"
#include "testtalkclientobjimp.h"

/****************** CTestTalkClientCommunicator Definition ******************/

class CTestTalkClientCommunicator : public RVCollectable
{
private:
  bool                    m_Valid;
  CTestTalkClientObject&  m_TestTalkClientObject;

  RVThread            m_ReaderThread;
  //RVCriticalSection   m_Touch;
  RVTRecursiveLock<RVMutexLock>   m_Touch;

  StreamSocket        m_StreamSocket;
	bool                m_Terminate;
  TVPManualEvent      m_ReaderStartEvent;
  TVPManualEvent      m_ReaderDoneEvent;

protected:  // protected member functions

public:     // public memeber functions
  CTestTalkClientCommunicator(CTestTalkClientObject& ttcc);
  virtual ~CTestTalkClientCommunicator();

  void Init();
  bool Start();
  virtual void Terminate(bool waitForThreads = true);
  bool Valid() { return m_Valid; }

  void StartReader();
  void StartWriter();

  void emptyMessagesQueue();
  
  int doReading();
  bool sendMessage(void* msg, int len, short type, short subtype);

  virtual char *nameOf() const
  {
    return ("CTestTalkClientCommunicator");
  }
};

void TestTalkClearClientsTable();

#endif //__TestTalkClientCommunicator_H

