/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/***********************************************************************
/* Name : TestTalkClientInstance.h
/* Purpose : define the client-instance class.
/*
/* Description : 
/*
/* Creation: Yahali, 5-Nov-93
/* Updates :  Who          When         What
/*                          
/***********************************************************************/
#ifndef __TestTalkClientInstance_H
#define __TestTalkClientInstance_H

#include "clntsrv.h"
//#include "testtalkeventserver.h"

class CTestTalkClientConnection; // tentative declerarion.

class TestTalkClientInstance: public ClientObj
{
private:
  RVCString		    m_ClientName;
  CTestTalkClass *m_TestTalkMain;
public:
	CTestTalkClientConnection   *clientConn;

public:
	TestTalkClientInstance(const char* name, CTestTalkClientConnection *conn, CTestTalkClass *ttMain);

  virtual ~TestTalkClientInstance();

	void Terminate();

  int doneReadingMessage(void* msg, int len, short type, short subtype);

  virtual char *nameOf() const
  {
	 return ("TestTalkClientInstance");
  }

  virtual void printOn( ostream& ) const;

  int sendMsgToClient(BaseEvent& e);


  const char* name() { return (const char*)m_ClientName; }
};

#endif // __TestTalk_CLIENTINST_H

