/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
 * netclnt.h   -- NetView Connection Module Definitions.
 *
 *   who          when          what
 *  Yahali     25-Oct-93     Creation.
 *
 */
#ifndef __TestTalkClientObj_H
#define __TestTalkClientObj_H

#ifndef _WINDOWS_
//#include <windows.h>
#endif 
#include "platform.h"
#include "typedmsg.h"
#include "thetml.h"

class CTestTalkClientObject;

class DllExport TestTalkClientObject {
private:
  CTestTalkClientObject*  myself;
  bool                    valid;

public:
	TestTalkClientObject();
	~TestTalkClientObject();

  bool Valid() {return valid;}

	bool NETInit(const char* tmlInstance, unsigned short port = 0);
	bool NETTurnOn();
	bool NETTurnOff();
	void NETTerminate();

	bool NETCopyFile(long msgId, const char *data, size_t dataSize, const char *addr);
	bool NETSendMultiMessage(const char *data, size_t dataSize, const char* clientsList);
	bool NETSendMessage(const char *data, size_t dataSize, const char *addr);
	bool NETSendMessageNoresponse(const char *data, size_t dataSize, const char *addr);
	bool NETSendMessageNowait(long msgId, const char *data, size_t dataSize, const char *addr);

	const char* NETFetchMessage();
	const char* NETWaitMessage();
	const char* NETWhoAmI();
	const char* NETLocalHostName();
	int NETGetLastStatus();
	const char* NETGetLastErrorMessage();

  virtual bool NewMessageEvent(TypedMessageObject* tmo, short qtype);
};

void DllExport TestTalkClientTerminate();

//*************** Internal error codes *********************//
#define NETSTATUS_SUCCESS 0
#define NETERROR_GETSHARESTRUCTPTR    15000
#define NETERROR_GETAPPINSTANCE       15001
#define NETERROR_TVNETNOTUP           15002
#define NETERROR_INITQUEUEWINDOWS     15003
#define NETERROR_SENDINGINITTOTVNET   15004
#define NETERROR_NETISDOWN            15005
#define NETERROR_MESSAGETOOLONG       15006
#define NETERROR_REQUESTTOTVNETFAILED 15007
#define NETERROR_SENDMESSAGEFAILURE   15008


#endif // __TestTalkClientObj_H

