/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TestTalkEventServer_H
#define __TestTalkEventServer_H

#include <hashtab.h>
#include <thr.h>

#include "clntsrv.h"
#include "netevent.h"
#include "tvpsync.h"
#include "testtalkclass.h"
#include "testtalkclientinstance.h"
#include "testtalknetconnection.h"

//
// The TestTalk evens server object.
//
class CTestTalkEventServer: public ServerObj
{
private:
  RVTRecursiveLock<RVMutexLock>  m_EventLock;
	RVHashTable                   m_ClientsTable;
	RVHashTable                   m_HostsTable;
  CTestTalkClass               *m_TestTalkMain;
  bool                          m_InsideCleanup;

public:
  CTestTalkEventServer(CTestTalkClass *ttMain);

  virtual ~CTestTalkEventServer();

	void cleanUp();
  
  int dispatchClientEvent(TestTalkClientEvent& event);
  
  void registerClientEvent(const char* cn, TestTalkClientInstance& clnt, int op);
  
	void removeClient(TestTalkClientInstance& client);

  int dispatchHostEvent(TestTalkHostEvent& event);
  
  void registerHostEvent(const char* thn, CTestTalkHostConnection& hc, int op);
  
	void removeHost(CTestTalkHostConnection& host);

  virtual char *nameOf() const
  {
    return ("CTestTalkEventServer");
  }
};

#endif //__TestTalkEventServer_H

