/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// rfsmessageslistener.cpp: implementation of the RFSMessagesListener class.
//
//////////////////////////////////////////////////////////////////////

#include "rfsmessageslistener.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RFSMessagesListener::RFSMessagesListener()
{

}

RFSMessagesListener::~RFSMessagesListener()
{

}


//////////////////////////////////////////////////////////////////////
// Methods impl
//////////////////////////////////////////////////////////////////////

void RFSMessagesListener::MessageDispatched(CAssociativeArray& message)
{
	if( message.KeyExists("$RFSRequest") )
	{
		RVCString symbol = message.GetValueOfParameter("$RFSRequest");
		ProcessRFSRequest(message, symbol);
	}
	else if( message.KeyExists("$RFSResponse") )
	{
		RVCString symbol = message.GetValueOfParameter("$RFSResponse");
		ProcessRFSResponse(message, symbol);
	}
}
