/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#ifndef __TV_UNIX__
#include <process.h>    /* _beginthread, _endthread */
#include <io.h>
#endif
#include <RVCString.h>

#include "netmsg.h"
#include "nvspackmsg.h"
#include "testtalkclientobj.h"
#include "associativearray.h"
#include "netkernelmessagehandler.h"
#include "eastesttalkserver.h"
#include "runtesttalk.h"
#include "handlers.h"
#include "tvenv.h"
#include "rfs.h"

void RFSTest()
{
	try
	{
		RVCString baseDir;
		RVCString sendToDir;
		RVCString getToDir;
		RVCString resultDir;
		CAssociativeArray pingMsg;
		FilesAssociationArchive archive;

		RVCString remoteHost = "localhost";

		CNetMessageHandler handler("rfstest");

		handler.Init();

		RFS rfs(&handler);
		//RFS rfs;

		printf("TV_TOP=%s\n", rfs.GetRemoteInstallationDir(remoteHost));
		printf("Temp=%s\n", rfs.GetRemoteTempDirectory(remoteHost));
		printf("User Dir=%s\n", rfs.GetRemoteUserDir(remoteHost));

		baseDir = rfs.CreateRemoteBaseDirectory(remoteHost, RFS::InstallationDir, true);
		sendToDir = baseDir + "\\send";
		getToDir  = baseDir + "\\get";

		printf("Base Dir: %s\n", baseDir);

		rfs.CreateRemoteDirectory(remoteHost, sendToDir);
		rfs.CreateRemoteDirectory(remoteHost, getToDir);
		
		/*
		archive.SetDefualtDestinationDirectory(sendToDir);
		archive.AddFileAssociation("C:\\Temp\\NotWorkingVer.zip", "1.zip");
		archive.AddFileAssociation("C:\\Temp\\played.txt", "");
		//archive.AddFileAssociation("C:\\Temp\\NotWorkingVer.zip", "C:\\Temp\\CopyOfNotWorkingVer.zip");
		//archive.AddFileAssociation("C:\\Temp\\played.txt", "C:\\Temp\\CopyOfplayed.txt");

		rfs.SendArchive(remoteHost, &archive);
		printf("1\n");

		archive.Reset();
		archive.SetDefualtDestinationDirectory(getToDir);
		archive.AddFileAssociation("V:\\bin_d\\TestTalkUtil.dll", NULL);
		archive.AddFileAssociation("V:\\bin_d\\TestView.dll", NULL);

		rfs.GetArchive(remoteHost, &archive);

		printf("2\n");
		rfs.DeleteRemoteFile(remoteHost, sendToDir + "\\played.txt");
		rfs.DeleteRemoteDirectory(remoteHost, sendToDir);
		rfs.DeleteRemoteFile(remoteHost, "c:\\rvtemp\\played1.txt");
		*/
	}
	catch(RFSException& e)
	{
		printf("%s\n", e.GetMessage());
	}
}

class CTestTalkClientTestObject : public TestTalkClientObject
{
public:
  CTestTalkClientTestObject() {}
  virtual ~CTestTalkClientTestObject() {}

  virtual bool NewMessageEvent(TypedMessageObject* tmo, short qtype);
};

bool CTestTalkClientTestObject::NewMessageEvent(TypedMessageObject* tmo, short qtype)
{
  switch (qtype)
  {
    case DataQ:
    case ControlQ:
      return true;

    case AckQ:
      {
        TestTalkMessage* ttm = NVSTmo2Ttm(tmo);
        printf("Recieved Ack %d for message ID %d\n", ttm->getType(), ttm->getMessageId());
        //m_MyNetMessageHandler->HandleEvent((const char*)ttm->getData());
        delete ttm;
      }
      return false;

    default:
      return false;
  }

  return false;
}

CTestTalkClientTestObject *tc = new CTestTalkClientTestObject;

static char buf[800] = "";

long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

RVCString whoami;
RVCString curname = "";

#define TestTalkPort 9010

void NewThread( void *dummy )
{
  curname += "A";
	int netIsUp = tc->NETInit(curname,TestTalkPort);
  if (!netIsUp) {
    cout << "Error in Init: " << tc->NETGetLastErrorMessage() << endl;
    return;
  }
  cout << "New thread: " << tc->NETWhoAmI() << endl;
	int b = tc->NETSendMessage("aaabbbccc", strlen("aaabbbccc")+1, whoami);
	printf("Send local Message by thread returned %d\n",b);
  tc->NETTerminate();
}

/*
int WINAPI WinMain(
		HINSTANCE hInstance,	// handle to current instance
    HINSTANCE hPrevInstance,	// handle to previous instance
    LPSTR lpCmdLine,	// pointer to command line
    int nCmdShow 	// show state of window
		)
*/

//********************************************************************//
// UDPServer for EAS
// BEGIN:
class Server: public EASTestTalkServer
{
	virtual void OnPong(const char* hostName)
	{
		cout<<"Server::OnPong - "<<hostName<<endl;
	}
};
// END;

int main(int argc, char* argv[])
{
	if(!RunTestTalk())
		return 0;

	RFSTest();

	return 0;
	/*CAssociativeArray array;
	CNetMessageHandlerTest handler;
	handler.Init(9010);
	array.AddCouple("SendTest", "empty string");
	handler.SendMessage(array, argv[1], "error sending message");
	handler.WaitForTerminate();
	handler.Terminate();
	return 0;*/

	if(argc > 1 && strcmp(argv[1], "-udpserver") == 0) {
		Server server;

		if(server.Init(9860)) {
			int stop;

			server.Start();
			server.InitPing("eyal", 9860, "eyal", 500);
			cin>>stop;
			server.Stop();
			//Sleep(15000);
			//server.Stop();

			//server.Init(9860);
			//server.Start();
			//server.InitPing("eyal", 9860, "eyal", 1100);
			//Sleep(15000);
			//server.Stop();
		}
		return 0;
	}

	int choice = 0;
	int netIsUp = tc->NETInit((argc>1?argv[1]:"1"),TestTalkPort);
  whoami = tc->NETWhoAmI();
  cout << "Starting client " << whoami << endl;

	NetMsgHandler mh("CopyFile");
	mh.Init();

	TVEnvContainerClass tvpc;
	while (1) {
		switch (choice)
      {
      case 0:
				cout << endl
						 << "1.  Init Net" << endl
						 << "2.  SendMessage" << endl
						 << "3.  WaitMessage" << endl
						 << "4.  SendMessage Noresponse" << endl
						 << "5.  SendMessage NoWait" << endl
						 << "6.  CopyFile" << endl
#ifndef __TV_UNIX__
             << "8.  sendLocalMessage" << endl
#endif
						 << "9.  WhoAmI" << endl
						 << "11. NETTerminate" << endl
#ifndef __TV_UNIX__
             << "22. New Client" << endl
#endif
//						 << "14. " << endl
						 << "99. Exit" << endl;
				break;

			case 1: // check tvpc.TVPSplitPath
			{
				RVCString name = getstr("Please enter requested name : ");
				int netIsUp = tc->NETInit(name,TestTalkPort);
				if (netIsUp)
				{
					cout << "Net started correctly." << endl;
				}
				else
          cout << "Error in Init: " << tc->NETGetLastErrorMessage() << endl;
			}
			break;

			case 2: // check
			{
				RVCString Client = getstr("Please enter recipient:");
				//int len = getint("Please enter message length");
				//char* msg = new char[len+1];
				//memset
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Message number %d",i);
					int b = tc->NETSendMessage(Data, strlen(Data)+1, Client);
					printf("Send local Message returned %d\n",b);
				}
      }
      break;

      case 3: //
      {
				int n=getint("Num messages to wait for:");
				for (int i=1;i<=n;i++)
				{
					const char* m = tc->NETWaitMessage();
					if (m)
						printf("NETWaitMessage Returened : %s, len:%d\n", m, strlen(m));
					else
					{
						cout << "Net terminated" << endl;
						return (1);
					}

				}
      }
      break;

			case 4: // check
			{
				RVCString Client = getstr("Please enter recipient:");
				//int len = getint("Please enter message length");
				//char* msg = new char[len+1];
				//memset
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Message number %d",i);
					int b = tc->NETSendMessageNoresponse(Data, strlen(Data)+1, Client);
					printf("NETSendMessageNoresponse returned %d\n",b);
				}
      }
      break;
			case 5: // check
			{
				RVCString Client = getstr("Please enter recipient:");
				//int len = getint("Please enter message length");
				//char* msg = new char[len+1];
				//memset
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Message number %d",i);
					int b = tc->NETSendMessageNowait(i, Data, strlen(Data)+1, Client);
					printf("NETSendMessageNowait returned %d\n",b);
				}
      }
      break;

			case 6: // check
			{
				RVCString Client = getstr("Please enter recipient:");
				RVCString srcFile = getstr(" Enter src file name:");
				RVCString dstFile = getstr(" Enter dst file name:");
				int n = getint("Num messages to send:");

				for (int i=1;i<=n;i++)
				{
					mh.CopyFile(srcFile, dstFile, Client);

				/*	mh.CopyFile("C:\\Temp\\Notepad.exe",
											"C:\\Temp\\Notepad3.exe",
											Client);
					mh.CopyFile("C:\\Temp\\WebLoad.exe",
										  "C:\\Temp\\WebLoad2.exe",
											Client);
					mh.CopyFile("C:\\Temp\\OTP60asd3.dll",
											"C:\\Temp\\OTP60asd2.dll",
											Client);*/
				}
			}
			break;
#ifndef __TV_UNIX__
                        case 8:
			{
				RVCString Client = getstr("Please enter recipient:");
        Client.append("@localhost");
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Local Message number %d",i);
					//int b = sendLocalMessage(Client, Data);
					int b = tc->NETSendMessage(Data, strlen(Data)+1, Client);
					printf("Send local Message returned %d\n",b);
				}
			}
			break;
#endif
			case 9:
			{
				const char *I = tc->NETWhoAmI();
				cout << (I?I:"Net not up") << endl;
			}
			break;

			case 11:
				tc->NETTerminate();
        delete tc;
        tc = new CTestTalkClientTestObject;
				break;

#ifndef __TV_UNIX__
                                	case 22:
       _beginthread( NewThread, 0, 0);
				break;
#endif

      case 99:
				//NETTerminate();
        if (tc)
          delete tc;
				mh.Terminate();
        return 1;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

		choice = getint("Please enter selection: [0]");
		//getstr("hit <Enter> to continue");

  } // end while
	mh.Terminate();
}


//Functions

