/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#ifndef __TV_UNIX__
#include <process.h>    /* _beginthread, _endthread */
#endif
#include <RVCString.h>

#include "netkernelmessagehandler.h"

static char buf[800] = "";

long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

RVCString whoami;
RVCString curname = "";

#define TestTalkPort 9010

int main(int argc, char* argv[])
{
	int choice = 0;
  CNetMessageHandler *mh = new CNetMessageHandler("Base");
  if (!mh->Init()) {
    cout << "Error in Init." << endl;
    return -1;
  }
  whoami = mh->WhoAmI();
  cout << "Starting client " << whoami << endl;
	while (1) {
		switch (choice)
      {
      case 0:
				cout << endl
						 << "1.  Init " << endl
						 << "2.  SendMessage" << endl
						 << "3.  SendMessageNoWait" << endl
						 << "4.  SendMessageNoResponse" << endl
						 << "9.  WhoAmI" << endl
						 << "11. Terminate" << endl
						 << "99. Exit" << endl;
				break;

			case 1: // 
			{
				RVCString name = getstr("Please enter requested name : ");
			}
			break;

			case 2: // check 
			{
				RVCString Client = getstr("Please enter recipient:");
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Message number %d",i);
					mh->SendMessage(Data, Client);
				}
      }
      break;

      case 3: // 
      {
				int n=getint("Num messages to wait for:");
				for (int i=1;i<=n;i++)
				{
					const char* m = tc->NETWaitMessage();
					if (m)
						printf("NETWaitMessage Returened : %s, len:%d\n", m, strlen(m));
					else
					{
						cout << "Net terminated" << endl;
						return (1);
					}

				}
      }
      break;
 
			case 4: // check 
			{
				RVCString Client = getstr("Please enter recipient:");
				//int len = getint("Please enter message length");
				//char* msg = new char[len+1];
				//memset
				int n=getint("Num messages to send:");
				for (int i=1;i<=n;i++)
				{
					char Data[200];
					sprintf(Data, "Message number %d",i);
					int b = tc->NETSendMultiMessage(Data, Client);
					printf("NETSendMultiMessage returned %d\n",b);
				}
      }
      break;

			case 9:
			{
				const char *I = mh->WhoAmI();
				cout << (I?I:"Net not up") << endl;
			}
			break;

			case 11:
				mh->Terminate();
				break;

      case 99:
				mh->Terminate();
        if (mh)
          delete mh;\
        mh = NULL;
        return 1;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

		choice = getint("Please enter selection: [0]");
		//getstr("hit <Enter> to continue");

  } // end while
}

