/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// AssociativeArray.h : Declaration of the CAssociativeArray

#ifndef __ASSOCIATIVEARRAYCOM_H_
#define __ASSOCIATIVEARRAYCOM_H_

#include "resource.h"       // main symbols
#include "associativearray1.h"

/////////////////////////////////////////////////////////////////////////////
// CAssociativeArrayCOM
class ATL_NO_VTABLE CAssociativeArrayCOM : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAssociativeArrayCOM, &CLSID_AssociativeArray>,
  public ISupportErrorInfo,
	public IDispatchImpl<IAssociativeArray, &IID_IAssociativeArray, &LIBID_ASSOCIATIVEARRAYOBJECTLib>
{
public:
	CAssociativeArrayCOM()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ASSOCIATIVEARRAYCOM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAssociativeArrayCOM)
	COM_INTERFACE_ENTRY(IAssociativeArray)
  COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAssociativeArray
public:
	STDMETHOD(Reset)();
	STDMETHOD(KeyExists)(/*[in]*/ BSTR Key, /*[out]*/ VARIANT* Out_Val);
	STDMETHOD(GetValueOf2ParameterArray)(/*[in]*/ BSTR Key, int index, /*[out]*/ BSTR *Out_Val);
  STDMETHOD(GetLongValueOf2ParameterArray)(/*[in]*/ BSTR Key, int index, /*[out]*/ long *Out_Val);
  STDMETHOD(GetDoubleValueOf2ParameterArray)(/*[in]*/ BSTR Key, int index, /*[out]*/ double *Out_Val);

	STDMETHOD(GetValueOf3ParameterArray)(/*[in]*/ BSTR Key, int index, BSTR DefaultValue,/*[out]*/ BSTR *Out_Val);
  STDMETHOD(GetLongValueOf3ParameterArray)(/*[in]*/ BSTR Key, int index, long DefaultValue,  /*[out]*/ long *Out_Val);
  STDMETHOD(GetDoubleValueOf3ParameterArray)(/*[in]*/ BSTR Key, int index, double DefaultValue,/*[out]*/ double *Out_Val);


	STDMETHOD(AddCouple_Char)(/*[in]*/ BSTR Key, BSTR Value);
	STDMETHOD(AddCouple_Double)(/*[in]*/ BSTR Key, double Value);
  STDMETHOD(AddCouple_Long)(/*[in]*/ BSTR Key, long Value);

	STDMETHOD(AddArrayCouple_Char)(/*[in]*/ BSTR Key, BSTR Value,int index);
	STDMETHOD(AddArrayCouple_Double)(/*[in]*/ BSTR Key, double Value, int index);
  STDMETHOD(AddArrayCouple_Long)(/*[in]*/ BSTR Key, long Value,int index);

	STDMETHOD(GetLongValueOf2Parameter)(/*[in]*/BSTR Key, long DefaultValue ,long *Out_Val);
	STDMETHOD(GetDoubleValueOf2Parameter)(/*[in]*/BSTR Key, double DefaultValue ,double *Out_Val);
	STDMETHOD(GetValueOf2Parameter)(/*[in]*/BSTR Key, BSTR DefaultValue,  BSTR* Out_Val);
	STDMETHOD(GetLongValueOfParameter)(/*[in]*/ BSTR Key, /*[out,retval]*/ long *Out_Val);
	STDMETHOD(GetDoubleValueOfParameter)(/*[in]*/ BSTR Key, /*[out,retval]*/ double *Out_Val);
	STDMETHOD(FromString)(/*[in]*/ BSTR AssoString);
//	STDMETHOD(Destroy)();
//	STDMETHOD(Init)(int in_capacity);
	STDMETHOD(ToString)(/*[out,retval]*/ BSTR *Out_Val);

  STDMETHOD(GetValueOfParameter)(BSTR Key,/*[out,retval]*/ BSTR *Out_Val);

private:
  CAssociativeArray m_AssociativeArray;

private:
  void MakeErrorInfo(std::exception &e);
};

#endif //__ASSOCIATIVEARRAYCOM_H_

