/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// ErrorLibLoader.h: interface for the CErrorLibLoader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERRORLIBLOADER_H__88444FD6_9497_42A8_B603_9A21F5AD0A07__INCLUDED_)
#define AFX_ERRORLIBLOADER_H__88444FD6_9497_42A8_B603_9A21F5AD0A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <exception>
#include <RVCString.h>

typedef int (*  GETERRORSEVERITY)(const char* errFileName, int fmtId);
typedef int (*  LOADERRORSTRING)(const char* errFileName, const char* data);
typedef const char*  (*  GETERRORFORMAT)(const char* errFileName, int fmtId);
typedef void (*  TERMINATE)();
typedef void (*  WLERRGERRORMSG)(std::exception*, RVCString&);

class CErrorLibLoader  
{
public:
    void Load();
    void Unload();

	CErrorLibLoader();
	virtual ~CErrorLibLoader();

    int WLERRGetErrorSeverity(const char* errFileName, int fmtId);
    int WLERRLoadErrorString(const char* errFileName, const char* data);
    const char* WLERRGetErrorFormat(const char* errFileName, int fmtId);
    void WLERRGetErrorMsg(std::exception*, RVCString&);
    void WLERRTerminate();
protected:
    HINSTANCE m_hDLL;

    GETERRORSEVERITY m_GETERRORSEVERITYFunc;
    LOADERRORSTRING  m_LOADERRORSTRINGFunc;
    GETERRORFORMAT   m_GETERRORFORMATFunc;
    TERMINATE m_TERMINATEFunc;
    WLERRGERRORMSG m_WLERRGERRORMSGFunc;
};

extern CErrorLibLoader dllLoader;

#endif // !defined(AFX_ERRORLIBLOADER_H__88444FD6_9497_42A8_B603_9A21F5AD0A07__INCLUDED_)
