/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TV_PACKMSG_H
#define __TV_PACKMSG_H

#include <assert.h>
#include <stdarg.h>
#ifndef __TV_UNIX__
#include "tvdebug.h"
#endif
#include "platform.h"
#include "bool.h"

#define MAXFIELDS   10
#define INITIAL_LEN 100

#define HPACKDATA void*

#define PackMsgDllExport DllExport

class PackMsgDllExport Pack {
private:
  HPACKDATA hPackedMsg;
  void* fields[MAXFIELDS + 1];
  int fieldsLen[MAXFIELDS];
	int numOfPack;
  int totalLen;

public:
  Pack(void* first,int firstLen, ...);
  Pack(HPACKDATA hData);

  ~Pack() {}

  HPACKDATA thePackedMsg() const
  {
    return hPackedMsg;
  }

  int thePackedMsgLen() const;

  void* field(unsigned int i) const
  {
    assert(i<MAXFIELDS);
    return fields[i];
  }

  int fieldLen(unsigned int i) const
  {
    assert(i<MAXFIELDS);
    return fieldsLen[i];
  }

  int getNumOfPacks()
  {
    return numOfPack;
  }

  int valid() const
  {
    return (hPackedMsg!=NULL);
  }
};

#endif // __PACKMSG_H

