/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/***********************************************************************
/* Name : navnames
/* Purpose : treat the tml-names module to create and manipulate
/*          tml-names.
/*
/* Description :
/*
/* Creation: Yahali, 22-Nov-93
/* Updates :  Who          When         What
/*                          
/***********************************************************************/

#include <RVCTokenizer.h>
#include "nvsnames.h"

CTestTalkAddress::CTestTalkAddress(const char* client, const char* host) :
  m_ClientName(client), m_HostName(host)
{
  m_Address = m_ClientName + "@" + m_HostName; 
}

CTestTalkAddress::CTestTalkAddress(const char* address) :
  m_Address(address)
{
  RVCTokenizer next(m_Address);
  m_ClientName = next("@");
  m_HostName = next("@");
}

