/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
/***********************************************************************
/* Name : sendmsg.cpp
/* Purpose : implement local messages sending with netview.
/*
/* Creation: Yahali, 14-Dec-93
/* Updates :  Who          When         What
/*
/***********************************************************************/

#ifndef __TV_UNIX__
#include <ace/OS.h>
#include <crtdbg.h>
#include <winsock2.h>
WSADATA wsaData;
#else
#define  _CrtSetDbgFlag(p) NULL
#endif
#include <malloc.h>
#ifdef __TV_UNIX__
#include <alloca.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "send2tml.h"

/***********************************************************************
/* Name : SendMessageToTML
/* Purpose : send a message to a local client of NetView.
/*
/* Input : name - the name of the client to send to.
/*				 data - the data to send to that client.
/*
/* Output : None.
/*
/* Return values: fail/success.
/*
/* Creation: Yahali, 14-Dec-93
/* Updates :  Who          When         What
/*
/***********************************************************************/
#define FROM "$FROM"
#define VAR_EXTRA 25

/***********************************************************************
/* Name : DumpTmlMessage
/* Purpose : Create a dumped TML associative array.
/*
/* Input : from - the name of the sender.
/*
/* Output : none
/*
/* Return values: pointer to the buffer's
/*
/* Remarks:	The user will have to free the returned buffer.
/*
/* Creation: Yahali, 13-Feb-96
/* Updates :  Who          When         What
/*
/***********************************************************************/

char* WINAPI DumpTmlArray(const char* from,...)
{
	//
	// get the parameters in list.
	va_list ap;
	va_start(ap, from);
	char* msg = DumpTmlVArray(from, ap);
	va_end(ap);

	return msg;
}

void WINAPI FreeTmlDumpArray(const char* msg)
{
	free ((void*)msg);
}

#ifdef HAVE_VA_LIST_AS_ARRAY
#define VARARGS_ASSIGN(foo, bar)	foo[0] = bar[0]
#else
#define VARARGS_ASSIGN(foo, bar)	(foo) = (bar)
#endif


char* WINAPI DumpTmlVArray(const char* from, va_list arglist)
{
	//
	// initialize fields & fieldsLen.
	int totalLen = strlen(from) + strlen(FROM) + VAR_EXTRA;
	int numargs = 1;
	const char* key;
	const char* value;
	int i;

	//
	// get the parameters in list.
	va_list ap ;
	VARARGS_ASSIGN(ap,arglist);
	while ((key = va_arg(ap,char*)) != NULL) {
		value = va_arg(ap,char*);
		if (value == NULL)
		{
			char *buf = (char*) alloca(strlen(key)+80);
			printf(buf,"Key %s has no value in call to function SendMessageToTML",
							key);
			//TVUIDisplayMessage(buf,NULL);
			 return NULL;
		}
		numargs++;
		totalLen += strlen(key) + strlen(value) + VAR_EXTRA;
	}
	va_end(ap);

	char* msg = (char*)malloc(totalLen);
	sprintf(msg, "%d '%d %s '%d %s",
					numargs,
					strlen(FROM), FROM,
					strlen(from), from);
	VARARGS_ASSIGN(ap,arglist);
	for (i=1; i<numargs; i++)
	{
		key   = va_arg(ap,char*);
		value = va_arg(ap,char*);

		char* p = msg+strlen(msg);
		sprintf(p, " '%d %s '%d %s",
						strlen(key), key,
						strlen(value), value);
	}

	return msg;
}

/************************* LIBMAIN *********************************/
/*  DLL standart main                                              */
/*******************************************************************/
#ifdef __TV_WINDOWS__
#include <crtdbg.h>
BOOL WINAPI DllMain( HINSTANCE hinstDll,
                           DWORD fdwRreason,
                           LPVOID plvReserved)
{
  switch (fdwRreason){
    case DLL_PROCESS_ATTACH:
      {
        _CrtSetDbgFlag(0);
			  WSADATA *lpwsaData = &wsaData;
		    WORD wVersionRequested = MAKEWORD(1, 1);
		    int nResult = WSAStartup(wVersionRequested, lpwsaData);
		    if (nResult != 0)
			    return FALSE;

		    if (LOBYTE(lpwsaData->wVersion) != 1 || HIBYTE(lpwsaData->wVersion) != 1)
		    {
		      int err = GetLastError();
			    WSACleanup();
			    return FALSE;
		    }
      }
      break;

    case DLL_PROCESS_DETACH:
      WSACleanup();
      break;

    default:
      break;
  }

  return TRUE;
}

#endif


