/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <RVCString.h>

#include "traceapp.h"
//#include "tvenv.h"
#include "traceappwnd.h"

#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_SHOW_DATE, OnSetIsDate)
	ON_COMMAND(ID_SHOW_PROJ_NAME, OnSetIsProjName)
	ON_COMMAND(ID_SHOW_LOCATION, OnSetIsFileLocation)
	ON_COMMAND(ID_SHOW_THREAD, OnSetIsThread)
	ON_UPDATE_COMMAND_UI(ID_SHOW_DATE, OnUpdateShowDate)
	ON_UPDATE_COMMAND_UI(ID_SHOW_LOCATION, OnUpdateShowLocation)
	ON_UPDATE_COMMAND_UI(ID_SHOW_PROJ_NAME, OnUpdateShowProjName)
	ON_UPDATE_COMMAND_UI(ID_SHOW_THREAD, OnUpdateShowThread)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_IsDate					= 0;
	m_IsThread				= 0;
	m_IsProjName			= 0;
	m_IsFileLocation	= 0;
}

//TRACE_SHOW_FILE		1
//TRACE_SHOW_PROJ		2
//TRACE_SHOW_DATE		4
//TRACE_SHOW_THREAD	8

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	((CTraceApp *)AfxGetApp())->mainWnd = this;
	traceWnd = new TraceAppWindow();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

int CMainFrame::OnSetIsDate()
{
	m_IsDate = !m_IsDate;
	return TRACE_SHOW_DATE;
}

int CMainFrame::OnSetIsProjName()
{
	m_IsProjName = !m_IsProjName;
	return TRACE_SHOW_PROJ;
}

int CMainFrame::OnSetIsFileLocation()
{
	m_IsFileLocation = !m_IsFileLocation;
	return TRACE_SHOW_FILE;
}

int CMainFrame::OnSetIsThread()
{
	m_IsThread = !m_IsThread;
	return TRACE_SHOW_FILE;
}


void CMainFrame::AddLine(char* line)
{
	char* str;
	CString cLine;

	if( !line )
		return;

	CView* editView = GetActiveView();
	if( !editView )
		return;

//TVEnvContainerClass tvpc;
/*	const char *pEnvOption = tvpc.TVEGetEnv("TRACE_TO_WINDOW");
  if (pEnvOption!=NULL) 
	{
		CString EnvOption;
   EnvOption = pEnvOption ; 
		EnvOption.MakeUpper();
    if (EnvOption.Find("YES") != -1)
		{*/
			//Show trace message in TraceApp window (NT) or std_output (Unix)
	char*	str1 = line;
	char*	token1;

//	CString formatedLine	= FormatString(line, 0);
//	token1 = __STRTOK( formatedLine.GetBuffer(formatedLine.GetLength()), "|" );

	token1 = __STRTOK( str1, "|" );

	while(token1 != NULL)
	{
		//cLine.Format("%s", token1);
		cLine += token1;
		cLine += "| ";
		token1 = __STRTOK( NULL, "|" );
		if (m_IsProjName)
		{
			cLine += token1;
			cLine += "| ";
		}
		token1 = __STRTOK( NULL, "|" );
		if (m_IsFileLocation)
		{
			cLine += token1;
			cLine += "| ";
		}
		token1 = __STRTOK( NULL, "|" );
		if (m_IsDate)
		{
			cLine += token1;
			cLine += "| ";
		}
		token1 = __STRTOK( NULL, "|" );
		if (m_IsThread)
		{
			cLine += token1;
			cLine += "| ";
		}
		token1 = __STRTOK( NULL, "\n" );
		cLine += token1;
		str = cLine.GetBuffer(cLine.GetLength());

		token1 = __STRTOK( NULL, "|" );
		if (token1 != NULL)
			cLine += "\n";
	}

	char *token;
	token = __STRTOK( str, "\n" );

  while( token != NULL )
	{
		HANDLE handle = GlobalAlloc(GHND,(DWORD)strlen(token)+1);
		char* tmp = (char*) GlobalLock(handle);
		strcpy(tmp, token);
		int len = strlen(tmp);
		tmp[len] = '\0';
		GlobalUnlock(handle);
		((CEditView*)editView)->GetEditCtrl().OpenClipboard();
		EmptyClipboard();
		SetClipboardData(CF_TEXT,handle);
		((CEditView*)editView)->GetEditCtrl().Paste();
		CloseClipboard();
		((CEditView*)editView)->GetEditCtrl().SendMessage(WM_CHAR,VK_RETURN,0);
     /* Get next token: */
     token = __STRTOK( NULL, "\n" );
	}
}

/********************************************************************
format the string that would be printed to the TraceApp editor: 
handle Slashes, Quatation marks, and non-printable characters of ascii 
in range 0-31.
*********************************************************************/
CString CMainFrame::FormatString(const char * inStr,bool delNonPrnt)
{
	RVCString str = RVCString(inStr);
	int idx = 0;

	unsigned char * pos = (unsigned char*)(LPCTSTR)(CString)str; //Galtech
	unsigned char *start = pos;//Galtech

	while (idx != RV_NPOS )
	{
#ifndef _ANSI_ONLY //Galtech
		pos = _mbschr( pos, '\\');
		if (!pos)
			break;
		idx = pos - start;
		str.insert(idx,"\\");
		if (idx == str.length()+2) //last char in the string
			break;
		pos += 2;
#else
		idx = str.index('\\',idx);
		if (idx == RV_NPOS)
			break;
		str.insert(idx,"\\");
		idx += 2;
#endif
	}


	idx = 0;

	pos = (unsigned char*)(LPCTSTR)(CString)str; //Galtech
	start = pos;//Galtech

	while (idx != RV_NPOS )
	{
#ifndef _ANSI_ONLY //Galtech
		pos = _mbschr( pos, '\"');
		if (!pos)
			break;
		idx = pos - start;
		str.insert(idx,"\\");
		if (idx == str.length()+2) //last char in the string
			break;
		pos += 2;
#else
		idx = str.index('\"',idx);
		if (idx == RV_NPOS)
			break;
		str.insert(idx,"\\");
		idx += 2;
#endif //_ANSI_ONLY //Galtech
	}
	// Find and transform the /*...*/ 
	idx = 0;
	while (idx != RV_NPOS )
	{
		idx = str.index("/*",idx);
		if (idx == RV_NPOS)
			break;
		// the Asci representation of the '*' is 0x2A
		//str.replace(idx+1, 1, "0x2A", 4);
		str.replace(idx+1, 1, "\\x2A", 4);
		//AfxMessageBox(str);
	}
	idx = 0;
	while (idx != RV_NPOS )
	{
		idx = str.index("*/",idx);
		if (idx == RV_NPOS)
			break;
		//str.replace(idx, 1, "0x2A", 4);
		str.replace(idx, 1, "\\x2A", 4);
		//AfxMessageBox(str);
	}

	//code added for handling special controls 
	char inBuff[5];
	char ch;
	RVCString tempStr;
	int len = str.length();
  if (!delNonPrnt) //default
	{
	  for (int i=0;i<len;i++)
	  {
		  ch = str(i);
		  if ((ch>=0) && (ch<=31))
		  {
			  sprintf(inBuff,"\\x%02x",ch);
			  for (int j=2; j<4; j++)
				  inBuff[j] = toupper(inBuff[j]);
			  tempStr+=inBuff;
		  }
		  else
			  tempStr+=ch;
	  }
	}
  else
	{
    for (int i=0;i<len;i++)
	  {
		  ch = str(i);
		  if (ch>31)
			  tempStr+=ch;
	  }
	}

	return tempStr.data();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
BOOL CMainFrame::DestroyWindow() 
{
	delete traceWnd;	
	return CFrameWnd::DestroyWindow();
}

void CMainFrame::OnUpdateShowDate(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_IsDate);
}

void CMainFrame::OnUpdateShowLocation(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_IsFileLocation);	
}

void CMainFrame::OnUpdateShowProjName(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_IsProjName);	
}

void CMainFrame::OnUpdateShowThread(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_IsThread);	
}

