/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////
#define	TRACE_SHOW_FILE		1
#define	TRACE_SHOW_PROJ		2
#define	TRACE_SHOW_DATE		4
#define	TRACE_SHOW_THREAD	8

class TraceAppWindow;

class CMainFrame : public CFrameWnd
{
private:
	TraceAppWindow *traceWnd;

protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

	void AddLine(char* line);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();

	CString FormatString(const char * inStr,bool delNonPrnt);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

public:
	bool	m_IsDate;
	bool	m_IsProjName;
	bool	m_IsFileLocation;
	bool	m_IsThread;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg int OnSetIsDate();
	afx_msg int OnSetIsProjName();
	afx_msg int OnSetIsFileLocation();
	afx_msg int OnSetIsThread();
	afx_msg void OnUpdateShowDate(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowLocation(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowProjName(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowThread(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

