/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright  1993-1995, Radview Software LTD. All Rights Reserved. */
/**********************************************************/
/*                                                        */
/* platform.h   -- platform header file                   */
/*                                                        */
/*         who        when          what                            */
/*      Iris        April 95  Created                         */
/*                                                        */
/**********************************************************/

#ifndef __PLATFORM_H
#define __PLATFORM_H

#ifdef __TV_UNIX__
#include <limits.h>
#ifdef __TV_linux__
#include </usr/include/limits.h>
#endif
#include <sys/types.h>
#endif

#ifndef _WINDOWS_
#include <ace/OS.h>
#include <windows.h>
#endif
#include <stdlib.h>
#include <stdarg.h>

#ifdef __TV_UNIX__
#include <assert.h>
#endif

#ifdef __TV_WINDOWS__
#ifndef _ANSI_ONLY//Galtech
#include <mbstring.h>
#endif //_ANSI_ONLY
#define strcasecmp strcmpi
#define strncasecmp strncmpi
#endif /* __TV_WINDOWS__ */
#ifdef __TV_UNIX__
#define strcmpi strcasecmp
#define stricmp strcasecmp
#define strnicmp  strncasecmp

#define wsprintf sprintf
#endif /* __TV_UNIX__ */

#ifdef __TV_UNIX__
#define ltoa(l,str,base) \
(                        \
  sprintf(str,"%ld",l),  \
  str                    \
)
#define itoa(i,str,base) \
(                        \
  sprintf(str,"%d",i),   \
  str                    \
)
#endif /* __TV_UNIX__ */

#ifdef __TV_WINDOWS__
#define PATH_SEP_CHAR ';'
#define PATH_SEP_STR  ";"
#define FILE_SEP_STR	 "\\"
#define FILE_SEP_CHAR	 '\\'

#ifndef _ANSI_ONLY//Galtech
#define _CHAR		unsigned char
#define __STRTOK(x,y)   (char *)_mbstok((_CHAR*)x, (_CHAR*)y)
#define __STRRCHR(x,y)  (char*)_mbsrchr((_CHAR*)x, (_CHAR)y)
#define __STRLWR(x)   (char *)_mbslwr((_CHAR*)x)
#define __STRUPR(x)   (char *)_mbsupr((_CHAR*)x)
#endif//Galtech

#endif
#ifdef __TV_UNIX__
#define PATH_SEP_CHAR ':'
#define PATH_SEP_STR  ":"
#define FILE_SEP_STR	 "/"
#define FILE_SEP_CHAR	 '/'
#define MAX_PATH PATH_MAX

#ifndef _ANSI_ONLY//Galtech
#define _CHAR		unsigned char
#ifdef __TV_WINDOWS__
#define __STRTOK   (char *)_strtok
#define __STRRCHR  _strrchr
#define __STRLWR   (char *)_strlwr
#else
#define __STRTOK   (char *)strtok
#define __STRRCHR  strrchr
#define __STRLWR   (char *)_fstrlwr
#endif
#define __STRUPR   (char *)_strupr
#endif //_ANSI_ONLY//Galtech

#endif

#ifdef __TV_WINDOWS__
#  ifdef WIN32
#    define _EXPORT WINAPI
#  else
//#    define EXPORT  far
#    define _EXPORT far pascal
#  endif
#define DllExport	__declspec( dllexport )
#define DllImport	__declspec( dllimport )
#endif
#ifdef __TV_UNIX__
#define _EXPORT
#define WINAPI
#define DllExport
#define DllImport
#endif


#ifdef __TV_UNIX__
#include <iostream.h>
#endif // __TV_UNIX__

template< typename rcType >
rcType& rv_temporary_parameter( const rcType& r ) {
        return const_cast<rcType&>(r);
}
#define rvTemporary(x) x

#define RV_EXCEPTION_THROW

#ifdef __TV_linux__
#ifdef __GNUG__
#if (__GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 95))
#define IOS_DOES_NOT_SUPPORT_NOCREATE

#undef RV_EXCEPTION_THROW
#define RV_EXCEPTION_THROW throw()

#undef rvTemporary
#define rvTemporary(x) rv_temporary_parameter(x)

#endif // __GNUC__ > 2  ...
#endif // __GNUG__
#endif // __TV_linux__




#ifdef __TV_WINDOWS__
#define SOCKET_LEN int
#endif
#ifdef __TV_solaris__
//#define SOCKET_LEN size_t
#define SOCKET_LEN int
#endif
#ifdef __TV_linux__
#define SOCKET_LEN  socklen_t
#endif
#ifndef SOCKET_LEN
#error "Unkown platform SOCKET_LEN is not defined"
#endif


#ifdef __TV_WINDOWS__
#define RV_INHERIT_PROTECTED protected
#define RV_INHERIT_PRIVATE private
#else
//Sun compiler and GNU compiler does not behave the same as Microsoft compiler
// So we avoid using protected and private inheritance with classes that are dynamically casted
#define RV_INHERIT_PROTECTED public
#define RV_INHERIT_PRIVATE public
#endif // __TV_WINDOWS__

#ifdef __TV_WINDOWS__
typedef HANDLE PROCESS_HANDLE;
#define TVPgetpid _getpid
#endif
#ifdef __TV_UNIX__
typedef pid_t PROCESS_HANDLE;
#define TVPgetpid getpid
#endif

class DllExport RWCollectablePRWGVector;
class DllExport RWSlistCollectablesPRWGVector;

#if (defined _cplusplus) || (defined __cplusplus)
extern "C" {
#endif

DllExport const char* WINAPI TVPStrlwr(char* str);
DllExport const char* WINAPI TVPStrupr(char* str);
DllExport int WINAPI TVPExecApplication(const char* szCmdLine, const char* szParams);
/*
The function 'TVPCreateProcess' is extension of the function 'TVPExecApplication'.
The addition is that it sets the out parameter 'handle' to be the handle to the created process.
( In windows the parameter 'handle' will be the handle to the process. In unix it will be the pid. )
*/
DllExport PROCESS_HANDLE WINAPI TVPCreateProcess(const char* szCmdLine, ... /*arguments*/);
DllExport PROCESS_HANDLE WINAPI TVPCreateProcessAsUser(int UserNum, const char* szCmdLine, ... /*arguments*/);

/*
Using the pararmeter 'handle' to kill the process. The function close the handle.
( In windows the parameter 'handle' will be the handle to the process. In unix it will be the pid. )
*/
DllExport int WINAPI TVPKillProcess(PROCESS_HANDLE& handle);


DllExport const char* WINAPI TVPGetTime();
DllExport const char* WINAPI TVPGetDate();
DllExport long WINAPI TVPWaitTime(long delta);
DllExport double WINAPI TVPSysTime();

DllExport void WINAPI TVPFatalErrorLog(const char* format,...);

#if (defined _cplusplus) || (defined __cplusplus)
}
#endif

#endif // __PLATFORM_H

