/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TVPPriorityQueue_H
#define __TVPPriorityQueue_H

#include <sortvec.h>
#include <thr.h>
#include <thr.h>

#include "platform.h"

class DllExport TVPPriorityQueue 
{
private:
  bool              m_Active;
  bool              m_Released;
	RVMutexLock       *m_Touch;
  RVCondition       *m_Condition;
  RVSortedVector    *m_Q;

public:
  typedef enum {
    Success,
    TimedOut,
    Released,
    Failed
  } WaitReturnType;

public:
	TVPPriorityQueue();
	virtual ~TVPPriorityQueue();

  void Init();
  void Terminate();

	void putEvent(RVCollectable* event, int priority=1);
	void release();
	RVCollectable* waitEvent();
	WaitReturnType waitEvent(RVCollectable*& event, long waitTime);

	bool isEmpty() const;
};


#endif

