/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// WLLightString.h: interface for the CWLLightString class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WLLIGHTSTRING_H__0ED16AB1_44C1_11D3_B5F3_00A0C9458D0D__INCLUDED_)
#define AFX_WLLIGHTSTRING_H__0ED16AB1_44C1_11D3_B5F3_00A0C9458D0D__INCLUDED_

#include <collectable.h>
#include "platform.h"

class DllExport CWLLightString  
{
public:
	CWLLightString();
	CWLLightString(const char* theString, bool own = true);
	virtual ~CWLLightString();

	unsigned length();
	const char* data();
  void setValue(const char* newValue, bool own = true);

protected:
	int     m_length;
	char*   m_theString;
	bool    m_ownString;
};

class DllExport CWLCollectableString : public RVCollectable, public CWLLightString 
{
  RVDECLARE_COLLECTABLE(CWLCollectableString)
private:
	bool m_IgnoreCase;


public:
	CWLCollectableString();
	CWLCollectableString(const char* theString, bool own = true);
	virtual ~CWLCollectableString();

	bool GetIgnoreCase();
	void SetIgnoreCase(bool ignore);

public:
  virtual int                   compareTo(const RVCollectable*) const;
  virtual unsigned              hash() const;
  virtual bool             isEqual(const RVCollectable*) const;

};

#endif // !defined(AFX_WLLIGHTSTRING_H__0ED16AB1_44C1_11D3_B5F3_00A0C9458D0D__INCLUDED_)

