/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <RVCString.h>

#include "platform.h"
#include "tvpnumconversions.h"
#include "tvpsync.h"

static char buf[800] = "";

long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

unsigned func(void* arg)
{
  cout << "Inside func" << endl;
  return 1;
}

#include <ace/OS_NS_unistd.h>
int ACE_TMAIN (int argc, ACE_TCHAR *argv[])
{
#ifdef __TV_WINDOWS__
#ifndef WIN32
  _InitEasyWin();
#endif
#endif
  {
    TVPMutex mutex1;
    TVPMutex mutex2;
    TVPManualEvent event;
    mutex1.Lock();
    mutex2.Lock();
    mutex2.Unlock();
    mutex1.Unlock();
    event.Set();
    event.Wait();
    TVPSysThread t;

    cout << "Before create" << endl;
    t.create(func,NULL);
    rvSleep(500);
    cout << "After create" << endl;
  }

  int choice = 0;
  while (1) {
    switch (choice)
      {
      case 0:
	cout << endl
	     << "1. string -> lowercase" << endl
	     << "2. string -> UPPERcase" << endl
	     << "3. Exec Application" << endl
	     << "4. Print Date&Time" << endl
	     << "5. check TVPWaitTime" << endl
	     << "6. TVPIntToString and TVPDoubleToString " << endl
	     << "99. Exit" << endl;
	break;

      case 1: // lowercase
	{
	  char* s = getstr("Please enter string to make lowercase: ");
	  cout << "Lowercase of '" << s << "' is: '" ;
	  cout << TVPStrlwr(s);
	  cout << "' now s = '" << s << "'" << endl;
	}
	break;

      case 2: // UPPERcase 
	{
	  char* s = getstr("Please enter string to make uppercase: ");
	  cout << "UPPERcase of '" << s << "' is: '" << TVPStrupr(s) 
	       << "' now s = '" << s << "'" 
	       << endl;
	}
	break;

 
      case 3:
	{
	  RVCString cmd = getstr("Enter window command to execute: ");
	  int s = TVPExecApplication(cmd, " ");
	  printf("TVPExecApplication(%s) %s\n",(const char*)cmd,(s ?  "Succeeded" : "Failed"));
	}
	break;

      case 4: // check time/date.
	{
	  RVCString time = TVPGetTime();
	  printf("Time now is: %s %s\n",TVPGetDate(),(const char*)time);
	}
	break;

      case 5: // Check waittime.
	{
	  long t = getint("Enter time to wait (millisecs): ");
	  long wt = TVPWaitTime(t);
	  printf("Actoally waited %ld\n",wt);
	}
	break;

      case 6: // check TVPIntToString and TVPDoubleToString
	{
	  RVCString res;
	  double d;
	  d=123456789012.345678;
	  TVPDoubleToString(d, res, 2);
	  printf("TVPDoubleToString(123456789012.345678,2) = (%s)\n", res.data());
	  TVPDoubleToString(-d, res, 3);
	  printf("TVPDoubleToString(123456789012.345678,3) = (%s)\n", res.data());
	  TVPDoubleToString(d, res, 4);
	  printf("TVPDoubleToString(123456789012.345678,4) = (%s)\n", res.data());

	  double j = 1.0;
	  for (int i=1;i<35;i++) {
	    j = j*2.0;
	    TVPDoubleToString(j, res, 4);
	    if (i>=29)
	      printf("TVPDoubleToString(%-25.4f,4) = (%s)\n", j, res.data());
	  }
	  TVPDoubleToString(1, res, 2);
	  printf("TVPDoubleToString(1,4) = (%s)\n", res.data());
	  TVPDoubleToString(1, res, 0);
	  printf("TVPDoubleToString(1,4) = (%s)\n", res.data());
	  TVPDoubleToString(0, res, 2);
	  printf("TVPDoubleToString(0,2) = (%s)\n", res.data());
	  TVPIntToString(0, res);
	  printf("TVPIntToString(0) = (%s)\n", res.data());
	  TVPIntToString(10, res);
	  printf("TVPIntToString(10) = (%s)\n", res.data());
	  TVPIntToString(-10, res);
	  printf("TVPIntToString(-10) = (%s)\n", res.data());
	}
	break;

      case 99:
        return 1;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

    choice = getint("Please enter selection: [0]");
    //getstr("hit <Enter> to continue");

  } // end while
}

