/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "strform.h"

//******************************************************************************
//          Class TVEFormatString  functions
//******************************************************************************
// converting a string with standard "C" format to a regular string, replacing
//  \\ with \, \t with a tab etc.
RVCollectableString&  TVEFormatString::unformat(){
   size_t i;
   char j;
   tempStr = (*this);

   i = tempStr.length();
   if (i>0)
			if (tempStr[(size_t)0]=='"'){      //trim leading quotes
					tempStr.remove(0,1);
					tempStr.remove(i-2,1);
					i=0;
			}
	 while ( i<tempStr.length()){
			 if (tempStr[i++]=='\\'){
					if ((tempStr.index(RVCRegexp("[0-3][0-7][0-7]"),i)==i)
						 ||(tempStr.index(RVCRegexp("[tnrbf]"),i)==i))
						switch (tempStr[i]){
							 case 't':
								 tempStr.replace(i-1,2,"\t");
								 break;
							 case 'b':
								 tempStr.replace(i-1,2,"\b");
								 break;
							 case 'r':
								 tempStr.replace(i-1,2,"\r");
								 break;
							 case 'f':
								 tempStr.replace(i-1,2,"\f");
								 break;
							 case 'n':
								 tempStr.replace(i-1,2,"\n");
								 break;
							 default :
								 sscanf(RVCString(tempStr(i,3)),"%o",&j);
								 tempStr.replace(i-1,4,RVCString(j));
								 break;
					 }
					else
					 tempStr.remove(i-1,1);
			 }
	 }
	 return tempStr;
}
//------------------------------------------------------------------------------
// Converting a string to standard "C" format, replacing tabs with \t, eoln with
// \n, and enclosing the string with quotes.
RVCollectableString& TVEFormatString::format(){

   size_t i;
   char num[5];

   tempStr = (*this);
   tempStr.prepend("\"");
   tempStr.append("\"");
   i=0;
   while ( ++i < (tempStr.length()-1) )
          switch (tempStr[i]){
             case ('\t'):
                tempStr.replace(i++,1,"\\t");
                break;
             case ('\n'):
                tempStr.replace(i++,1,"\\n");
                break;
             case ('\r'):
                tempStr.replace(i++,1,"\\r");
                break;
             case ('\f'):
                tempStr.replace(i++,1,"\\f");
                break;
             case ('\b'):
                tempStr.replace(i++,1,"\\b");
                break;
             case ('"'):
                tempStr.replace(i++,1,"\\\"");
                break;
             case ('\\'):
                tempStr.replace(i++,1,"\\\\");
                break;
             default :
                if ((tempStr[i]>0) && (tempStr[i]<32)){
                    RVCString  numStr(itoa(tempStr[i],num,8));
                    for( ;numStr.length()<3;numStr.prepend("0"));
                    tempStr.replace(i,1,RVCString("\\"+numStr));
                    i+=3;
                }break;
          }
   return tempStr;
}
//------------------------------------------------------------------------------
RVCollectableString& TVEFormatString::operator=(const char* str)
{
     size_t len = (*this).length();
     (*this).replace(0,len,RVCString(str));
     return (*this);
}

