/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
///////////////////////////////////////////////////////////////////////////////
//
// (c) 2000 GalTech Soft. All rights reserved.
//
// unicode.h
// 
// Unicode Library. 
///////////////////////////////////////////////////////////////////////////////
#ifndef _UNICODE_H
#define _UNICODE_H
#include "gt_portable.h"
#include "gt_unidef.h"
#include "gt_portable.h"
#include "gt_uniservapis.h"

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */
#ifdef __TV_WINDOWS__
#define _DLGUNITS_TO_Y(wnd, units)		ConvertDialogDimension(wnd, units, 0)
#define _DLGUNITS_TO_X(wnd, units)		ConvertDialogDimension(wnd, units, 1)
int ConvertDialogDimension(HWND hwnd, int Dimension, bool bHDirection, bool bToDlgUnits = false);
#endif
//ANSI to Unicode(UCS2) conversions
int ANSIToUCS2(UINT CodePage, const char* pszA, int countA, gt_wchar_t* pszW, int countW);
int UCS2ToANSI(UINT CodePage, const gt_wchar_t* pszW, int countW, char* pszA, int countA);

//ANSI to Unicode(UTF8) conversions
int ANSIToUTF8(UINT CodePage, const char* pszA, int countA, char* pszUTF, int countUTF);
int UTF8ToANSI(UINT CodePage, const char* pszUTF, int countUTF, char* pszA, int countA);

int ANSIToANSI(UINT CodePageFrom, UINT CodePageTo, const char* pszFrom, int countFrom, char* pszTo, int countTo);
void RemoveInvalidHTMLCodes(gt_wchar_t* pStr);

//Finds nth char, starting from 0
int UTF8_NthChar(const char *ptr, int n);

//Length of UTF8 string in characters
int UTF8_Length(const char *ptr);


#ifdef __TV_UNIX__
unsigned int GetACP ( void );
#endif

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif // _UNICODE_H
