/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* $Header: x:/xlat/xlat1.h 1.7 1996/07/10 12:14:38 davidg Exp $ */
/*
 * xlat1.h -- code page data translator (through UniCode) header file.
 * Copyright (C) Kivun Computers Ltd 1989-1993. All rights reserved.
 * Bob Rosenschein  Nov 6, 1993
 * David Goldstein  Jan 3, 1994
 */

/* -------------------------     */

#ifndef _INC_XLAT1

#ifndef USE_CPLUS_COMP
#ifdef __cplusplus
extern "C" {
#endif
#endif

/*
 * Constants
 */

#define MAX_CODEDESC    40  /* code page description length */
#define MAX_CODES   3   /* number of (ligatured) bytes to UniCode */
#define MAX_8_BITS  256 /* how much will fit into an 8-bit byte */
#define BEG_URANGE_1    ((WORD) 0x0000)  /* beg of interesting UniCode range #1 */
#define END_URANGE_1    ((WORD) 0x07FF)  /* end of interesting UniCode range #1 */
#define BEG_URANGE_2    ((WORD) 0x2000)  /* beg of interesting UniCode range #2 */
#define END_URANGE_2    ((WORD) 0x27FF)  /* end of interesting UniCode range #2 */
#define BEG_URANGE_3    ((WORD) 0xFE00)  /* beg of interesting UniCode range #3 */
#define END_URANGE_3    ((WORD) 0xFFFF)  /* end of interesting UniCode range #3 */
#define MAX_16_BITS     END_URANGE_2 //((WORD) 0x2800)  /* 0x2700 intresting part (for now) of UniCode table */


/* Structures and Typedefs */

#ifndef __MINMAX_DEFINED
typedef unsigned short WORD;
#endif

typedef struct _CODEREC {
    WORD code;
//    WORD unicode;
} CODEREC, *PCODEREC;

typedef struct _RANGE {
    WORD start;  // first number of range
    WORD end;    // last number of range
    WORD offset; // offset of this range from the start of the CodeRecs array
} RANGE;

#if XLATLIB
typedef struct  _CPREC {    /* code page record */
    int     iCodePage;      /* Kivun code page id */
    int     iStringID;      /* string ID for dialog */
    int     iClosestWCp;    // Closest Windows Codepage
    char    *pszCPName;     // "C" description
    bool    bMultiTable;    // True if this is a multi-table convertion
    WORD FAR *lpToUni;      /* pointer to trans to UniCode table */
    untiny  FAR *lpFromUni1;/* pointer to trans from UniCode table #1 */
    untiny  FAR *lpFromUni2;/* pointer to trans from UniCode table #1 */
} CPREC, *PCPREC, FAR *LPCPREC;

typedef struct  _CPEXTRA {    /* code page record */
    int     iCodePage;      /* Kivun code page id */
    int     iStringID;      /* string ID for dialog */
    char    *pszCPName;     // "C" description
} CPEXTRA, *PCPEXTRA;
#endif

#ifndef USE_CPLUS_COMP
#ifdef __cplusplus
}
#endif
#endif

#define _INC_XLAT1

#endif  /* _INC_XLAT1 */

/* -------------------------     */


// ============= old stuff =================

#if 0
#ifdef SE_WINDOWS3
typedef struct  _CPREC {    /* code page record */
    int     iCodePage;  /* Kivun code page id */
    int     iStringID;  /* string ID for dialog */
    char    *pszCPName; /* "C" description */
//  LPSTR   pszCPDesc; /* description */
    WORD FAR *lpToUni;   /* pointer to trans to UniCode table */
    untiny  FAR *lpFromUni1;/* pointer to trans from UniCode table #1 */
    untiny  FAR *lpFromUni2;/* pointer to trans from UniCode table #1 */
} CPREC, *PCPREC, FAR *LPCPREC;
#else
typedef struct  _CPREC {    /* code page record */
    int     iCodePage;  /* Kivun code page id */
    int     iStringID;  /* string ID for dialog */
    char    *pszCPName; /* "C" description */
    LPSTR   pszCPDesc; /* description */
    WORD FAR *lpToUni;   /* pointer to trans to UniCode table */
    untiny  FAR *lpFromUni1;/* pointer to trans from UniCode table #1 */
    untiny  FAR *lpFromUni2;/* pointer to trans from UniCode table #1 */
} CPREC, *PCPREC, FAR *LPCPREC;
#endif
#endif
