/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*///////////////////////////////////////////////////////////////////////////////
 * dbcode.h -- double byte encoding header.
 * Copyright (C) GalTech Soft Ltd. 1998-2000. All rights reserved.
 *
///////////////////////////////////////////////////////////////////////////////
*/

#ifndef __DBCODE_H     /* prevent multiple includes */
#define __DBCODE_H

#define IS_WIDE_CHAR(w)   ((w) & 0xff00) /* TRUE when a 2 byte char */

// Double-byte encoding methods.
// SINGLE_BYTE- non DBCS character set.
// SJIS      - Shift-JIS, the standard method used under Windows.
// UNICODE   - Unicode encoding.

//typedef enum { SINGLE_BYTE, SJIS, SJIS_WIDE, EUC, BIG5, KS, GB ,UNICODE } DBCS_ENCODING;
#define IS_DOUBLE_BYTE_ENCODING(c)	(   \
							(c)==CP_MS_JAPANESE ||	\
							(c)==CP_MS_CHINESE_SIMPLIFIED ||	\
							(c)==CP_MS_KOREAN ||	\
							(c)==CP_MS_CHINESE_TRADITIONAL ||	\
							(c)==CP_EUCJP ||	\
							(c)==CP_EUCCN 	\
		)
#define IS_ESCAPE_SEQUENCE_CODEPAGE(c)	(   \
							(c)==CP_JIS     \
		)


#define NLJ	10
#define CRJ	13
#define ESCJ 27
#define SS2	142
#define IS_ESCAPE(hi, lo)  ((hi)==0 && (lo)==0x1B)
#define SJIS1(A) ((A >= 129 && A <= 159) || (A >= 224 && A <= 239))
#define SJIS2(A) (A>= 64 && A <= 252)
#define ISEUC(A) (A >= 161 && A <= 254)


#endif /* __DBCODE_H */
