/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#define MAX_NO_OF_CODES  17046
#define MAX_NO_OF_RANGES 270
#define MAX_NO_OF_OUTCODES  17046
#define MAX_NO_OF_OUTRANGES 4124

typedef struct  _CPREC {    /* code page record */
    UINT    CodePage;      /* code page id */
    char	szDescription[MAX_RES_NAME];     // "C" description
    BOOL    bMultiTable;    // True if this is a multi-table convertion
} CPREC, *PCPREC, *LPCPREC;

CPREC CPRecTable [] = {
	{CP_MS_LATIN1, "MS_LATIN1", FALSE},
	{CP_MS_CYRILLIC, "MS_CYRILLIC", FALSE},
	{CP_MS_GREEK, "MS_GREEK", FALSE},
	{CP_MS_TURKISH,"MS_TURKISH",FALSE},
	{CP_MS_HEBREW, "MS_HEBREW",FALSE},
	{CP_MS_ARABIC, "MS_ARABIC",FALSE},
	{CP_KOI_8, "KOI_8", FALSE},
	{CP_MS_JAPANESE,"MS_JAPAN", TRUE},
	{CP_JIS, "JIS", TRUE},
	{CP_EUCJP,"EUCJP", TRUE},
	{CP_MS_CHINESE_SIMPLIFIED, "MS_CHINA", TRUE},
	{CP_MS_CHINESE_TRADITIONAL, "MS_TAIWAN",TRUE},
	{CP_MS_KOREAN, "MS_KOREA", TRUE},
	{CP_MAC_HEBREW, "CP_MAC_HEBREW", FALSE},
	{CP_MAC_ROMAN, "CP_MAC_ROMAN", FALSE},
	{CP_EUCJP, "CP_JAPAN_EUC", TRUE},
	{CP_JIS, "CP_JAPAN_JIS", TRUE},
	{CP_IBM_850, "CP_IBM_850", FALSE},
	{CP_IBM_852, "CP_IBM_852", FALSE},
	{CP_IBM_850, "CP_IBM_861", FALSE},
	{CP_IBM_850, "CP_IBM_862", FALSE},
	{CP_IBM_850, "CP_IBM_866", FALSE},
	{CP_IBM_850, "CP_IBM_869", FALSE},
	{CP_MS_LATIN2, "CP_MS_EEUROPE", FALSE},
	{CP_MS_BALTIC, "CP_ISO_8859_4", FALSE},
	{CP_ISO_8859_3,"CP_ISO_8859_3", FALSE}
};

