/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WebLoad_HashDictionaries_H
#define __WebLoad_HashDictionaries_H

#include <thr.h>
#include "tvpsync.h"
#include "cache.h"

#define PCMethodsHashDictionary *CMethodsHashDictionary

class CObjectsHashDictionary : public RVHashDictionary{
public:
  RVDECLARE_COLLECTABLE(CObjectsHashDictionary)
  CObjectsHashDictionary();
  CObjectsHashDictionary(const CObjectsHashDictionary &);
  ~CObjectsHashDictionary();
/*
  {


     RVHashDictionaryIterator sci(*this);
     RVCollectable* item;
     RVHashDictionary* phash_dict_entery;

     while ( item = sci() ) {
       phash_dict_entery = (RVHashDictionary*)item;
       phash_dict_entery->clearAndDestroy();
     }

     delete phash_dict_entery;

  }
*/

//  CMethodsHashDictionary 
int ReadCache(IDispatch *ptrIDispatch_cache,CMethodsHashDictionary **methods_cache_RW);
int WriteCache(IDispatch *ptrIDispatch_cache,CMethodsHashDictionary **methods_cache_RW);
void GetTypeInfo(iJSComPrivateData *pCJSComObject);

//	  void ReadCache(IDispatch *pIDispatch);
//int CreateCacheEntry(IDispatch *pIDispatch,CMethodsHashDictionary *methods_cache_RW);

private:
int FindObjectInCache(IDispatch *ptrIDispatch_cache,RVCollectable **methods_cache_RWColl);
int CreateCacheEntry(IDispatch *ptrIDispatch_cache,CMethodsHashDictionary *methods_cache_RW);
int FillCacheEntry(IDispatch *ptrIDispatch_cache,CMethodsHashDictionary *pmethods_cache_RW);

private:
	RVReadersWriterLock m_CacheLock;
//	TVPManualEvent m_FillCacheEvent;
//	IDispatch *m_pIDispatch;

};

class CMethodsHashDictionary : public RVHashDictionary{
public:
  RVDECLARE_COLLECTABLE(CMethodsHashDictionary)
  CMethodsHashDictionary();

	void SetFillCacheEventReset();
	void SetFillCacheEventSet();
	void SetFillCacheEventWait();

  void SetDefaultPropertyParam(CMethodInfo* pDefaultPropertyParam);
  CMethodInfo* GetDefaultPropertyParam();

  ~CMethodsHashDictionary();

private:
		TVPManualEvent m_FillCacheEvent;
    CMethodInfo* m_pDefaultPropertyParam;
};


#endif //__WebLoad_HashDictionaries_H
