/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __JSCOMOBJECT__H
#define __JSCOMOBJECT__H


#include "loadengineglobals.h"
#include <Errors.h>// for the function AMGetErrorText
#include "ComObjectClass.h"
#include "ComMethodClass.h"
#include "iJSComPrivateData.h"

//#define VARIANT_FAILED(Status) ((VARTYPE)(Status.vt)==VT_EMPTY)
#define VARIANT_FAILED(Status) ((VARTYPE)(Status.vt)==VT_ERROR)
//#define VARIANT_FAILED(Status) ((VARTYPE)(Status.vt)==VT_EMPTY || VT_ERROR)
//#define VARIANT_FAILED(Status) (((Status.vt)==VT_EMPTY) ||
//																((Status.vt)==VT_ERROR))
#define SIMPLE_PROPERTY 11
#define PROPERTY_WITH_PARAMS 12
#define SIMPLE_METHOD 13

typedef /* [v1_enum] */ 
enum tagPROPERTYTYPE
    {	TI_SIMPLE_PROPERTY	= 1,
	NOTI_SIMPLE_PROPERTY	= 2,
	TI_NON_SIMPLE_PROPERTY	= 4,
	NOTI_NON_SIMPLE_PROPERTY	= 8
    }	PROPERTYTYPE;



typedef enum WL_JSType {
  		WL_JSTYPE_VOID,            
			WL_JSTYPE_OBJECT,          
			WL_JSTYPE_INT,            
			WL_JSTYPE_DOUBLE,           
			WL_JSTYPE_STRING,              
			WL_JSTYPE_BOOLEAN,   
			WL_JSTYPE_ERROR 
} WL_JSType;


struct JSCOM_INVOKE_PARAMS{

	JSCOM_INVOKE_PARAMS(){
		dispid = 0;
		invoke_type = 0;
		//dis_params = NULL;
		//return_value = NULL;
		//VariantInit(&return_value);
	}
/*
	~JSCOM_INVOKE_PARAMS(){
		VariantClear(&return_value);
	}
*/

	DISPID dispid;//(Typedef LONG DISPID;)
	WORD invoke_type;
//	DISPPARAMS FAR* dis_params;
	DISPPARAMS dis_params;//Used by IDispatch::Invoke to contain the arguments passed to a method or property
	VARIANT return_value;
};





// This class is exported from the JSCOMObject.dll
//JSCOMOBJECT_API : IN ORDER TO BE ABLE TO CREATE AN INSTANCE 
// OF THE CLASS FROM OUTSIDE OF THE DLL.

class CObjectsHashDictionary;
class CMethodsHashDictionary;



class JSCOMOBJECT_API ComObject : public iJSComPrivateData {
public:
	explicit ComObject() {}
	~ComObject() {}

	bool IsSpecialMethod(const char* name);
	bool BeforeGetProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, bool& exitMethod) { return true; }
	bool BeforeSetProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, bool& exitMethod) { return true; }

  bool AfterGetProperty (JSContext *cx, JSObject *obj, jsval id, 
												 jsval *vp, bool& exitMethod, int ret,
												 WLERRORINFO &m_ErrInfo){
		return true; 
	}

  bool AfterSetProperty (JSContext *cx, JSObject *obj, jsval id,
												 jsval *vp, bool& exitMethod,
												 int ret,WLERRORINFO &m_ErrInfo){
		return true; 
	}


  
	bool OnCreationOfJSComObject(JSContext* cx, JSObject* obj) { return true; }
  iJSComPrivateData* CreateNewObject(); 

};
/*
class CExternHashDictionary : public RVHashDictionary{
public:
  RVDECLARE_COLLECTABLE(CExternHashDictionary)
  CExternHashDictionary();

  ~CExternHashDictionary(){


     RVHashDictionaryIterator sci(*this);
     RVCollectable* item;
     RVHashDictionary* phash_dict_entery;

     while ( item = sci() ) {
       phash_dict_entery = (RVHashDictionary*)item;
       phash_dict_entery->clearAndDestroy();
     }

     delete phash_dict_entery;

  }
};

*/


#endif
