/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
#include "ComMethodClass.h"
#include "ComObjectClass.h"

//#include "rvhtmldomxml.h"
//#include "rvhtmldomobject.h"

void ComMethodFinalize(JSContext *cx, JSObject *obj)
{
  ComMethodPrivate* pPrv = (ComMethodPrivate*)JS_GetPrivate(cx, obj);
	if ( pPrv ) {
		delete(pPrv);
	}
}


static JSBool ComMethodCall(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  WLERRORINFO m_ErrInfo;
	int ret;

	iJSComPrivateData *pCJSComObject = NULL;
	RVCString className = RVJS_GetClassName(obj);
/*	if (className.compareTo("XML")==0)
	{
		CDOMJSPrivate* pDOMPrivate = static_cast<CDOMJSPrivate*>(JS_GetPrivate(cx, obj));
		CDOMXmlElement* pXMLElement = static_cast<CDOMXmlElement*>(pDOMPrivate->GetObj());
		JSObject* pActiveXJSObj = pXMLElement->GetXmlJSObj();
		pCJSComObject = static_cast<iJSComPrivateData*>(JS_GetPrivate(cx, pActiveXJSObj));
	} else if (className.compareTo("OBJECT")==0)
	{
		CDOMJSPrivate* pDOMPrivate = static_cast<CDOMJSPrivate*>(JS_GetPrivate(cx, obj));
		CDOMObjectElement* pObjectElement = static_cast<CDOMObjectElement*>(pDOMPrivate->GetObj());
		JSObject* pActiveXJSObj = pObjectElement->GetActiveXJSObj();
		pCJSComObject = static_cast<iJSComPrivateData*>(JS_GetPrivate(cx, pActiveXJSObj));
	} else*/
	{
		pCJSComObject = static_cast<iJSComPrivateData*>(JS_GetPrivate(cx, obj));
	}
	
	ret = pCJSComObject->CallMethodDispatcher(cx,argv,argc,m_ErrInfo,rval);

  if (ret != 0) {
		if (!ThrowComError(cx,m_ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}

  return JS_TRUE;
}

static JSBool ComMethodPropertyGet(JSContext *cx, JSObject *obj,jsval id, jsval *vp){
  WLERRORINFO m_ErrInfo;
	int ret;

  // Call method dispatcher to get JS VALUE
  ComMethodPrivate *pComMethodPrivate = (ComMethodPrivate*)JS_GetPrivate(cx, obj);

  JSObject* aParent = pComMethodPrivate->GetParent();
  iJSComPrivateData *pCJSComObjectParent = (iJSComPrivateData*)JS_GetPrivate(cx, aParent);

  jsval res;

  // Emulate rleationship between argv and caller object
 	jsval obj2val[3];
  obj2val[0] = OBJECT_TO_JSVAL(obj);
	ret = pCJSComObjectParent->CallMethodDispatcher(cx, &obj2val[2], 0, m_ErrInfo,&res);

  if (ret != 0) {
		if (!ThrowComError(cx,m_ErrInfo))
			return JS_FALSE;
    else
      return JS_TRUE;
  }

  // Convert result of call to JSObject and call its getter

  JSObject* ObjFromCall = JSVAL_TO_OBJECT(res);

  return GlobalComObject_PropertyGet(cx, ObjFromCall, id, vp);

}

//STRUCT
JSClass ComMethodClass = {
  "ComMethod",//CONSTRUCTOR
  JSCLASS_HAS_PRIVATE,
  JS_PropertyStub,	// add Property
  JS_PropertyStub,	// del Property
  ComMethodPropertyGet,	// get Property //JS ENGINE WILL CALL THIS FUNCTION WHEN THERE IS '.' AFTER JS OBJECT
  JS_PropertyStub,	// set Property  //JS ENGINE WILL CALL THIS FUNCTION WHEN THERE IS '=____.' AFTER JS OBJECT
  JS_EnumerateStub,
	JS_ResolveStub,//proto_resolve_stub,
	JS_ConvertStub,
	ComMethodFinalize , //DESTRUCTOR
	0,0,
	ComMethodCall//OPERATOR'()'
};




JSObject* NewComMethodObject( 
	JSContext* cx, 
	const char* name,
  JSObject* parent) 
{
	JSObject* method = JS_NewObject( cx, &ComMethodClass, 0, 0 );

	ComMethodPrivate* pPrv = new ComMethodPrivate(name, parent);
	JS_SetPrivate( cx, method, pPrv );
	
	return method;
}	



JSClass* GetComMethodJSClass() {
	return &ComMethodClass;
}



//ComMethodPrivate implementation

ComMethodPrivate::ComMethodPrivate(	const char* name , JSObject* parent): m_name(name), m_parent(parent)
{
}

const RVCString& ComMethodPrivate::GetName() const {
	return m_name;
}



									
																	
