/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "StdAfx.h"
//#include "platform.h"//because dllexport
#include "ComProtocol.h"

//#include "platform.h"//because dllexport
#include "comobjectclass.h"
#include "tracedll.h"

#include "HashDictionaries.h"
///#include "cache.h"


//The Protocol global static pointer.  
//static void* piLEProtocolProcess = NULL;
iLEProtocolProcess* piLEProtocolProcess = NULL;


iLEProtocolProcess* NewProtocolProcess() {
	//create 'comProtocolProcess' object and sets the global static pointer :
	piLEProtocolProcess =  new  comProtocolProcess ();
	assert(piLEProtocolProcess);
	return piLEProtocolProcess;
}


////////////////////////////////////////////////////////////////
//////////////// class comProtocolProcess /////////////////////
////////////////////////////////////////////////////////////////

comProtocolProcess::comProtocolProcess(): m_bForceVcInMTA(false) {}
comProtocolProcess::~comProtocolProcess() {}

// the implementation of class iLEProtocolProcess
iLEProtocolSession& comProtocolProcess::NewProtocolSession() {
	comProtocolSession * pcomProtocolSession = new comProtocolSession(*this);
	assert(pcomProtocolSession);
	return *pcomProtocolSession;
}

iLEProtocolAgendaMachineThread& comProtocolProcess::NewProtocolAgendaMachineThread(WLProtocolThreadType p_ProtocolThreadType) {
	comProtocolAgendaMachineThread * pcomProtocolAgendaMachineThread = new comProtocolAgendaMachineThread(*this, p_ProtocolThreadType);
	assert(pcomProtocolAgendaMachineThread);
	return *pcomProtocolAgendaMachineThread;

}

iLEProtocolJSRuntime& comProtocolProcess::NewProtocolJSRuntime() {
	comProtocolJSRuntime * pcomProtocolJSRuntime = new comProtocolJSRuntime(*this);
	assert(pcomProtocolJSRuntime);
	return *pcomProtocolJSRuntime;
	
}

bool comProtocolProcess::ProcessInitialize() {
	WlTraceMsg("JSCOMObject : Called the protocol callback ProcessInitialize");
/*
	HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
	if (hr != S_OK ) {
			//cout << "CWLJSScript::Init Error in CoInitialize." << endl;
			return false;
	}		
	*/
	return true;		
}

bool comProtocolProcess::ProcessTermination() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback ProcessTermination");
	
	//	delete (iJSComPrivateData::m_pObjectsCache);//??
//	CoUninitialize();
	
	return true;
	
}

bool comProtocolProcess::ProcessInitializeJava(cRVJVM& rJvm, JNIEnv* rEnv) {
	WlTraceMsg("JSCOMObject : Called the protocol callback ProcessInitializeJava");
  return true;
}	

bool comProtocolProcess::ProcessFinalizeJava(cRVJVM& rJvm, JNIEnv* rEnv) {
	WlTraceMsg("JSCOMObject : Called the protocol callback ProcessFinalizeJava");
  return true;
}	

bool comProtocolProcess::Get_bForceVcInMTA() {
	return m_bForceVcInMTA;
}

void comProtocolProcess::ForceVcInMTA() {
	m_bForceVcInMTA = true;
}


////////////////////////////////////////////////////////////////
//////////////// class comProtocolSession/////////////////////
////////////////////////////////////////////////////////////////


comProtocolSession::comProtocolSession(iLEProtocolProcess & father) 
	: iLEProtocolSession(father) {}

comProtocolSession::~comProtocolSession() {}

iLEProtocolAgendaInMix& comProtocolSession::NewProtocolAgendaInMix() {
	comProtocolAgendaInMix * pcomProtocolAgendaInMix = new comProtocolAgendaInMix(*this);
	assert(pcomProtocolAgendaInMix);
	return *pcomProtocolAgendaInMix;
	
}

bool comProtocolSession::SessionInitialize() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback SessionInitialize");	
	return true;
}

bool comProtocolSession::SessionTermination() {
	WlTraceMsg("JSCOMObject : Called the protocol callback SessionTermination");	
	(iJSComPrivateData::m_pObjectsCache)->clearAndDestroy();
	return true;
}


////////////////////////////////////////////////////////////////
//////////////// class comProtocolJSRuntime///////////////////
////////////////////////////////////////////////////////////////

comProtocolJSRuntime::comProtocolJSRuntime(iLEProtocolProcess& father) :
	iLEProtocolJSRuntime(father) {}//temp avidan
	
comProtocolJSRuntime::~comProtocolJSRuntime() {}

bool comProtocolJSRuntime::JSRuntimeInitialize(JSRuntime* rt){
  m_JSRuntime = rt;
	WlTraceMsg("JSCOMObject : Called the protocol callback JSRuntimeInitialize");	
	return true;
}

bool comProtocolJSRuntime::JSRuntimeAfterNewMainContext(JSContext* cx){
	WlTraceMsg("JSCOMObject : Called the protocol callback JSRuntimeAfterNewMainContext");	
	return true;
}

bool comProtocolJSRuntime::JSRuntimeBeforeDestroyMainContext(JSContext* cx){
	WlTraceMsg("JSCOMObject : Called the protocol callback JSRuntimeBeforeDestroyMainContext");	
	return true;
}


////////////////////////////////////////////////////////////////
//////////////// class comProtocolAgendaInMix///////////////////
////////////////////////////////////////////////////////////////

comProtocolAgendaInMix::comProtocolAgendaInMix(iLEProtocolSession & father) :
	iLEProtocolAgendaInMix(father) ,test("Com Message : This is the data of the data member test") {}//temp avidan
	
comProtocolAgendaInMix::~comProtocolAgendaInMix() {}

iLEProtocolVCInMix& comProtocolAgendaInMix::NewProtocolVCInMix() {
	comProtocolVCInMix * pcomProtocolVCInMix = new comProtocolVCInMix(*this);
	assert(pcomProtocolVCInMix);
	return *pcomProtocolVCInMix;
}

bool comProtocolAgendaInMix::BeforeInitAgenda() {
	WlTraceMsg("JSCOMObject : Called the protocol callback BeforeInitAgenda");	
	return true;
}


bool comProtocolAgendaInMix::AfterTerminateAgenda() {
	WlTraceMsg("JSCOMObject : Called the protocol callback AfterTerminateAgenda");	
	return true;
}

bool comProtocolAgendaInMix::JSInitializeForScript(JSContext* cx, JSObject* AgendaGlobal, JSObject* GeneralGlobal) {
	WlTraceMsg("JSCOMObject : Called the protocol callback JSInitializeForScript");
	return RegisterComObject(cx, GeneralGlobal );
}

bool comProtocolAgendaInMix::JSTerminateForScript(JSContext* cx, JSObject* AgendaGlobal, JSObject* GeneralGlobal) {
	WlTraceMsg("JSCOMObject : Called the protocol callback JSTerminateForScript");
	return true;
}

void comProtocolAgendaInMix::SetComTest(char* s) {//@@avidan temp
	test = s;
}

RVCString& comProtocolAgendaInMix::GetTestString() {//@@avidan temp
	return test;
}

////////////////////////////////////////////////////////////////
//////////////// class comProtocolAgendaMachineThread/////////////////
////////////////////////////////////////////////////////////////

comProtocolAgendaMachineThread::comProtocolAgendaMachineThread(iLEProtocolProcess & father, WLProtocolThreadType p_ThreadType) 
	: iLEProtocolAgendaMachineThread(father, p_ThreadType)/*,m_RuningBrowserPlayBack(false) */{}

comProtocolAgendaMachineThread::~comProtocolAgendaMachineThread() {}

bool comProtocolAgendaMachineThread::MachineThreadInitialize() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback MachineThreadInitialize");
	comProtocolProcess* pcomProtocolProcess = dynamic_cast<comProtocolProcess*>(&GetProtocolProcess());
	assert(pcomProtocolProcess);

	bool bForceVCInMTA = pcomProtocolProcess->Get_bForceVcInMTA();

  // Special initialize for probing client
  if (m_ProtocolThreadType == THREAD_TYPE_SINGLE_CLIENT){
	  //////////////////////////////////////////////////////////////////////////////////////
	  //
	  // This CoInitialize was added because there is a use of com before the CoInitialize of
	  // each Virtual client.
	  // Generally com mustn't be used in the threads of the load engine. ( except from the
	  // java script ). if other module that inherits the probing client wants to use com in
	  // the call backs it must do it in another thread.
	  //
	  //////////////////////////////////////////////////////////////////////////////////////
	  HRESULT hr = CoInitializeEx(NULL,COINIT_APARTMENTTHREADED);
	  if (hr != S_OK && hr != S_FALSE) {
		  WlTraceMsg("JSCOMObject : Error 0 in function comProtocolAgendaMachineThread::MachineThreadInitialize");
		  WlAssert(0);
	  }
  }

  else if (m_ProtocolThreadType == THREAD_TYPE_VC || m_ProtocolThreadType ==  THREAD_TYPE_JS) {
    if ( bForceVCInMTA || m_ProtocolThreadType ==  THREAD_TYPE_JS ) {
		  HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
		  if(//(hr == -2147417850 ) //cannot cange thread mode after it is set
			   (hr == S_FALSE ) ) {//was already called the function 'CoInitializeEx'
			  //m_RuningBrowserPlayBack = 1;//@@avidan3 temp
				  WlTraceMsg("JSCOMObject : Error 1 in funcrion comProtocolAgendaMachineThread::MachineThreadInitialize");
		  }
	  }
	  else {
		  HRESULT hr = CoInitializeEx(NULL,COINIT_APARTMENTTHREADED);		
		  if(//(hr == -2147417850 ) //cannot cange thread mode after it is set
			   ( hr == S_FALSE ) ) {//was already called the function 'CoInitializeEx'
			  //m_RuningBrowserPlayBack = 1;//@@avidan3 temp
			  WlTraceMsg("JSCOMObject : Error 2 in funcrion comProtocolAgendaMachineThread::MachineThreadInitialize");
		  }
	  }
  }
	return true;
}

bool comProtocolAgendaMachineThread::MachineThreadTermination() {
	WlTraceMsg("JSCOMObject : Called the protocol callback MachineThreadTermination");
	//if(m_RuningBrowserPlayBack == false) {//@@avidan3 temp
	//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT//
//		CoUninitialize();//@@avidan47
	//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT//
	//}
	return true;
}




////////////////////////////////////////////////////////////////
//////////////// class comProtocolVCInMix///////////////////////
////////////////////////////////////////////////////////////////

comProtocolVCInMix::comProtocolVCInMix(iLEProtocolAgendaInMix & father) 
	: iLEProtocolVCInMix(father) {}

comProtocolVCInMix::~comProtocolVCInMix() {}

bool comProtocolVCInMix::JSInitializeForClient(JSContext* cx, JSObject* obj, CLEVariablesData* variables){
	WlTraceMsg("JSCOMObject : Called the protocol callback JSInitializeForScript");	
	return true; 
}

bool comProtocolVCInMix::OnThreadActivation() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback OnThreadActivation");	
	return true; 
}

bool comProtocolVCInMix::BeforeInitClient() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback BeforeInitClient");	
	return true; 
}

bool comProtocolVCInMix::AfterInitClient() { 
	WlTraceMsg("JSCOMObject : Called the protocol callback AfterInitClient");	
	return true; 
}

bool comProtocolVCInMix::BeforeRound() {
//	WlTraceMsg("JSCOMObject : Called the protocol callback BeforeRound");	
	return true;
}
	
bool comProtocolVCInMix::AfterRound() {
//	WlTraceMsg("JSCOMObject : Called the protocol callback AfterRound");	
	return true; 
}

bool comProtocolVCInMix::BeforeTerminateClient() {
	WlTraceMsg("JSCOMObject : Called the protocol callback BeforeTerminateClient");
	return true; 
}

bool comProtocolVCInMix::AfterTerminateClient() {
	WlTraceMsg("JSCOMObject : Called the protocol callback AfterTerminateClient");
	return true; 
}

bool comProtocolVCInMix::OnThreadTermination() {
	WlTraceMsg("JSCOMObject : Called the protocol callback OnThreadTermination");
	return true;
}
