/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
#include <ordered.h>
#include <collstr.h>
#include <collint.h>
#include <collectable.h>
#include "cache.h"


  
CParamterInfo :: CParamterInfo(int type_,bool optional_) : m_Type(type_),m_Optional(optional_){
  }



CMethodInfo :: CMethodInfo(DISPID dispid_,int InvokeType_,int type_return_):
            m_dispid(dispid_),m2_InvokeType(InvokeType_),m_TypeReturn(type_return_){

//  CMethodInfo();
        m_pParamList = new RVOrdered(100);
}

CMethodInfo :: CMethodInfo(DISPID dispid_):
            m_dispid(dispid_){
//   CMethodInfo();
   m_pParamList = new RVOrdered(100);
}

CMethodInfo ::  CMethodInfo(){
    m_pParamList = new RVOrdered(100);
		m_CustomInfo = CI_EMPTY;
}


CMethodInfo :: ~CMethodInfo(){

/*
   RVOrderedIterator sci(*m_pParamList);
   RVCollectable* item;
   CParamterInfo* tmp_param_info;
//   int counter = 0;
//   int type_cache,type_call;

   while ( item = sci() ) {
     tmp_param_info = (CParamterInfo*)item;
     delete(tmp_param_info);
   }
*/
  m_pParamList->clearAndDestroy();

  delete(m_pParamList);     
}

void CMethodInfo ::  SetInvokeType(int InvokeType_){
    m2_InvokeType = InvokeType_;
}

void CMethodInfo ::  SetTypeReturn(int type_return_){ 
    m_TypeReturn  = type_return_;
}

void CMethodInfo ::  SetParamNumber(int param_number_){ 
    m_ParamNumber  = param_number_;
}

void CMethodInfo ::  SetParamNumberMinimum(int param_number_minimum_){ 
    m_ParamNumberMinimum  = param_number_minimum_;
}

void CMethodInfo :: SetCustomInfo(CUSTOM_CACHE_INFO CustomInfo_){
		m_CustomInfo = CustomInfo_;
}



void CMethodInfo :: InsertParam(CParamterInfo* param_){
  
  m_pParamList->insert(param_);
}

void CMethodInfo :: PrintParamTypes(){


   RVOrderedIterator sci(*m_pParamList);
   RVCollectable* item;
   CParamterInfo* tmp_param_info;

   while ( item = sci() ) {
     tmp_param_info = (CParamterInfo*)item;

    cout<<"Type : "<<tmp_param_info->GetType()
        <<" Optional : "<<tmp_param_info->GetOptional()
        <<" Type is Ptr : "<<tmp_param_info->GetTypeIsPointer()<<endl;

   }

/*
  for (unsigned int i = 0; i < ParamList->entries(); i++){

    CParamterInfo* tmp_param_info;
    tmp_param_info = (CParamterInfo*)&ParamList[i];//.find(&temp);

    cout<<"Type : "<<tmp_param_info->GetType()<<" Optional : "
        <<tmp_param_info->GetOptional()<<endl;

    //cout<<ParamList[i];
  }
*/
//  cout<<ParamList->entries();
}

void CParamterInfo :: SetType(int type_){
  m_Type = type_;
}

void CParamterInfo :: SetOptional(bool optional_){
  m_Optional = optional_;
}

void CParamterInfo :: SetTypeIsPointer(bool type_is_pointer_){
  m_TypeIsPointer = type_is_pointer_;
}

CObjectGUID :: CObjectGUID(GUID guid_) : m_guid(guid_){
}

bool CObjectGUID::isEqual(const RVCollectable* c) const{

  const CObjectGUID *obj_guid = (const CObjectGUID*) c;

  if (this->m_guid == obj_guid->m_guid)
    return true;
  else
    return false;

//  const Bus* b = (const Bus*)c;
//  return busNumber_ == b->busNumber_;
}

unsigned CObjectGUID::hash() const
{
  return (unsigned)(m_guid.Data1 + m_guid.Data2 + m_guid.Data3);
}


void CObjectGUID:: PrintInterface(){
}


CVARIANTArrayPointer :: CVARIANTArrayPointer(VARIANT *pVARIANT,int VARIANT_length) :
												m_pVARIANT(pVARIANT),m_VARIANT_length(VARIANT_length){
}

void printKeyAndValue( RVCollectable* ky, RVCollectable* val, void*){
  
  CMethodInfo* method_params_RW;
  RVCollectableString* method_name_RW;

  method_name_RW =  (RVCollectableString*)ky;
  method_params_RW = (CMethodInfo*)val;

	cout<<"Method Name : "<<*method_name_RW
		<<" DISPID : "<<method_params_RW->GetDISPID()
//		<<" Ret Val  : "<<VARENUM_types[method_params_RW->GetTypeReturn()]
		<<" Ret Val  : "<<method_params_RW->GetTypeReturn()
    <<" Is Method : "<<method_params_RW->GetInvokeType()
    <<" P.N. :  "<<method_params_RW->GetParamNumber()
    <<" P.N.Min :  "<<method_params_RW->GetParamNumberMinimum()
    <<endl;
    method_params_RW->PrintParamTypes();

		Sleep(500);

}

void printKeyAndValue1( RVCollectable* ky, RVCollectable* val, void*){

  CObjectGUID *tmp_obj_GUID;

  RVHashDictionary *dictionary_cache_RW;
  
  
//  CMethodInfo* method_params_RW;
//  RVCollectableString* method_name_RW;

  tmp_obj_GUID =  (CObjectGUID*)ky;
  dictionary_cache_RW = (RVHashDictionary*)val;
/*
	cout<<"Method Name : "<<*method_name_RW
		<<" DISPID : "<<method_params_RW->GetDISPID()
		<<" Ret Val  : "<<VARENUM_types[method_params_RW->Get_type_return()]
    <<" Is Method : "<<method_params_RW->Get_is_method()
    <<" P.N. :  "<<method_params_RW->Get_param_number()
    <<endl;
    method_params_RW->PrintParamTypes();
*/

}

