/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// JSCOMObject.cpp : Defines the entry point for the DLL application.
//
#include "stdafx.h"
#include "iJSComPrivateData.h"
#include "HashDictionaries.h"
#include "cache.h"
#include "tracedll.h"
#include "ComObjectClass.h"
#include "comprotocol.h"
#include "wlleprotocol.h"
#include "loadthreadinstance.h"
#include "loadgeneratorscript.h"


extern void C2V_Init();

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			C2V_Init();
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
//		iJSComPrivateData::m_pObjectsCache->clearAndDestroy();
//			delete (iJSComPrivateData::m_pObjectsCache);
		//	CoUninitialize();
			break;
    }
    return TRUE;
}

#ifdef _DEBUG
void iJSComPrivateData :: PrintObjectCreate(JSContext *cx){
  if (piLEProtocolProcess->AmIInThreadLevel(cx))
		{	//not in InitAgenda()

		//Commented for Gil
	//char note_message[1024] = "NNNNew ";
	//sprintf(note_message,"NNNNew %s Round Number : %d",
	//					m_ClassName_RW.data(),getCurrentThreadData(cx)->CurrentScriptRoundNum());
	
	//		if( !getCurrentThreadData(cx)->report( WLLogMessage::Warning, note_message ) ) { // ~~ note??
	//	assert(0);// ~~ cant return
	//	}
			//int round_num = getCurrentThreadData(cx)->CurrentScriptRoundNum();
			//cout<<getCurrentThreadData(cx)->CurrentScriptRoundNum();
		}
		else 
		{
			//in InitAgenda()
		}
}
#endif


iJSComPrivateData::iJSComPrivateData()
{ 
  m_RemoteConnection = false;
  m_TypeInfoExists = false;
	m_pMethodsCache = NULL;
#ifdef _DEBUG
	RoundNumber = 0;
#endif
	
	WlTraceMsg("iJSComPrivateData constuctor");
/*	
	#ifdef _DEBUG
	
		if( !getCurrentThreadData(cx)->reportLogMessageString( WLLogMessage::Note, "New ActiveXObject was created" ) ) {
			assert(0);// ~~ cant return
		}

	#endif		
*/

	//m_ptrIDispatch = (IDispatch *)malloc(sizeof(IDispatch));
	
  //m_pExcepInfo = NULL;


//  m_pMethodsCache = new RVHashDictionary(10);
}

iJSComPrivateData :: ~iJSComPrivateData(){ 


	#ifdef _DEBUG
 // do not use m_ti in the finalizer (called by the GC) {itaj}
/*
		char note_message[1024];
		sprintf(note_message,"RRRR %s Round : %d",
						m_ClassName_RW.data(),RoundNumber);
/*
		if( !m_ti->report( WLLogMessage::Warning, note_message ) ) { // ~~ note??
			assert(0);// ~~ cant return
			}
*/
	#endif


	WlTraceMsg("Before Calling Release COMMM Object");
/*//@@CComPtr
		m_ptrIDispatch->Release();
	*/
	WlTraceMsg("After Calling Release COMMM Object");

}

bool iJSComPrivateData :: Init(const char* ClassName_, WLERRORINFO &m_ErrInfo, char* RemoteComputerName_){

	long ret;
	HRESULT hr;
	USES_CONVERSION;

	m_ClassName_RW = ClassName_;

  if (strcmp(RemoteComputerName_,"")){
    m_RemoteConnection = true;
    m_RemoteComputerName_RW = RemoteComputerName_;

		ret = FindGuid(m_ErrInfo);

    if (ret != 0) {
      WlTraceMsg("iJSComPrivateData :: Init - FindGuid() failed");
			return false;
    }

		SCODE sc = ::CLSIDFromString( T2OLE(m_ClassName_RW.data()), &m_ObjectGUID_UUID ) ;
    if (FAILED(sc))
    {
      WlTraceMsg("iJSComPrivateData :: Init - CLSIDFromString() failed for %s", ClassName_);
			return false;
    }
  }

	//"CLSID:"
	RVCString sClassNameBeginning;
	if (m_ClassName_RW.length() > 5)
	{
		sClassNameBeginning = m_ClassName_RW(0, 6);
	}

	if (sClassNameBeginning.compareTo("CLSID:", RVCString::ignoreCase) == 0)
	{
		RVCString sGUID(m_ClassName_RW(6, m_ClassName_RW.length() - 6));
		sGUID = "{" + sGUID + "}";
		hr = CLSIDFromString(T2OLE(sGUID.data()), &m_ObjectGUID_UUID);
	} else
	{
		hr = CLSIDFromProgID(A2OLE(ClassName_), &m_ObjectGUID_UUID);
	}
	if (FAILED(hr))
	{
		WlTraceMsg("iJSComPrivateData :: Init - CLSIDFromProgID() failed for %s", ClassName_);
		return false;
	}



/*
	ret = FindGuid();

    if (ret != 0) 
		return false;

	SCODE sc = ::CLSIDFromString( T2OLE(m_ClassName_RW.data()), &m_ObjectGUID_UUID ) ;
	if (FAILED(sc))
		return false;
*/

//	if (FAILED(sc))
//	{
//		CString str;
//		str.Format(_T("Could not convert the CLSID of the %s interface viewer."), szInterface);
//		ErrorMessage( str, sc ) ;
//		return ;
//	}

// ret = ConvertGUID();

//    if (ret != 0) 
//		return false;

	ret = CreateObject();

  if (ret != 0)
  {
    WlTraceMsg("iJSComPrivateData :: Init - CreateObject() failed for %s", ClassName_);
		return false;
  }

	return true;

}


#ifdef _DEBUG /**************** Debug function ***************/

int iJSComPrivateData :: InitXMLObject(char* RemoteComputerName_ ){

	HRESULT hr;
  CComPtr<IUnknown> ptrIUnknown;

  if (strcmp(RemoteComputerName_,"")){
    m_RemoteConnection = true;
    m_RemoteComputerName_RW = RemoteComputerName_;
  }

	//hr = CoInitialize(NULL);

const CLSID CLSID_VAPropParamObj = {0x2933BF90,0x7B36,0x11d2,{0xB2,0x0E,0x00,0xC0,0x4F,0x98,0x3E,0x60}};


  if (!m_RemoteConnection){
	  hr = CoCreateInstance(CLSID_VAPropParamObj,NULL,CLSCTX_SERVER,
		  IID_IUnknown, (void**)&ptrIUnknown);

   	if (FAILED(hr))
  		return 1;
  }

  else {

    COSERVERINFO serverinfo;
    COSERVERINFO* pServerInfo;

    serverinfo.dwReserved1 = 0;
    serverinfo.dwReserved2 = 0;

    USES_CONVERSION;
    serverinfo.pwszName = A2OLE(m_RemoteComputerName_RW.data());
    serverinfo.pAuthInfo = NULL;

    pServerInfo = &serverinfo;

    MULTI_QI qi = {&IID_IUnknown, NULL, 0};

    hr = CoCreateInstanceEx(CLSID_VAPropParamObj, NULL,  CLSCTX_REMOTE_SERVER ,
							    pServerInfo, 1, &qi);

    if (FAILED(hr))
	    return 1;

    ptrIUnknown.Attach(qi.pItf);

    if (ptrIUnknown == 0)
      return 1;

  }

//	hr = ptrIUnknown->QueryInterface(IID_IDispatch,(void**)&m_ptrIDispatch);//@@CComPtr
	try {
		m_ptrIDispatch = ptrIUnknown;//@@CComPtr
	}
	catch(_com_error & e) {
		WlTraceMsg ( "Error : exception occured in the function iJSComPrivateData :: InitXMLObject" + e.Description() );//@@avidan add error		
		return 1;
	}


	//if (FAILED(hr))
		//return 1;

	//ptrIUnknown.Release();//@@avidan . change to a comment without testing.

	return 0;

}

#endif /**************** End Debug function ***************/

//
// The Following function was added by Yahali to fix the 
// Invoke type for case of 
// getproperty with parameters .
WORD iJSComPrivateData :: GetInvokeType(const char* PropertyName){
  char* PropertyName_lcase = _strlwr(_strdup(PropertyName));
  RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
  free(PropertyName_lcase);

	if (!m_pMethodsCache)
	{
		return -1;
	}
	//we can be sure, that method_params_RW is not NULL, because
	//we have already checked it by calling CanFindMethodInCache
  CMethodInfo* method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);
  if (method_params_RW)
	{
		return method_params_RW->GetInvokeType();
	} else
	{
		return -1;
	}
}

//FIND WHICH KIND OF INVOKE TYPE : METHOD, PROPERTY OR PROPERTY WITH PARAMETERS.
int iJSComPrivateData :: FindCacheInvokeType(const char* PropertyName){

  char* PropertyName_lcase = _strlwr(_strdup(PropertyName));
  RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
  free(PropertyName_lcase);

	//we can be sure, that method_params_RW is not NULL, because
	//we have already chacked it by calling CanFindMethodInCache
  CMethodInfo* method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);

	//if (strcmp(PropertyName,"Cells") == 0)
	//	return PROPERTY_WITH_PARAMS;

/*
  if (method_params_RW ==0){

//		if (strcmp(PropertyName,"GetCells") == 0)
//			return PROPERTY_WITH_PARAMS;

		m_ErrInfo.m_ErrorIndex = 14;
		m_ErrInfo.m_ErrorDescription = PropertyName;
    return 999;
  }
*/
	int for_my_test = method_params_RW->GetParamNumberMinimum();
	int num_min_params = method_params_RW->GetParamNumber();
	// We currently don't check the optional params

	int t = method_params_RW->GetInvokeType();

	
	switch(t){

		case INVOKE_FUNC :

			return SIMPLE_METHOD;

		case INVOKE_PROPERTYGET :

			if (num_min_params == 0)
				return SIMPLE_PROPERTY;
			else
				return PROPERTY_WITH_PARAMS;	

		case INVOKE_PROPERTYGET  + INVOKE_PROPERTYPUT :
		case INVOKE_PROPERTYGET  + INVOKE_PROPERTYPUTREF:

			if (num_min_params - 1 <= 0)
				return SIMPLE_PROPERTY;
			else
				return PROPERTY_WITH_PARAMS;	
	}

return 1;
//	int num_params =	method_params_RW->GetParamNumber();
}

int iJSComPrivateData :: CanFindMethodInCache(const char* PropertyName){

  char* PropertyName_lcase = _strlwr(_strdup(PropertyName));
  RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
  free(PropertyName_lcase);

  CMethodInfo* method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);

  if (method_params_RW ==0)
		return 0;
	else
		return 1;

}

//TI EXISTS. NO NEED TO CALL Call_GetIDofName()
int iJSComPrivateData :: FindInvokeDISPID(const char* PropertyName,DISPID* dispid){

  char* PropertyName_lcase = _strlwr(_strdup(PropertyName));

  RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
  free(PropertyName_lcase);

  CMethodInfo* method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);

  if (method_params_RW ==0){
    return 1;
  }

  //finds dispid in cache - there is no need to call GetIdOfNames now
  *dispid = method_params_RW->GetDISPID();
	return 0;
}

//TI EXISTS. NO NEED TO CALL Call_GetIDofName()
CMethodInfo* iJSComPrivateData :: FindMethodInfo(const char* PropertyName){

  char* PropertyName_lcase = _strlwr(_strdup(PropertyName));

  RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
  free(PropertyName_lcase);

  CMethodInfo* method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);

	return method_params_RW;
}


int iJSComPrivateData :: Call_GetIDsOfNames(const char* MethodName_,WLERRORINFO &m_ErrInfo, DISPID *dispid_){


	//char temp_char[128];
	//strcpy(temp_char,MethodName_);
	USES_CONVERSION;
	LPOLESTR method_name = A2OLE(MethodName_);
	//LPOLESTR method_name = A2OLE(temp_char);

	try {
		m_ErrInfo.m_hrLastError = m_ptrIDispatch->GetIDsOfNames(IID_NULL,&method_name,1,GetUserDefaultLCID(),
								dispid_);
	}
	catch( _com_error & e ) {
		WlTraceMsg("Error : exception occured in the function iJSComPrivateData :: Call_GetIDsOfNames" + e.Description() );//@@avidan add error
	}

	if (FAILED(m_ErrInfo.m_hrLastError))
		return 1;

	return 0;
	
}





JSObject* CreateJSObject( iJSComPrivateData* pJSComPrivateData, JSContext* cx) {//@@ for FTPlayBack
	JSObject *js_Object = JS_NewObject(cx, &ComObjectClass, NULL, NULL);
	JS_SetPrivate(cx, js_Object, pJSComPrivateData);
	return js_Object;
}
