/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _wlxmlprivate_h_
#define _wlxmlprivate_h_

#include "rvjsapi.h"
#include "platform.h"


class CWLXmlParserPrivate {
private:
  void*	m_CPP_RealObject;	// pointer to the real C++ object or wrapper
  bool  m_bDelete;

public:
  enum eClass{NULL_OBJECT,
              PARSER_OBJECT,
              DOCUMENT, 
              DOCUMENT_FRAGMENT,
              NODE, 
              NODELIST, 
              NAMEDNODEMAP, 
              CHARACTERDATA, 
              ATTRIBUTE, 
              ELEMENT, 
              TEXT, 
              COMMENT, 
              CDATA_SECTION, 
              DOCUMENT_TYPE, 
              NOTATION, 
              ENTITY,
              ENTITY_REFERENCE,
              PROCESSING_INSTRUCTION};

  eClass m_eClass;

  CWLXmlParserPrivate(void* pRealObject, eClass eClass, bool bDelete);
	~CWLXmlParserPrivate();
	void*	 GetCPPObj();
  void setToDelete(bool bDelete);

  static void setPrivateToDelete(JSContext *p_pCX, JSObject *p_pObj, bool toDelete);
  static void* GetThisObject(JSContext *p_pCX, JSObject *p_pObj);
  static  CWLXmlParserPrivate::eClass GetObjectEClass(JSContext *p_pCX, JSObject *p_pObj);
  static DllExport const char* GetObjectEClassStr(JSContext *p_pCX, JSObject *p_pObj);

private:
  //CWLXmlParserPrivate& CWLXmlParserPrivate(CWLXmlParserPrivate& src){return &this;}
  //CWLXmlParserPrivate& operator=(CWLXmlParserPrivate& src){return &this;}

};


#endif//_wlxmlprivate_h_
