/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "tracedll.h"
#include "wlerrorlib.h"
#include "loadexceptions.h"
#include "loadreportinfo.h"
#include "wlxmlfuncs.h"
#include "wlxmlprivate.h"
#include <xercesc/dom/DOMDocumentType.hpp>

XERCES_CPP_NAMESPACE_USE

#define CLASSNAME DOMDocumentType
DEFAULT_GET_THIS_OBJECT(documenttype);

JSBool WLXMLDocumentTypeEnumerate(JSContext *cx, JSObject *obj );


static JSClass wl_XMLDocumentTypeClass = {
	"XMLDocumentTypeObject",
	JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	WLXMLDocumentTypeEnumerate,//JS_EnumerateStub
	JS_ResolveStub,
	JS_ConvertStub,
	WLXmlGenericFinalize
};




JSBool WLXMLDocumentTypeEnumerate(JSContext *cx, JSObject *obj )
{
  //enumerate class is implemented for: (for a in xmlparse), it can be implemented later.
  DOMDocumentType* pObj = documenttype_GetThisObject(cx, obj);
  
  if (pObj==NULL)
    return JS_TRUE;;

	return JS_TRUE;
}

METHOD_RET_XMLCHAR_NO_ARGS(documenttype, getName);
METHOD_RET_XMLCHAR_NO_ARGS(documenttype, getPublicId);
METHOD_RET_XMLCHAR_NO_ARGS(documenttype, getSystemId);
METHOD_RET_XMLCHAR_NO_ARGS(documenttype, getInternalSubset);
METHOD_RET_OBJECT_NO_ARGS(documenttype, getEntities, NamedNodeMap, false);
METHOD_RET_OBJECT_NO_ARGS(documenttype, getNotations, NamedNodeMap, false);


static JSFunctionSpec xmlDocumentType_methods[] = {
  {"getName",   documenttype_getName, 0},
  {"getPublicId",   documenttype_getPublicId, 0},
  {"getSystemId",   documenttype_getSystemId, 0},
  {"getInternalSubset",   documenttype_getInternalSubset, 0},
  {"getEntities",   documenttype_getEntities, 0},
  {"getNotations",   documenttype_getNotations, 0},
	{0}
};


static JSPropertySpec xmlDocumentType_properties[] = {
	{0}
};



//create new DocumentType object
jsval WLCreateDocumentTypeObject(JSContext* cx, JSObject* obj, void* value, bool toDelete)
{
  if (!value)
    return JSVAL_NULL;

  CJSGCRequestBeginEnd GCGuard(cx); //lock GC for this action
	CWLXmlParserPrivate* prv = new CWLXmlParserPrivate((void*)value, CWLXmlParserPrivate::DOCUMENT_TYPE, toDelete);
  JSObject* newObj = JS_NewObject(cx, &wl_XMLDocumentTypeClass, NULL, NULL);
	JS_SetPrivate(cx, newObj, (void*)prv);
  return OBJECT_TO_JSVAL(newObj);
}

//when we'll define all classes
JSObject* rvAddXMLDocumentTypeClass(JSContext *cx, JSObject *obj, JSObject* parent_proto)
{
  return JS_InitClass(cx, obj, parent_proto, &wl_XMLDocumentTypeClass, NULL, 0, xmlDocumentType_properties, xmlDocumentType_methods, NULL, NULL);
}


